#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define sp(n) fixed << setprecision(n)
#define _  << " " <<
#define pb push_back
#define ff first
#define ss second

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

struct qitem {
    int maxv, minv, len, parent;
};

int n, m;
vector<vector<pii> > g;

void bfs(vector<qitem>& v, int start, bool is_max) {
    for (int i = 1; i <= n; i++) {
        v[i].len = -1;
        v[i].parent = -1;
        v[i].minv = INT_MAX;
        v[i].maxv = INT_MIN;
    }

    queue<int> q;

    q.push(start);
    v[start].len = 0;

    while (!q.empty()) {
        int from = q.front(); q.pop();

        for (auto i: g[from]) {
            int to = i.ff;
            if (to == v[from].parent) {
                continue;
            }

            int len = v[from].len + 1;
            int minv = min(v[from].minv, i.ss);
            int maxv = max(v[from].maxv, i.ss);

            if (v[to].parent == -1) {
                v[to].len = len;
                v[to].parent = from;
                v[to].minv = minv;
                v[to].maxv = maxv;
                q.push(to);
            }
            else if (v[to].len == len && (is_max && maxv > v[to].maxv || !is_max && minv < v[to].minv)) {
                v[to].parent = from;
                v[to].minv = minv;
                v[to].maxv = maxv;
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << sp(10);

#ifdef LOCAL_DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif

    cin >> n >> m;

    g.resize(n + 1);

    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;

        g[u].pb({ v, c });
        g[v].pb({ u, c });
    }

    vector<qitem> from_start_max(n + 1), from_start_min(n + 1), from_finish_max(n + 1), from_finish_min(n + 1);

    bfs(from_start_max, 1, true);
    bfs(from_start_min, 1, false);
    bfs(from_finish_max, n, true);
    bfs(from_finish_min, n, false);

    int shortest_len = from_start_max[n].len;

    int best_d = from_start_max[n].maxv - from_start_max[n].minv;
    int x = n, start_i = n, finish_i = -1;
    vector<qitem>& start_v = from_start_max;
    vector<qitem>& finish_v = from_finish_min;

    int cur_d;

    cur_d = from_start_min[n].maxv - from_start_min[n].minv;
    if (cur_d > best_d) {
        best_d = cur_d;
        x = n;
        start_i = n;
        finish_i = -1;
        start_v = from_start_min;
        finish_v = from_finish_max;
    }

    cur_d = from_finish_min[1].maxv - from_finish_min[1].minv;
    if (cur_d > best_d) {
        best_d = cur_d;
        x = 1;
        start_i = -1;
        finish_i = 1;
        start_v = from_start_max;
        finish_v = from_finish_min;
    }

    cur_d = from_finish_max[1].maxv - from_finish_max[1].minv;
    if (cur_d > best_d) {
        best_d = cur_d;
        x = 1;
        start_i = -1;
        finish_i = 1;
        start_v = from_start_min;
        finish_v = from_finish_max;
    }

    for (int v = 2; v <= n - 1; v++) {
        if (from_finish_max[v].len + from_start_max[v].len > shortest_len) {
            continue;
        }

        for (int i = 0; i < g[v].size(); i++) {
            for (int j = i + 1; j < g[v].size(); j++) {
                int ii = g[v][i].ff, jj = g[v][j].ff;

                if (from_start_max[ii].len + from_finish_max[jj].len + 2 == shortest_len) {
                    cur_d = max(from_finish_max[jj].maxv, g[v][j].ss) - min(from_start_min[ii].minv, g[v][i].ss);
                    if (cur_d > best_d) {
                        best_d = cur_d;
                        x = v;
                        start_i = ii;
                        finish_i = jj;
                        start_v = from_start_min;
                        finish_v = from_finish_max;
                    }

                    cur_d = max(from_start_max[ii].maxv, g[v][i].ss) - min(from_finish_min[jj].minv, g[v][j].ss);
                    if (cur_d > best_d) {
                        best_d = cur_d;
                        x = v;
                        start_i = ii;
                        finish_i = jj;
                        start_v = from_start_max;
                        finish_v = from_finish_min;
                    }
                }
                else if (from_start_max[jj].len + from_finish_max[ii].len + 2 == shortest_len) {
                    cur_d = max(from_finish_max[ii].maxv, g[v][i].ss) - min(from_start_min[jj].minv, g[v][j].ss);
                    if (cur_d > best_d) {
                        best_d = cur_d;
                        x = v;
                        start_i = jj;
                        finish_i = ii;
                        start_v = from_start_min;
                        finish_v = from_finish_max;
                    }

                    cur_d = max(from_start_max[jj].maxv, g[v][j].ss) - min(from_finish_min[ii].minv, g[v][i].ss);
                    if (cur_d > best_d) {
                        best_d = cur_d;
                        x = v;
                        start_i = jj;
                        finish_i = ii;
                        start_v = from_start_max;
                        finish_v = from_finish_min;
                    }
                }
            }
        }
    }

    string start_path = "", finish_path = "";
    int cur;

    cur = start_i;
    while (cur != -1) {
        start_path += " " + to_string(cur);
        cur = start_v[cur].parent;
    }
    reverse(all(start_path));

    cur = finish_i;
    while (cur != -1) {
        finish_path += to_string(cur) + " ";
        cur = finish_v[cur].parent;
    }
    reverse(all(finish_path));

    string ans = start_path + to_string(x) + finish_path;

    cout << shortest_len << endl;
    cout << ans << endl;

#ifdef LOCAL_DEBUG
    cerr << "Execution time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s.\n";
#endif

    return 0;
}