#include <iostream>
#include <vector>
#include <stdio.h>
#include <algorithm>
#include <iomanip>
#include <math.h>
#include <string>
#include <utility>
#include <map>
#include <string.h>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <list>
#include <fstream>
#include <sstream>
#include <stack>
#include <mutex>
#include <queue>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const ll inf = 2e10;

struct bfs_str {
	ll prev;
	ll node;
	ll len;
	ll w;
};

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	ll nodes, edges;
	cin >> nodes >> edges;

	vector<ll> min_path(nodes, inf);
	vector<pair<ll, ll>> diff(nodes, pair<ll, ll>{inf, -inf});
	vector<vector<pair<ll, ll>>> aj_list(nodes);

	for (ll i = 0; i < edges; i++) {
		ll a, b, w;
		cin >> a >> b >> w;
		a--; b--;
		aj_list[a].push_back(make_pair(b, w));
		aj_list[b].push_back(make_pair(a, w));
	}

	min_path[0] = 0;

	queue<bfs_str> q;

	vector<vector<ll>> way(nodes);

	for (ll i = 0; i < aj_list[0].size(); i++) {
		bfs_str cur;
		cur.len = 1;
		cur.prev = 0;
		cur.node = aj_list[0][i].first;
		cur.w = aj_list[0][i].second;

		diff[cur.node].first = cur.w;
		diff[cur.node].second = cur.w;

		way[cur.node] = vector<ll>{0};
		q.push(cur);
	}

	while (q.size()) {

		bfs_str cur = q.front();
		q.pop();

		if (cur.len > min_path[cur.node])
			continue;
		else
			min_path[cur.node] = cur.len;

		if (diff[cur.node].first == inf || max(cur.w, diff[cur.prev].second) - min(cur.w, diff[cur.prev].first) 
			> diff[cur.node].second - diff[cur.node].first) {

			diff[cur.node].first = min(cur.w, diff[cur.prev].first);
			diff[cur.node].second = max(cur.w, diff[cur.prev].second);
			
			way[cur.node] = way[cur.prev];
			way[cur.node].push_back(cur.prev);
		}

		for (const pair<ll, ll>& p : aj_list[cur.node]) {
			bfs_str s;
			s.prev = cur.node;
			s.node = p.first;
			s.len = cur.len + 1;
			s.w = p.second;
			q.push(s);
		}
	}

	cout << way[nodes - 1].size() << endl;
	for (ll i : way[nodes - 1])
		cout << i + 1 << ' ';
	cout << nodes << endl;

	return 0;
}