#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

const int MOD = 998244353;

long long binpow(long long a, long long p){
	return p?binpow(a*a%MOD, p>>1)*(p&1?a:1)%MOD:1;
}

long long bininv(long long a){
	return binpow(a, MOD-2);
}

vector<vector<vector<long long> > > dp; // contestant -> problem -> minute -> num cases (contestant solved problem at minute) 
vector<long long> fct;

int cnt[302][30];
 
void calc(int ind, vector<int> &a, int k, int c) {
  vector < pair<int, int> > mas;
  for (int i = 0; i < (int)a.size(); i++) {
    if (a[i] != 0) {
      mas.push_back(make_pair(a[i], i));
    }
  }
 
  for (int i = 0; i < (int)mas.size(); i++) {
    int first = mas[i].second;
 
    cnt[0][0] = 1;
 
    int qan = 0;
    for (int j = 0; j < (int)mas.size(); j++) {
      if (j == i) continue;
      ++qan;
      for (int h = qan; h > 0; h--) {
        for (int sum = k - mas[j].first; sum >= 0; sum--) {
          cnt[sum + mas[j].first][h] += cnt[sum][h - 1];
          cnt[sum + mas[j].first][h] %= MOD;
        }
      }
    }
 
    for (int j = 0; j <= k; j++) {
      for (int h = 0; h <= qan; h++) {
        if (j + mas[i].first <= k) {
          dp[ind][first][j + mas[i].first] += cnt[j][h] * 1ll * fct[c - h - 1] % MOD;
          dp[ind][first][j + mas[i].first] %= MOD; 
        }
        cnt[j][h] = 0;
      }
    }
  }
}

void solve(int test_ind){
	int n, m, k;
	cin >> n >> m >> k;

	vector<long long> idenom(n);

	fct = vector<long long>(27, 1);
	for (long long i=1;i<=26;++i){
		fct[i] = fct[i-1] * i % MOD;
	}

	vector<vector<int> > a(n, vector<int>(m));
	dp = vector<vector<vector<long long> > >(n, vector<vector<long long> >(m, vector<long long>(k+1, 0)));
	for (int i=0;i<n;++i){
		int c = 0;
		for (int j=0;j<m;++j){
			cin >> a[i][j];
			if (a[i][j] != 0) ++c;
		}
		idenom[i] = bininv(fct[c]);
		calc(i, a[i], k, c);
	}

	for (int i=0;i<n;++i){
		for (int j=0;j<m;++j){
			for (int l=1;l<=k;++l){
				// cout << i << " " << j << " " << l << " " << dp[i][j][l] << endl;
				(dp[i][j][l] += dp[i][j][l-1]) %= MOD;
			}
		}
	}
	// dp -> dp pref sum

	vector<vector<long long> > unsolved(m, vector<long long>(k+1, 0));
	for (int prob=0;prob<m;++prob){
		for (int j=0;j<=k;++j){
			long long p = 1;
			for (int i=0;i<n;++i){
				if (a[i][prob] == 0) continue;
				(p *= 1 + MOD - dp[i][prob][j] * idenom[i] % MOD) %= MOD;
			}
			unsolved[prob][j] = p;
		}
	}

	vector<long long> ans(n, 0);

	for (int i=0;i<n;++i){
		for (int j=0;j<m;++j){
			for (int l=1;l<=k;++l){
				long long d = (dp[i][j][l] - dp[i][j][l-1] + MOD) % MOD * idenom[i] % MOD;
				if (d > 0) (ans[i] += d * unsolved[j][l - 1] % MOD * bininv(1 + MOD - dp[i][j][l-1] * idenom[i] % MOD) % MOD) %= MOD;
			}
		}
	}

	for (long long p: ans){
		cout << p << endl;
	}
}

int main(){
	int t=1;
	//cin >> t;
	for(int i=0;i<t;i++){
		solve(i);
	}
	return 0;
}
