#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//-----------------------------------------------
#define LOG
#ifdef LOG
  #define db(x)     cerr << #x << ": " << x << endl;
  #define dbA(x, s) cerr << #x << ": "; for (int i = 0; i < s; i++) cerr << x[i] << " "; cerr << endl;
#else
  #define db(x)
  #define dbA(x, s)
#endif
//-----------------------------------------------
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
//-----------------------------------------------
template<class K, class V> ostream& operator << (ostream& out, const pair<K, V>& obj) { out << "{ " << obj.first << ", " << obj.second << " }"; return out; }
template<class T> ostream& operator << (ostream& out, const vector<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const deque<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const unordered_set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class T> ostream& operator << (ostream& out, const ordered_set<T>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class K, class V> ostream& operator << (ostream& out, const map<K, V>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
template<class K, class V> ostream& operator << (ostream& out, const unordered_map<K, V>& obj) { out << "{ "; for (auto& elem : obj) out << elem << " "; out << "}"; return out; }
//-----------------------------------------------
#define all(x)  x.begin(), x.end()
#define sz(x)   (int)x.size()
#define sq(x)   (x) * (x)
#define fr      first
#define sc      second
#define newline puts("")
//-----------------------------------------------
using ll128 = __int128_t;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<ll, int>;
//-----------------------------------------------
const int N   = 10 * 1000 * 1000 + 5;
const ll mod  = 1000000007;
const ll mod3 = 998244353;
const ll INFL = 2000000000 * 1ll * 1000000000 + 500000;
const ll INF  = 1000000000;
// const ld pi   = acosl(-1.0);
//-----------------------------------------------

vector<string> grid;
int n, m, ansf, ansq;

void input() {
  cin >> n >> m;
  grid.resize(n);
  for (int i = 0; i < n; i++) {
    cin >> grid[i];
  }
}

void clear_q(int i, int j) {
  ansq++;
  grid[i][j] = grid[i][j + 1] = grid[i][j + 2] = '.';
  grid[i + 1][j] = grid[i + 1][j + 2] = '.';
  grid[i + 2][j] = grid[i + 2][j + 1] = grid[i + 2][j + 2] = '.';
  grid[i + 3][j + 2] = grid[i + 4][j + 2] = '.';
}

void clear_f(int i, int j) {
  ansf++;
  grid[i][j] = grid[i][j + 1] = grid[i][j + 2] = '.';
  grid[i + 1][j] = '.';
  grid[i + 2][j] = grid[i + 2][j + 1] = '.';
  grid[i + 3][j] = grid[i + 4][j] = '.';
}

void solve(int test_id) {
  for (int j = 0; j < m; j++) {
    for (int i = 0; i < n; i++) {
      if (grid[i][j] == '#') {
        int k = i;
        while (k < n && grid[k][j] == '#') {
          k++;
        }

        int cnt = k - i;
        if (cnt % 5 == 3) {
          for (int fi = i; fi < i + cnt - 5; fi += 5) {
            clear_f(fi, j);
          }
          clear_q(i + cnt / 5 * 5, j);
        } else {
          for (int fi = i; fi < i + cnt; fi += 5) {
            clear_f(fi, j);
          }
        }
      }
    }
  }

  cout << ansq << " " << ansf << endl;
}

int main() {
  int testcases = 1;
  // scanf("%d", &testcases);
  for(int test_id = 1; test_id <= testcases; test_id++) {
    input();
    solve(test_id);
  }
  return 0;
}