//  Copyright 2021 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  using ld = long double;

  int n;
  ld L, V;
  cin >> n >> L >> V;
  vector<ld> a(n);
  for (auto& x : a) cin >> x;
  reverse(a.begin(), a.end());

  vector<ld> suffix(n + 1);
  vector<ld> suffix2(n + 1);
  for (int i = n - 1; i >= 0; --i) {
    suffix[i] = suffix[i + 1] + ld(1) / (V + a[i]);
    suffix2[i] = suffix2[i + 1] + ld(a[i]) / (V + a[i]);
  }

  ld ans = 1e30;
  ld t = 0;
  for (int wait = 0; wait <= n; ++wait) {
    ld curt = (wait == 0 ? ld(0) : L / a[wait - 1]);
    smin(ans, t + 2 * L * suffix[wait] - 2 * curt * suffix2[wait] + curt * (n - wait));

    if (wait != n) {
      t += L / ld(a[wait]);
    } 
  }
  cout << setprecision(20) << fixed << ans / n << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
