// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <stdio.h>
#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238;
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int N = 310;

int n, m;
char a[N][N];

void removeF(int i, int j) {
	a[i][j] = '.';
	a[i + 1][j] = '.';
	a[i + 2][j] = '.';
	a[i + 3][j] = '.';
	a[i + 4][j] = '.';
	a[i][j + 1] = '.';
	a[i][j + 2] = '.';
	a[i + 2][j + 1] = '.';

	// for (int i = 0; i < n; ++i) {
	// 	printf("%s\n", a[i]);
	// }
}

void removeQ(int i, int j) {
	a[i][j] = '.';
	a[i + 1][j] = '.';
	a[i + 2][j] = '.';
	a[i + 2][j + 1] = '.';
	a[i + 2][j + 2] = '.';
	a[i + 1][j + 2] = '.';
	a[i][j + 2] = '.';
	a[i][j + 1] = '.';
	a[i + 3][j + 2] = '.';
	a[i + 4][j + 2] = '.';

	// for (int i = 0; i < n; ++i) {
	// 	printf("%s\n", a[i]);
	// }
}

void run() {
    scanf("%d%d", &n, &m);

    for (int i = 0; i < n; ++i) {
    	scanf("\n%s", a[i]);
    }

    int cntF = 0, cntQ = 0;
    for (int j = 0; j < m; ++j) {
    	for (int i = 0; i < n; ++i) {
    		if (a[i][j] == '.') {
    			continue;
    		}

    		int cnt = 0;
    		for (int k = i; k < std::min(n, i + 5); ++k) {
    			if (a[k][j] == '#') {
    				++cnt;
    			} else {
    				break;
    			}
    		}

    		if (cnt == 0) {
    			continue;
    		}

    		// debug(cnt);

    		if (cnt == 5) {
    			++cntF;
    			removeF(i, j);
    		} else {
    			++cntQ;
    			removeQ(i, j);
    		}
    	}
    }

    for (int i = 0; i < n; ++i) {
    	for (int j = 0; j < m; ++j) {
    		assert(a[i][j] == '.');
    	}
    }

    printf("%d %d\n", cntQ, cntF);
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    auto start = std::chrono::high_resolution_clock::now();
    run();
    auto end = std::chrono::high_resolution_clock::now();

    #ifdef PERVEEVM_LOCAL
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
