//  Copyright 2021 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int t; cin >> t;
  map<string, int> mp;
  auto getid = [&](string const& s) {
    if (mp.find(s) == mp.end()) {
      mp[s] = int(mp.size());
    }
    return mp[s];
  };
  vector<vector<pair<int, int>>> queries(t);
  for (int i = 0; i < t; ++i) {
    int k; cin >> k;
    while (k--) {
      string s; cin >> s;
      int p = s.find('=');
      string L = s.substr(0, p);
      string R = s.substr(p + 1);
      queries[i].emplace_back(getid(L), atoi(R.c_str()));
    }
  }
  int nvars = int(mp.size());
  {
    int shit; cin >> shit; assert(shit == nvars);
  }
  vector<int> value(nvars);
  for (int i = 0; i < nvars; ++i) {
    string s; int val; cin >> s >> val; value[getid(s)] = val;
  }

  vector<int> ans;
  vector<int> ptr(t);
  for (int i = 0; i < t; ++i) {
    ptr[i] = int(queries[i].size()) - 1;
  }
  while (true) {
    int canset = -1;
    int canadd = -1;
    bool haveany = false;
    for (int i = 0; i < t; ++i) {
      if (ptr[i] < 0) {
        continue;
      }
      haveany = true;
      auto[id, val] = queries[i][ptr[i]];
      if (value[id] < 0) {
        canadd = i;
        break;
      }
      if (value[id] == val) {
        canset = i;
        break;
      }
    }
    if (!haveany) {
      break;
    }
    if (canset >= 0) {
      ans.push_back(canset);
      auto[id, val] = queries[canset][ptr[canset]];
      value[id] = -1;
      --ptr[canset];
      continue;
    }
    if (canadd >= 0) {
      ans.push_back(canadd);
      --ptr[canadd];
      continue;
    }
    cout << "No\n";
    return 0;
  }
  cout << "Yes\n";
  reverse(ans.begin(), ans.end());
  for (int i : ans) cout << i + 1 << ' ';
  cout << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
