// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <stdio.h>
#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl
#else
    #define debug(x) 238;
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int N = 300100;

int a[N], b[N];

class Cmp {
public:
	bool operator()(const std::pair<int, int>& p1, const std::pair<int, int>& p2) const {
		return p1.first < p2.first || (p1.first == p2.first && a[p1.second] + b[p1.second] < a[p2.second] + b[p2.second]) || (p1.first == p2.first && a[p1.second] + b[p1.second] == a[p2.second] + b[p2.second] && p1.second < p2.second);
	}
};

void solve() {
	int n;
	scanf("%d", &n);

	for (int i = 0; i < n; ++i) {
		scanf("%d%d", &a[i], &b[i]);
	}

	std::set<std::pair<int, int>> setik;
	std::set<std::pair<int, int>, Cmp> setikA, setikB;
	for (int i = 0; i < n; ++i) {
		setik.insert(std::make_pair(a[i] + b[i], i));
		setikA.insert(std::make_pair(a[i], i));
		setikB.insert(std::make_pair(b[i], i));
	}

	assert((int)setik.size() == n);
	assert((int)setikA.size() == n);
	assert((int)setikB.size() == n);

	std::vector<std::pair<std::pair<int, int>, char>> ans;
	while (!setik.empty()) {
		int v = setik.begin()->second;
		setik.erase(setik.begin());
		setikA.erase(std::make_pair(a[v], v));
		setikB.erase(std::make_pair(b[v], v));

		if (a[v] + b[v] == 0) {
			continue;
		}

		if (a[v] + b[v] != 1) {
			printf("No\n");
			return;
		}

		if (a[v] == 1) {
			if (setikA.empty()) {
				printf("No\n");
				return;
			}
			auto best = *setikA.rbegin();
			if (a[best.second] == 0) {
				printf("No\n");
				return;
			}

			ans.push_back(std::make_pair(std::make_pair(v, best.second), 'W'));

			setik.erase(std::make_pair(a[best.second] + b[best.second], best.second));
			setikA.erase(std::make_pair(a[best.second], best.second));
			setikB.erase(std::make_pair(b[best.second], best.second));
			--a[best.second];
			--a[v];
			setik.insert(std::make_pair(a[best.second] + b[best.second], best.second));
			setikA.insert(std::make_pair(a[best.second], best.second));
			setikB.insert(std::make_pair(b[best.second], best.second));
		} else {
			if (setikB.empty()) {
				printf("No\n");
				return;
			}
			auto best = *setikB.rbegin();
			if (b[best.second] == 0) {
				printf("No\n");
				return;
			}

			ans.push_back(std::make_pair(std::make_pair(v, best.second), 'B'));

			setik.erase(std::make_pair(a[best.second] + b[best.second], best.second));
			setikA.erase(std::make_pair(a[best.second], best.second));
			setikB.erase(std::make_pair(b[best.second], best.second));
			--b[best.second];
			--b[v];
			setik.insert(std::make_pair(a[best.second] + b[best.second], best.second));
			setikA.insert(std::make_pair(a[best.second], best.second));
			setikB.insert(std::make_pair(b[best.second], best.second));
		}
	}

	if ((int)ans.size() != n - 1) {
		printf("No\n");
		return;
	}
	for (int i = 0; i < n; ++i) {
		if (a[i] != 0 || b[i] != 0) {
			printf("No\n");
			return;
		}
	}

	printf("Yes\n");
	for (auto[edge, color] : ans) {
		auto[from, to] = edge;
		printf("%d %d %c\n", from + 1, to + 1, color);
	}
}

void run() {
	int t;
	scanf("%d", &t);

	while (t--) {
		solve();
	}    
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    auto start = std::chrono::high_resolution_clock::now();
    run();
    auto end = std::chrono::high_resolution_clock::now();

    #ifdef PERVEEVM_LOCAL
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
