#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <stack>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <cstddef>
#include <cstring>
#include <bitset>
#include <random>
#include <memory>
#include <iomanip>

typedef long long ll;
typedef long double ld;

using namespace std;

const int MX = 3e5 + 7;
int g[MX][26];
int N = 1;
int am[MX];

void add(const string& s) {
    int now = 0;
    for (char c : s) {
        if (g[now][c - 'a'] == 0) {
            g[now][c - 'a'] = N++;
        }
        now = g[now][c - 'a'];
    }
    am[now]++;
}

int n, k;

pair<int, int> dfs(int v) {
    vector<pair<int, int>> some = {{0, am[v]}};
    for (int i = 0; i < 26; i++) {
        if (g[v][i]) {
            pair<int, int> res = dfs(g[v][i]);
            some.push_back(res);
        }
    }

    sort(some.begin(), some.end(), [](const pair<int, int>& a, const pair<int, int>& b)
            { return a.second < b.second; });

    int am = 0;
    int A = 0;
    for (int i = 0; i < (int)some.size(); i++) {
        am += some[i].first;
        A += some[i].second;
    }

    while (A > k) {
        am++;
        A -= some.back().second;
        some.pop_back();
    }

    return {am, A};
}

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);

    cin >> n >> k;
    vector<string> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (const string& s : a) add(s);

    pair<int, int> res = dfs(0);
    cout << res.first + 1 << '\n';


    return 0;
}
