#include <algorithm>
#include <bits/stdc++.h>
#include <random>

using namespace std;
typedef long long ll;
typedef long double ld;

#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define forrn(i, s, n) for (int i = (int)(s); i < (int)(n); i++)
#define PYMOD(a, m) ((((a) % (m)) + (m)) % (m))
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define mp make_pair
#define ff first
#define ss second

struct SM {
    struct op {
        optional<int> c;
        optional<string> v;
        optional<char> f;
    };

    vector<op> ops;

    optional<int> eval(int x, int y) const {
        vector<ll> stack;
        for (auto z : ops) {
            if (z.c.has_value()) {
                stack.push_back(z.c.value());
            } else if (z.v.has_value()) {
                if (z.v.value() == "x") {
                    stack.push_back(x);
                } else {
                    stack.push_back(y);
                }
            } else {
                if (stack.size() < 2) {
                    return {};
                }
                ll b = stack[stack.size() - 1];
                ll a = stack[stack.size() - 2];
                stack.resize(stack.size() - 2);
                ll c;
                switch (z.f.value()) {
                case '+':
                    c = a + b;
                    break;
                case '-':
                    c = a - b;
                    break;
                case '*':
                    c = a * b;
                    break;
                case '^':
                    c = 1;
                    if (b < 0) {
                        return {};
                    }
                    for (int i = 0; i < b; i++) {
                        c *= a;
                        if (c > numeric_limits<int>::max() ||
                            c < numeric_limits<int>::min()) {
                            return {};
                        }
                    }
                }
                if (c > numeric_limits<int>::max() ||
                    c < numeric_limits<int>::min()) {
                    return {};
                }
                stack.push_back(c);
            }
        }
        if (stack.size() != 1) {
            return {};
        }
        return stack[0];
    }
};

ostream &operator<<(ostream &os, const SM::op &o) {
    if (o.c.has_value()) {
        return os << *o.c;
    }
    if (o.v.has_value()) {
        return os << *o.v;
    }
    return os << *o.f;
}

ostream &operator<<(ostream &os, const SM &s) {
    for (const auto &o : s.ops) {
        os << o << " ";
    }
    return os;
}

SM gen() {
    static mt19937 rnd(179);

    auto gen_op = [&]() {
        uniform_int_distribution<> tdist(1, 3);
        int type = tdist(rnd);
        if (type == 1) {
            uniform_int_distribution<> cdist(-9, 9);
            int c = cdist(rnd);
            return SM::op{{c}, {}, {}};
        } else if (type == 2) {
            uniform_int_distribution<> xdist(1, 2);
            int x = xdist(rnd);
            if (x % 2 == 0) {
                return SM::op{{}, {"x"}, {}};
            } else {
                return SM::op{{}, {"y"}, {}};
            }
        } else {
            vector<char> ops = {'+', '-', '*', '^'};
            uniform_int_distribution<> opdist(0, 3);
            return SM::op{{}, {}, {ops[opdist(rnd)]}};
        }
    };

    uniform_int_distribution<> ndist(1, 10);
    int n = ndist(rnd);
    vector<SM::op> ops(n);
    for (int i = 0; i < n; i++) {
        ops[i] = gen_op();
    }
    return SM{ops};
}

struct props {
    bool correct, lmax, lmin, pl;

    int get_mask() { return ((int)lmax << 2) | ((int)lmin << 1) | ((int)pl); }
};

props getProps(const SM &sm) {
    vector<vector<int>> vals(21, vector<int>(21));
    for (int x = 0; x < 21; x++) {
        for (int y = 0; y < 21; y++) {
            auto z = sm.eval(x - 10, y - 10);
            if (!z.has_value()) {
                return {false, false, false, false};
            }
            vals[x][y] = *z;
        }
    }
    props ret{true, false, false, false};
    int lmxs = 0;
    int lmns = 0;
    for (int i = 0; i < 21; i++) {
        for (int j = 0; j < 21; j++) {
            int dx[4] = {-1, 1, 0, 0};
            int dy[4] = {0, 0, -1, 1};
            bool ismx = true, ismn = true, ispl = false;
            for (int k = 0; k < 4; k++) {
                int ni = i + dx[k], nj = j + dy[k];
                if (ni < 0 || ni >= 21 || nj < 0 || nj >= 21) {
                    ismx = ismn = false;
                    continue;
                }
                if (vals[ni][nj] >= vals[i][j]) {
                    ismx = false;
                }
                if (vals[ni][nj] <= vals[i][j]) {
                    ismn = false;
                }
                if (vals[ni][nj] == vals[i][j]) {
                    ispl = true;
                }
            }
            if (ismx)
                lmxs++;
            if (ismn)
                lmns++;
            ret.pl |= ispl;
        }
    }
    ret.lmax = lmxs >= 2;
    ret.lmin = lmns >= 2;
    return ret;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // Code here:

    // set<int> fnd;
    // while (fnd.size() < 8) {
    //     auto sm = gen();
    //     auto props = getProps(sm);
    //     if (!props.correct) {
    //         continue;
    //     }
    //     if (!fnd.count(props.get_mask())) {
    //         cout << "Found " << props.get_mask() << endl;
    //         cout << sm << endl;
    //     }
    //     fnd.insert(props.get_mask());
    // }

    vector<string> answers = {
        /* 0: */ "y x + y 9 * +",
        /* 1: */ "-9",
        /* 2: */ "y x + 4 ^",
        /* 3: */ "y x - x -2 * y + *",
        /* 4: */ "-5 x y - 4 ^ -",
        /* 5: */ "2 y x * - x y * *",
        /* 6: */ "-1 y x + 2 ^ ^",
        /* 7: */ "y y y x - 6 ^ * -",
    };

    string a1, a2, a3, a4;
    string b1, b2, b3, b4;
    string c1, c2;
    cin >> a1 >> a2 >> a3 >> a4 >> b1 >> b2 >> b3 >> b4 >> c1 >> c2;
    props p{true, a4 == "Yes", b4 == "Yes", c2 == "Yes"};

    cout << answers[p.get_mask()] << endl;

    return 0;
}
