#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define forrn(i, s, n) for (int i = (int)(s); i < (int)(n); i++)
#define PYMOD(a, m) ((((a) % (m)) + (m)) % (m))
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define mp make_pair
#define ff first
#define ss second

namespace FACTORIZE {
const ll MAXX = 1000;
const int FERMA_ITER = 30;
// const int POLLARD_PO_ITER = 10000;
int POLLARD_PO_ITER;
inline ll sqr(ll n) { return n * n; }
ll check_small(ll n) {
    for (ll x = 1; sqr(x) <= n && x <= MAXX; x++) {
        if (x > 1 && n % x == 0) {
            return x;
        } else if (sqr(x + 1) > n) {
            return -1;
        }
    }
    return -1;
}
ll check_square(ll n) {
    ll bl = 0;
    ll br = 3e9 + 1;
    ll bm;
    while (br - bl > 1) {
        bm = (bl + br) / 2;
        if (sqr(bm) <= n) {
            bl = bm;
        } else {
            br = bm;
        }
    }
    if (sqr(bl) == n && bl > 1) {
        return bl;
    } else {
        return -1;
    }
}
inline ll MUL(ll val, ll n, ll mod) {
    long long int q = ((double)val * (double)n / (double)mod);
    long long int res = val * n - mod * q;
    res = (res % mod + mod) % mod;
    return res;
}
inline ll _mul(ll a, ll b, ll m) {
    static __int128 xa = 1;
    static __int128 xb = 1;
    static __int128 xm = 1;
    xa = a;
    xb = b;
    xm = m;
    return ll(xa * xb % xm);
}
inline ll _binpow(ll x, ll p, ll m) {
    static ll res = 1;
    static ll tmp = 1;
    res = 1;
    tmp = x;
    while (p > 0) {
        if (p & 1ll) {
            res = _mul(res, tmp, m);
        }
        tmp = _mul(tmp, tmp, m);
        p >>= 1;
    }
    return res;
}
mt19937_64 next_rand(42);
ll gcd(ll x, ll y) { return !x ? y : gcd(y % x, x); }
bool is_prime(ll n) {
    if (n <= 1)
        return false;
    if (n == 2)
        return true;
    ll a, g;
    for (int iter = 0; iter < FERMA_ITER; iter++) {
        a = next_rand() % (n - 2);
        if (a < 0)
            a += n - 2;
        a += 2;
        assert(1 < a && a < n);
        g = gcd(a, n);
        if (g != 1) {
            return false;
        }
        if (_binpow(a, n - 1, n) != 1) {
            return false;
        }
    }
    return true;
}
inline ll _func(ll x, ll n) {
    static ll result = 1;
    result = _mul(x, x, n);
    return result + 1 < n ? result + 1 : 0;
}
ll diff(ll x, ll y, ll mod) {
    if (x - y < 0)
        return x - y + mod;
    else
        return x - y + mod;
}
ll pollard_po(ll n) {
    const int POLLARD_PO_ITER = 5 + 3 * pow(n, 0.25);
    const int MAGIC_LOG = 20;
    while (true) {
        ll x = next_rand() % n;
        for (int i = 0; i < POLLARD_PO_ITER; i++) {
            x = _mul(x, x, n) + 1;
        }
        ll y = _mul(x, x, n) + 1;
        for (int i = 0; i < POLLARD_PO_ITER / MAGIC_LOG; i++) {
            ll g = 1;
            for (int j = 0; j < MAGIC_LOG; j++) {
                g = _mul(g, diff(x, y, n), n);
                y = _mul(y, y, n) + 1;
            }
            ll res = __gcd(g, n);
            if (res != 1 && res != n)
                return res;
        }
    }
}
ll get_div(ll n) {
    ll res;
    res = check_small(n);
    if (res != -1) {
        return res;
    }
    res = check_square(n);
    if (res != -1) {
        return res;
    }
    if (is_prime(n)) {
        return n;
    }
    return pollard_po(n);
}
} // namespace FACTORIZE

vector<ll> primes(ll n) {
    if (n == 1) {
        return {};
    }
    if (FACTORIZE::is_prime(n)) {
        return {n};
    }
    vector<ll> ret;
    while (n > 1) {
        ll div = FACTORIZE::get_div(n);
        n /= div;
        auto divp = primes(div);
        copy(all(divp), back_inserter(ret));
    }
    return ret;
}

vector<pair<ll, int>> factorize(ll n) {
    vector<pair<ll, int>> ret;
    vector<ll> p = primes(n);
    sort(all(p));
    for (auto q : p) {
        if (ret.empty() || ret.back().first < q) {
            ret.emplace_back(q, 0);
        }
        ret.back().second++;
    }
    return ret;
}

ll phi(const vector<pair<ll, int>> &v) {
    ll ret = 1;
    for (auto [p, a] : v) {
        ret *= p - 1;
        forn(_, a - 1) { ret *= p; }
    }
    return ret;
}

ll leq_and_coprime(ll i, const vector<pair<ll, int>> &v) {
    int n = v.size();
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); mask++) {
        ll d = 1;
        int pcnt = 0;
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1) {
                d *= v[i].first;
                pcnt++;
            }
        }
        if (pcnt % 2 == 0) {
            ans += i / d;
        } else {
            ans -= i / d;
        }
    }
    return ans;
}

ll gcd(ll x, ll y) {
    while (y > 0) {
        tie(x, y) = mp(y, x % y);
    }
    return x;
}

void solve() {
    ll n;
    cin >> n;
    auto fct = factorize(n);
    auto l = phi(fct);
    ll lt = 0, rt = n;
    int d = 1;
    if (l % 2 == 0) {
        d = -1;
    }
    ll x;
    for (x = n / 2; gcd(x, n) > 1; x += d)
        ;
    cout << x << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    // Code here:

    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }

    return 0;
}
