#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <utility>
#include <set>
#include <unordered_map>
#include <numeric>
#include <map>
#include <cassert>
#include <deque>
#include <stack>
#include <queue>
#include <random>
#include <functional>
#include <unordered_set>
#include <complex>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using cd = complex<ld>;

struct Node {
    int pref, mid, suff, sz, cnt;
    Node* left, *right;

    Node(int _sz) {
        left = nullptr;
        right = nullptr;
        pref = mid = suff = 0;
        sz = _sz;
        cnt = 0;
    }
};

int get_pref(Node *t) {
    return t == nullptr ? 0 : t->pref;
}

int get_suff(Node *t) {
    return t == nullptr ? 0 : t->suff;
}

int get_mid(Node *t) {
    return t == nullptr ? 0 : t->mid;
}

int get_sz(Node *t) {
    return t == nullptr ? 0 : t->sz;
}

void merge(Node* res, Node* left, Node* right) {
    res->pref = get_pref(left) + (get_pref(left) == res->sz / 2 ? get_pref(right) : 0);
    res->suff = get_suff(right) + (get_suff(right) == res->sz / 2 ? get_suff(left) : 0);
    res->mid = max({res->pref, res->suff, get_mid(left), get_mid(right), get_suff(left) + get_pref(right)});
}

int d = 1;

void add(Node *&tree, ll x, int delta, int tl = 0, int tr = d - 1) {
    if (tree == nullptr) {
        tree = new Node(tr - tl + 1);
    }
    if (tl == tr) {
        tree->cnt += delta;
        if (tree->cnt) {
            tree->suff = tree->pref = tree->mid = 1;
        } else {
            tree->suff = tree->pref = tree->mid = 0;
        }
    } else {
        int tm = ((ll)tl + tr) / 2;
        if (x <= tm) {
            add(tree->left, x, delta, tl, tm);
        } else {
            add(tree->right, x, delta, tm + 1, tr);
        }
        merge(tree, tree->left, tree->right);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> v(n);

    vector<pair<int, int>> events;

    while (d < 1e9) {
        d *= 2;
    }

    Node *tree = new Node(d);

    for (int &e : v) {
        cin >> e;
        events.emplace_back(m - e % m, e / m);
        add(tree, e / m, 1);
    }

    sort(events.begin(), events.end());
    int bestAns = get_mid(tree), res = 0;
    for (int i = 0; i < (int)events.size(); i++) {
        int j = i;
        while (j < (int)events.size() && events[j].first == events[i].first) {
            add(tree, events[j].second, -1);
            add(tree, events[j].second + 1, 1);
            j++;
        }
        i = j - 1;
        int ans = get_mid(tree);
        if (ans > bestAns) {
            bestAns = ans;
            res = events[i].first;
        }
    }

    cout << bestAns << " " << res << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
