#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)(x).size()
//#define int ll

struct node {
    int l, r, f;
    pair<int, int> max;
    node() = default;
    node(int l, int r, int f, pair<int, int> mx) : l(l), r(r), f(f), max(mx) {};
};

const int N = 1e7 + 10;
node t[N];
int cnt_all = 1;

void del_all(int m) {
    cnt_all = 1;
    t[1].l = t[1].r = t[1].f = 0;
    t[1].max = {0, m - 1};
}

void push(int v) {
    t[t[v].l].f += t[v].f;
    t[t[v].r].f += t[v].f;
    t[t[v].l].max.F += t[v].f;
    t[t[v].r].max.F += t[v].f;
    t[v].f = 0;
}

void update(int v, int l, int r, int a, int b, int delta) {
    if (l > b || r < a) {
        return;
    }
    if (l >= a && r <= b) {
        t[v].max.F += delta;
        t[v].f += delta;
        return;
    }
    int mid = (l + r) / 2;
    if (!t[v].l) {
        cnt_all++;
        t[v].l = cnt_all;
        t[cnt_all].l = t[cnt_all].r = t[cnt_all].f = 0;
        t[cnt_all].max = {0, mid};
    }
    if (!t[v].r) {
        cnt_all++;
        t[v].r = cnt_all;
        t[cnt_all].l = t[cnt_all].r = t[cnt_all].f = 0;
        t[cnt_all].max = {0, r};
    }
    push(v);
    update(t[v].l, l, mid, a, b, delta);
    update(t[v].r, mid + 1, r, a, b, delta);
    t[v].max = max(t[t[v].l].max, t[t[v].r].max);
}

pair<int, int> get_max(int v, int l, int r, int a, int b) {
    if (l > b || r < a) {
        return {0, 0};
    }
    if (l >= a && r <= b) {
        return t[v].max;
    }
    int mid = (l + r) / 2;
    if (!t[v].l) {
        cnt_all++;
        t[v].l = cnt_all;
        t[cnt_all].l = t[cnt_all].r = t[cnt_all].f = 0;
        t[cnt_all].max = {0, mid};
    }
    if (!t[v].r) {
        cnt_all++;
        t[v].r = cnt_all;
        t[cnt_all].l = t[cnt_all].r = t[cnt_all].f = 0;
        t[cnt_all].max = {0, r};
    }
    push(v);
    return max(get_max(t[v].l, l, mid, a, b), get_max(t[v].r, mid + 1, r, a, b));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T;
    cin >> T;
    while (T--) {
        int n, m;
        cin >> n >> m;
        map<int, pair<int, int>> seg;
        map<int, int> pref;
        map<int, int> suf;
        set<int> good;
        for (int i = 0; i < n; i++) {
            int t;
            cin >> t;
            if (t % m == 0) {
                pref[t / m] = m;
                good.insert(t / m);
            } else {
                pref[t / m] = max(pref[t / m], m - t % m);
                suf[t / m + 1] = max(suf[t / m + 1], (m - 1) - (m - t % m) + 1);
                good.insert(t / m);
                good.insert(t / m + 1);
            }
        }
        for (auto it : good) {
            if (pref[it] + suf[it] >= m) {
                seg[it] = {m, 0};
            } else {
                seg[it] = {pref[it], suf[it]};
            }
        }
        int prv = -100, r;
        pair<int, int> ans = {0, 0};
        del_all(m);
        auto add = [&](int day) {
            if (seg[day].F > 0) update(1, 0, m - 1, 0, seg[day].F - 1, 1);
            if (seg[day].S > 0) update(1, 0, m - 1, m - seg[day].S, m - 1, 1);
        };
        auto del = [&](int day) {
            if (seg[day].F > 0) update(1, 0, m - 1, 0, seg[day].F - 1, -1);
            if (seg[day].S > 0) update(1, 0, m - 1, m - seg[day].S, m - 1, -1);
        };
        for (auto it : seg) {
            if (it.F == prv + 1) {
                del(prv);
                while (true) {
                    add(r);
                    if (t[1].max.F == r - it.F + 1) {
                        r++;
                    } else {
                        del(r);
                        break;
                    }
                }
            } else {
                r = it.F;
                del_all(m);
                while (true) {
                    add(r);
                    if (t[1].max.F == r - it.F + 1) {
                        r++;
                    } else {
                        del(r);
                        break;
                    }
                }
            }
            ans = max(ans, {r - it.F, t[1].max.S});
        }
        cout << ans.F << ' ' << ans.S << '\n';
    }
}