#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

vector<int> parent;
vector<int> ranks;

vector<pair<pair<int, int>, int>> edges;

void make_s(int u) {
    parent[u] = u;
    ranks[u] = 0;
}

int find_parent(int u) {
    if (u == parent[u]) {
        return u;
    }
    return parent[u] = find_parent(parent[u]);
}

bool union_s(int u, int v, int c) {
    int uu = u, vv = v;
    u = find_parent(u);
    v = find_parent(v);
    if (u == v) {
        return false;
    }
    edges.push_back({{uu, vv}, c});
    if (ranks[u] > ranks[v]) {
        swap(u, v);
    }
    parent[u] = v;
    if (ranks[u] == ranks[v]) {
        ranks[v]++;
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    int n;
    while(t--) {
        edges.clear();
        cin >> n;
        parent.resize(n);
        ranks.resize(n);
        for (int i = 0; i < n; i++) {
            make_s(i);
        }
        vector<int> b(n);
        vector<int> w(n);
        set<pair<int, int>> min_;
        set<pair<int, int>> minb;
        set<pair<int, int>> minw;
        bool ch = true;
        int sum = 0;
        for (int i = 0; i < n; i++) {
            cin >> w[i] >> b[i];
            sum += w[i] + b[i];
            if (w[i] != 0 || b[i] != 0) {
                min_.insert({w[i] + b[i], i});
            } else if (n != 1) {
                ch = false;
            }
            if (w[i]) {
                minw.insert({-w[i], i});
            }
            if (b[i]) {
                minb.insert({-b[i], i});
            }
        }
        if (sum != 2 * n - 2) {
            ch = false;
        }
        if (ch) {
            while (!min_.empty()) {
                vector<pair<int, int>> elems;
                if (!ch) {
                    break;
                }
                auto t = *min_.begin();
                min_.erase(t);
                if (t.first != 1) {
                    ch = false;
                    break;
                }
                vector<int> bad;
                int v = t.second;
                if (b[v] > 0) {
                    bool find_ = false;
                    while (!minb.empty()) {
                        auto s = *minb.begin();
                        minb.erase(s);
                        if (union_s(v, s.second, 1)) {
                            find_ = true;
                            b[v]--, b[s.second]--;
                            min_.erase({b[s.second] + 1 + w[s.second], s.second});
                            if (b[s.second] + w[s.second] > 0) {
                                min_.insert({b[s.second] + w[s.second], s.second});
                            }
                            if (b[s.second]) {
                                minb.insert({-b[s.second], s.second});
                            }
                            break;
                        } else {
                            bad.push_back(s.second);
                        }
                    }
                    if (!find_) {
                        ch = false;
                        break;
                    }
                    for (auto vert : bad) {
                        minb.insert({-b[vert], vert});
                    }
                }
                if (w[v] > 0) {
                    bool find_ = false;
                    while (!minw.empty()) {
                        auto s = *minw.begin();
                        minw.erase(s);
                        if (union_s(v, s.second, 0)) {;
                            find_ = true;
                            w[v]--, w[s.second]--;
                            min_.erase({b[s.second] + 1 + w[s.second], s.second});
                            if (b[s.second] + w[s.second] > 0) {
                                min_.insert({b[s.second] + w[s.second], s.second});
                            }
                            if (w[s.second]) {
                                minw.insert({-w[s.second], s.second});
                            }
                            break;
                        } else {
                            bad.push_back(s.second);
                        }
                    }
                    if (!find_) {
                        ch = false;
                        break;
                    }
                    for (auto vert : bad) {
                        minw.insert({-w[vert], vert});
                    }
                }
            }
        }
        if (!ch) {
            cout << "No" << endl;
        } else {
            cout << "Yes" << endl;
            for (auto e : edges) {
                cout << e.first.first + 1 << " " << e.first.second + 1 << " ";
                if (e.second == 1) {
                    cout << "B" << endl;
                } else {
                    cout << "W" << endl;
                }
            }
        }
    }
    return 0;
}
