// #pragma GCC optimize("Ofast,no-stack-protector,unroll-all-loops,unroll-loops")
// #pragma GCC target("abm,mmx,sse,sse2,sse3,ssse3,sse4a,popcnt,tune=native")
  
#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <vector>
#include <unordered_map>
#include <map>
#include <ctime>
  
using namespace std;
 
typedef long long ll;

const int mod = 998244353;
 
const int maxn = 507, maxk = 307, maxm = 26;

ll power(ll a, int n){
    ll res = 1;
    while (n){
        if (n & 1)
            res = res * a % mod;
        a = a * a % mod;
        n >>= 1;
    }
    return res;
}

ll inv(ll a){
    return power(a, mod - 2);
}

int times[maxn][maxm];

ll solve_exactly[maxn][maxm][maxk];
ll do_not_solve[maxn][maxm][maxk];

ll prob_not_solve_pref[maxn][maxm][maxk];
ll prob_not_solve_suff[maxn][maxm][maxk];

void use_solve_exactly(int n, int m, int k){
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            for (int t = 0; t <= k; t++){
                if (t == 0)
                    do_not_solve[i][j][t] = 1;
                else
                    do_not_solve[i][j][t] = do_not_solve[i][j][t - 1];
                do_not_solve[i][j][t] -= solve_exactly[i][j][t];
                if (do_not_solve[i][j][t] < 0)
                    do_not_solve[i][j][t] += mod;
                prob_not_solve_pref[i][j][t] = i ? prob_not_solve_pref[i - 1][j][t] : 1;
                prob_not_solve_pref[i][j][t] = prob_not_solve_pref[i][j][t] * do_not_solve[i][j][t] % mod;
            }
        }
    }
    for (int i = n - 1; i >= 0; i--){
        for (int j = 0; j < m; j++){
            for (int t = 0; t <= k; t++){
                prob_not_solve_suff[i][j][t] = i == n - 1 ? prob_not_solve_suff[i + 1][j][t] : 1;
                prob_not_solve_suff[i][j][t] = prob_not_solve_suff[i][j][t] * do_not_solve[i][j][t] % mod;
            }
        }
    }
    vector<int> ans(n);
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            for (int t = 1; t <= k; t++){
                ll no_one_solved = i == 0 ? 1 : prob_not_solve_pref[i - 1][j][t - 1];
                if (i + 1 < n)
                    no_one_solved = no_one_solved * prob_not_solve_suff[i + 1][j][t - 1] % mod;
                ans[i] += solve_exactly[i][j][t] * no_one_solved % mod; 
            }
        }
    }
    for (int i = 0; i < n; i++)
        cout << ans[i] << ' ';
}

ll cnt[maxn][maxk][maxm];

ll inv_fact[maxn], invv[maxn];

ll cnt_ways[maxn][maxk][maxm];

void prepare_solve_exaclty(int n, int m, int k){
    for (int i = 1; i < maxn; i++)
        invv[i] = inv(i);
    inv_fact[0] = 1;
    for (int i = 1; i < maxn; i++)
        inv_fact[i] = inv_fact[i - 1] * invv[i];
    for (int i = 0; i < n; i++){
        vector<int> s;
        for (int j = 0; j < m; j++){
            if (times[i][j])
                s.push_back(times[i][j]);
        }
        cnt[i][0][0] = 1;
        for (int t = 1; t <= k; t++){
            for (int ss = 1; ss < s.size(); ss++){
                for (int j = 0; j < s.size(); j++){
                    if (t >= s[j])
                        cnt[i][t][ss] += cnt[i][t - s[j]][ss - 1];
                }
                cnt[i][t][ss] %= mod;
            }
        }
        for (int t = 1; t <= k; t++){
            for (int p = 0; p < m; p++){
                if (times[i][p] == 0 || t >= times[i][p])
                    continue;
                for (int ss = 0; ss < s.size(); ss++){
                    cnt_ways[i][t][p] = cnt[i][t - times[i][p]][p - 1];
                    if (t >= 2 * times[i][p]){
                        cnt_ways[i][t][p] -= cnt_ways[i][t - times[i][p]][p - 1];
                        if (cnt_ways[i][t][p] < 0)
                            cnt_ways[i][t][p] += mod;
                    }
                    solve_exactly[i][t][p] += cnt_ways[i][t][p] * inv_fact[s.size()] % mod * invv[s.size()] % mod;
                }
            }
        }
    }
}


  
void solve(){
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++)
            cin >> times[i][j];
    }
    prepare_solve_exaclty(n, m, k);
    use_solve_exactly(n, m, k);
}
 
  
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}