﻿#include <bits/stdc++.h>
//#include <bits/extc++.h>
//#include <immintrin.h>

using namespace std;

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")


template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)
        in >> i;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a) {
        out << i << " ";
    }
    return out;
}

template<typename T, typename D>
istream &operator>>(istream &in, pair<T, D> &a) {
    in >> a.first >> a.second;
    return in;
}

template<typename T, typename D>
ostream &operator<<(ostream &out, const pair<T, D> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct LogOutput {
    template<typename T>
    LogOutput &operator<<(const T &x) {
#ifdef DIVAN
        cout << x;
#endif
        return *this;
    }
} dout, fout;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef long double ld;
typedef complex<double> cd;

#define elif else if
#define all(_v) _v.begin(), _v.end()
#define rall(v) v.rbegin(), v.rend()
#define sz(v) (int)(v.size())
#define sqr(_v) ((_v) * (_v))
#define eb emplace_back
#define pb push_back
#define mod(x, m) ((x) >= 0 ? ((x) % m) : ((((x) % m) + m) % m))
#define minq(x, y) x = min((x), (y))
#define maxq(x, y) x = max(x, (y))
#define forn(i, n) for (int i = 0; i < (n); ++i)

#define vpi vector <pair <int, int>>
#define vi vector<int>
#define pi pair <int, int>
#define ti tuple <int, int, int>


const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;
const int INF = 2139062143;
const int nINF = -2139062144;
const ull ULINF = numeric_limits<ull>::max();
const long double PI = acos(-1);
auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
//auto seed = 0;
mt19937 rnd(seed);

inline void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    //    freopen("input.txt", "r", stdin);
    //    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
}

#define int ll

struct SegmentTree {

    struct Node {
        long long sum;
        long long pref;
        long long suf;
        long long seg;

        Node (long long x) {
            sum = x;
            pref = suf = seg = max(0ll, x);
        }
    };

    vector <Node> tree;
    int size;

    void pull(int x) {
        int l = 2 * x + 1;
        int r = 2 * x + 2;
        tree[x].sum = tree[l].sum + tree[r].sum;
        tree[x].pref = max(tree[l].pref, tree[l].sum + tree[r].pref);
        tree[x].suf = max(tree[r].suf, tree[r].sum + tree[l].suf);
        tree[x].seg = max(max(tree[l].seg, tree[r].seg), tree[l].suf + tree[r].pref);
    }

    const Node ZERO = Node(nINF);

    void init(int n) {
        size = 1;
        while (size < n) size *= 2;
        tree.assign(2 * size, ZERO);
    }

    void set(int i, int v, int x, int lx, int rx) {
        if (rx == lx + 1) {
            tree[x] = Node(v);
            return;
        }
        int mx = (lx + rx) / 2;
        if (i < mx) {
            set(i, v, 2 * x + 1, lx, mx);
        } else {
            set(i, v, 2 * x + 2, mx, rx);
        }
        pull(x);
    }

    void set(int i, int v) {
        set(i, v, 0, 0, size);
    }

    long long get_seg() {
        return tree[0].seg;
    }
};

void Set(int pos, SegmentTree& st, const vi& day) {
    if (pos == 0) {
        st.set(0, 1);
        return;
    } else if (pos >= sz(day)) {
        return;
    }
    int between = (pos * 2) - 1;
    if (day[pos] == day[pos - 1]) {
        st.set(between, 0);
        st.set(between + 1, 0);
    } else if (day[pos] == day[pos - 1] + 1) {
        st.set(between, 0);
        st.set(between + 1, 1);
    } else {
        st.set(between, nINF);
        st.set(between + 1, 1);
    }
}

void Solve() {
    int n, m;
    cin >> n >> m;
    vector <int> a(n), day(n), needForNext(n);
    cin >> a;
    SegmentTree st;
    st.init(2 * n - 1);
    map <int, vi> change;
    forn(i, n) {
        day[i] = a[i] / m;
        needForNext[i] = ((a[i] / m + 1) * m) - a[i];
        change[needForNext[i]].eb(i);
        Set(i, st, day);
    }
    int ans = st.get_seg(), t = 0;
    for (auto &[x, y] : change) {
        for (auto pos : y) {
            day[pos]++;
            Set(pos, st, day);
            Set(pos + 1, st, day);
        }
        int curr = st.get_seg();
        if (ans < curr) {
            ans = curr;
            t = x;
        }
    }
    cout << ans << ' ' << t << '\n';
}

signed main() {
    auto startTime = chrono::high_resolution_clock::now();
    IO();
    int t = 1;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        //        cout << "Case #" << i << ": ";
        Solve();
    }
    auto endTime = chrono::high_resolution_clock::now();
    chrono::duration<long double> duration = endTime - startTime;
    cout << setprecision(6) << fixed;
    fout << '\n' << "Time: " << duration.count();
    return 0;
}