﻿#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <unordered_map>
#include <random>
#include <chrono>
using namespace std;

#define X real()
#define Y imag()
#define endl '\n'
#define int long long
#define all(X) (X).begin(), (X).end()
#define rall(X) (X).rbegin(), (X).rend()
mt19937_64 rnd(chrono::system_clock::now().time_since_epoch().count());
int gcd(int a, int b) { return b ? gcd(b, a % b) : a; }
int lcm(int a, int b) { return a * b / gcd(a, b); }

const int INF = 1e9;

struct node
{
	vector<pair<int, int>> edges;
};

void DJSMIN(int start, vector<node> &d, vector<pair<int, int>> &dist, vector<int> &links)
{
	priority_queue<pair<int, pair<int, int>>> que;

	dist[start] = { 0, INF };
	que.push(make_pair(start, dist[start]));

	auto cmp = [](pair<int, int> a, pair<int, int> b) {
		if (a.first < b.first)
			return 1;
		else if (a.first == b.first && a.second < b.second)
			return 1;
		else return 0;
	};

	while (!que.empty()) {
		int first = que.top().first;
		que.pop();
		for (auto j : d[first].edges) {
			if (cmp(make_pair(dist[first].first + 1, min(dist[first].second, j.second)), dist[j.first])) {
				dist[j.first] = make_pair(dist[first].first + 1, min(dist[first].second, j.second));
				que.push(make_pair(j.first, dist[j.first]));
				links[j.first] = first;
			}
		}
	}
}

void DJSMAX(int start, vector<node> &d, vector<pair<int, int>> &dist, vector<int> &links)
{
	priority_queue<pair<int, pair<int, int>>> que;

	dist[start] = { 0, -INF };
	que.push(make_pair(start, dist[start]));

	auto cmp = [](pair<int, int> a, pair<int, int> b) {
		if (a.first < b.first)
			return 1;
		else if (a.first == b.first && a.second > b.second)
			return 1;
		else return 0;
	};

	while (!que.empty()) {
		int first = que.top().first;
		que.pop();
		for (auto j : d[first].edges) {
			if (cmp(make_pair(dist[first].first + 1, max(dist[first].second, j.second)), dist[j.first])) {
				dist[j.first] = make_pair(dist[first].first + 1, max(dist[first].second, j.second));
				que.push(make_pair(j.first, dist[j.first]));
				links[j.first] = first;
			}
		}
	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
//#ifndef ONLINE_JUDGE
//	freopen("input.txt", "r", stdin);
//#endif

	int n, m;
	cin >> n >> m;

	vector<node> d(n);
	for (int i = 0; i < m; i++)
	{
		int u, v, c;
		cin >> u >> v >> c;
		u--; v--;
		d[u].edges.push_back(make_pair(v, c));
		d[v].edges.push_back(make_pair(u, c));
	}

	vector<int> link1MIN(n), link1MAX(n), linknMIN(n), linknMAX(n);
	vector<pair<int, int>> dist1MIN(n, { INF, INF }), distnMIN(n, { INF, INF });
	vector<pair<int, int>> dist1MAX(n, { INF, -INF }), distnMAX(n, { INF, -INF });
	DJSMIN(0, d, dist1MIN, link1MIN);
	DJSMIN(n - 1, d, distnMIN, linknMIN);
	DJSMAX(0, d, dist1MAX, link1MAX);
	DJSMAX(n - 1, d, distnMAX, linknMAX);

	int delt = -INF, v = -1, t = -1;
	int mindist = dist1MIN[n - 1].first;
	cout << mindist << endl;

	for (int i = 0; i < n; i++) {
		if (dist1MIN[i].first + distnMIN[i].first == mindist) {
			if (delt < dist1MAX[i].second - distnMIN[i].second) {
				delt = dist1MAX[i].second - distnMIN[i].second;
				v = i;
				t = 1;
			}
			if (delt < distnMAX[i].second - dist1MIN[i].second) {
				delt = distnMAX[i].second - dist1MIN[i].second;
				v = i;
				t = 2;
			}
		}
	}

	for (auto &i : d[0].edges) {
		if (i.first == n - 1 && delt < 0) {
			cout << 1 << " " << n;
			return 0;
		}
	}

	vector<int> left, right;
	if (t == 1) {
		for (int i = v; i != 0; i = link1MAX[i])
			left.push_back(i);
		left.push_back(0);
		reverse(all(left));
		left.pop_back();
		for (int i = v; i != n - 1; i = linknMIN[i])
			right.push_back(i);
		right.push_back(n - 1);
	}
	else {
		for (int i = v; i != 0; i = link1MIN[i])
			left.push_back(i);
		left.push_back(0);
		reverse(all(left));
		left.pop_back();
		for (int i = v; i != n - 1; i = linknMAX[i])
			right.push_back(i);
		right.push_back(n - 1);
	}
	for (auto &i : left)
		cout << i + 1 << " ";
	for (auto &i : right)
		cout << i + 1 << " ";
	return 0;
}