#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <iomanip>
#include <map>
#include <complex>
#include <queue>
#include <cassert>
#include <chrono>
#include <random>
#include <climits>
#define forn(i, n) for (int i = 0; i < n; ++i)
#define debug(x) cout << #x << " = " << x << endl
#define all(a) begin(a), end(a)
#define sqr(x) ((x) * (x))
//#define int long long

using namespace std;

template<class Iter> 
void print(Iter l, Iter r) {
    cout << "[";
    for (auto it = l; it != r; ++it) {
        if (it != l) {
            cout << ", ";   
        }
        cout << *it;
    }
    cout << "]" << endl;
}

template<class C, class F> 
ostream& operator<<(ostream &out, pair<C, F> p) {
    return out << "(" << p.first << ", " << p.second << ")";
}

using ll = long long;

mt19937_64 rnd(std::chrono::system_clock::now().time_since_epoch().count());

using pi = pair<int, int>;

const int N = 3e5 + 40;
int cols[N][2];
int sols[N][2];
int deg[N];

int ptr;
int ans_u[N];
int ans_v[N];
int ans_c[N];

void solve() {
    int n;
    cin >> n;

    set<pi> st;
    set<pair<pi, int>> have[2];
    ptr = 0;

    forn(i, n) {
        forn(j, 2) {
            cin >> cols[i][j];
            deg[i] += cols[i][j];
        }
        st.insert({deg[i], i});

        forn(j, 2) {
            if (cols[i][j]) {
                have[j].insert({{cols[i][j], deg[i]}, i});
            }
            sols[i][j] = cols[i][j];
        }
    }

    while (st.size()) {
        auto [_, u] = *st.begin();
        st.erase(st.begin());

      //  debug(u);

        forn(j, 2) {
            if (cols[u][j] == 0) continue;
            have[j].erase({{cols[u][j], 1}, u});

            if (have[j].empty()) {
                cout << "No\n";
                return;
            }

            auto rb = *have[j].rbegin();
            have[j].erase(rb);
            int node = rb.second;

            ans_u[ptr] = u;
            ans_v[ptr] = node;
            ans_c[ptr] = j;
            ++ptr;

            if (cols[node][1-j] > 0) {
                have[1-j].erase({{cols[node][1-j], deg[node]}, node});
            }
            st.erase({deg[node], node});

            deg[node]--;

            // debug(node);
            // debug(deg[node]);

            cols[node][j]--;

            if (deg[node] > 0) {
                st.insert({deg[node], node});
            }
            forn(k, 2) {
                if (cols[node][k] > 0) {
                    have[k].insert({{cols[node][k], deg[node]}, node});
                }
            }
        }
    }

    if (ptr != n - 1) {
        cout << "No\n";
        return;
    }

    forn(i, ptr) {
        int u = ans_u[i];
        int v = ans_v[i];
        int cv = ans_c[i];

        if (u == v) {
            cout << "No\n";
            return;
        }

        sols[u][cv]--;
        sols[v][cv]--;
    }

    forn(i, n) {
        if (sols[i][0] != 0 || sols[i][1] != 0) {
            cout << "No\n";
            return;
        }
    }

    cout << "Yes\n";

    forn(i, ptr) {
         int u = ans_u[i];
        int v = ans_v[i];
        int cv = ans_c[i];
        cout << u + 1 << " " << v + 1 << " " << "WB"[cv] << "\n";
    }

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); 

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}