#define FS first
#define SC second

#include <random>
#include <iostream>
#include <iomanip>
#include <unordered_map>
#include <map>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;

mt19937 gen(339264);

const int MAXN = 1050;
int d[MAXN][MAXN];


pair<int, int> solve_small(int n, int m, const vector<int>& a) {
    int mx_tz = 0, mx_st = 0;
    for (int tz = 0; tz < m; tz++) {
        int mx = 1;
        int streak = 1;
        int last = (a[0] + tz) / m;
        for (int i = 1; i < n; i++) {
            int cur = (a[i] + tz) / m;
            if (cur == last + 1) {
                streak++;
                last = cur;
                mx = max(mx, streak);
            } else if (cur == last) {
            } else {
                last = cur;
                streak = 1;
            }
        }
        if (mx > mx_st) {
            mx_tz = tz;
            mx_st = mx;
        }
    }
    return {mx_st, mx_tz};
}

pair<int, int> solve_big(int n, int m, const vector<int>& a) {
    int mx_tz = 0, mx_st = 0;
    for (int i = 0; i < n; i++) {
        int tz = (m - a[i] % m) % m;

        int mx = 1;
        int streak = 0;
        for (int j = 0; j <= a[n - 1] + tz; j += m) {
            int val = *lower_bound(a.begin(), a.end(), j - tz);


            if (val + tz >= j + m){
                streak = 0;
            } else {
                streak++;
                mx = max(mx, streak);
            }

            //cerr << j << " " << val << " " << streak << " " << mx << endl;
        }

        if (mx > mx_st) {
            mx_tz = tz;
            mx_st = mx;
        }
    }
    return {mx_st, mx_tz};
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0);

    uniform_int_distribution<int> rand(0,100500);

    int t;
    cin >> t;

    const int K = 5000; 
    for (int tt = 0; tt < t; tt++) {
        int n, m;
        cin >> n >> m;

        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }

        int s, tz;
        if (m <= K) {
            tie(s, tz) = solve_small(n, m, a);
        } else {
            tie(s, tz) = solve_big(n, m, a);
        }
        cout << s << " " << tz << endl;
    }

    return 0;
}
