#include <bits/stdc++.h>

#define s second
#define f first
#define pb push_back
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define all(a) (a).begin(), (a).end()
#define len(a) (int)(a).size()
#define INF (int)(1e9)

using namespace std;

const int N = 100100;
vector<pair<int, int> > g[N];

int n, m;

void bfs(int st, vector<int> &d, vector<int> &mi, vector<int> &ma, vector<int> &pmi, vector<int> &pma) {
    d.resize(n, INF);
    mi.resize(n, INF);
    ma.resize(n, -INF);
    pmi.resize(n, -1);
    pma.resize(n, -1);
    d[st] = 0;
    queue<int> q;
    q.push(st);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto [v, w] : g[u]) {
            if (d[v] == INF) {
                q.push(v);
                d[v] = d[u] + 1;
            }
            if (d[v] >= d[u] + 1) {
                if (mi[v] > min(mi[u], w)) {
                    mi[v] = min(mi[u], w);
                    pmi[v] = u;
                }
                if (ma[v] < max(ma[u], w)) {
                    ma[v] = max(ma[u], w);
                    pma[v] = u;
                }
            }
        }
    }
}

vector<int> get_path(int u, vector<int> &p) {
    vector<int> ans;
    while (u != -1) {
        ans.pb(u);
        u = p[u];
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(37);
    // freopen("test.in", "r", stdin);

    cin >> n >> m;

    forn(i, m) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u - 1].pb({v - 1, w});
        g[v - 1].pb({u - 1, w});
    }

    vector<int> d1, mi1, ma1, pmi1, pma1;
    vector<int> d2, mi2, ma2, pmi2, pma2;

    bfs(0, d1, mi1, ma1, pmi1, pma1);
    bfs(n - 1, d2, mi2, ma2, pmi2, pma2);

    int dist = d1[n - 1];

    int kk = -INF, kku;
    
    forn(i, n) {
        if (d1[i] + d2[i] == dist) {
            if (max(ma1[i] - mi2[i], ma2[i] - mi1[i]) > kk) {
                kk = max(ma1[i] - mi2[i], ma2[i] - mi1[i]);
                kku = i;
            }
        }
    }

    cout << dist << '\n';

    if (kk == ma1[kku] - mi2[kku]) {
        vector<int> p1 = get_path(kku, pma1);
        vector<int> p2 = get_path(kku, pmi2);
        reverse(all(p1));
        p1.pop_back();
        for (int i : p1) cout << i + 1 << ' ';
        for (int i : p2) cout << i + 1 << ' ';
    } else {
        vector<int> p1 = get_path(kku, pmi1);
        vector<int> p2 = get_path(kku, pma2);
        reverse(all(p1));
        p1.pop_back();
        for (int i : p1) cout << i + 1 << ' ';
        for (int i : p2) cout << i + 1 << ' ';
    }

    return 0;
}
