//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O4")

#include <bits/stdc++.h>

using namespace std;

using ll = long long int;
using ld = long double;
using ui = unsigned int;
using ull = unsigned long long;
using pp = pair<int, int>;
using tt = tuple<int, int, int>;

const int inf = (int) 1e9 + 1;
const int mod = 998244353;
//const ll inf = (ll) 1e18;


#define umap unordered_map
#define uset unordered_set
#define Power ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define all(x) (x).begin(), (x).end()
#define pb push_back


template<typename T>
T gcd(T a, T b) {
    return b ? gcd(b, a % b) : a;
}

template<typename T>
T lcm(T a, T b) {
    return a * b / gcd(a, b);
}

mt19937_64 mers((random_device()) ());


pair<vector<int>, vector<ll>> bfs(vector<vector<pair<int, ll>>> g, int s) {
    vector<int> d(g.size(), 1000000);
    vector<ll> max0(g.size(), -1);

    deque<int> q;
    q.push_back(s);
    d[s] = 0;

    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (auto [to, w] : g[v]) {
            if (d[to] > d[v] + 1) {
                d[to] = d[v] + 1;
                q.push_back(to);
            } else if (d[to] + 1 == d[v]) {
                max0[v] = max(max0[v], max(w, max0[to]));
            }
        }
    }
    return {d, max0};
}

void solve() {

    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }

    auto [d, max0] = bfs(g, 0);
    auto [d1, max1] = bfs(g, n - 1);

    int edge_v = -1;
    int edge_to = -1;
    ll edge_score = -1;
    for (int v = 0; v < n; v++) {
        if (d[v] + d1[v] != d[n - 1])
            continue;
        for (auto [to, w] : g[v]) {
            if (d[to] + d1[to] != d[n - 1])
                continue;
            if (d[v] + 1 == d[to]) {
                ll score = max(max0[v], max1[to]) - w;
                if (edge_score < score) {
                    edge_score = score;
                    edge_v = v;
                    edge_to = to;
                }
            }
        }
    }
    vector<int> ans(d[n - 1] + 1);
    ans[d[edge_v]] = edge_v;
    for (int i = d[edge_v] - 1; i >= 0; i--) {
        int v = ans[i + 1];
        for (auto [to, w] : g[v]) {
            if (d[to] + 1 == d[v]) {
                if (max(w, max0[to]) == max0[v]) {
                    ans[i] = to;
                    break;
                }
            }
        }
    }
    ans[d[edge_to]] = edge_to;
    for (int i = d[edge_to] + 1; i <= d[n - 1]; i++) {
        int v = ans[i - 1];
        for (auto [to, w]: g[v]) {
            if (d[v] + 1 == d[to]) {
                if (max(w, max1[to]) == max1[v]) {
                    ans[i] = to;
                    break;
                }
            }
        }
    }

    cout << ans.size() - 1 << "\n";
    for (auto x : ans) {
        cout << x + 1 << " ";
    }
}


signed main() {

    Power;


#ifdef _DEBUG
    (void) freopen("input.txt", "r", stdin);
    (void) freopen("output.txt", "w", stdout);
#else
    //  (void)freopen("lwdb.in", "r", stdin);
    //  (void)freopen("lwdb.out", "w", stdout);
#endif

    int queue_counter = 1;
//    cin >> queue_counter;
    while (queue_counter--) {
        solve();
    }

    return 0;
}