#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef pair<int, int> pll;

int k;
int last_index = 1;

struct bor {
    vector<int> children;
    int size;
    int ends;
    pll d; // {removes, left}

    void add_string(string& s, int from);
    void calc();

    bor() {
        this->size = 0;
        this->ends = 0;
        this->children.resize(26);
        fill(this->children.begin(), this->children.end(), -1);
        this->d = { 0, 0 };
    }
};

vector<bor> nodes;

void bor::add_string(string& s, int from) {
    ++size;

    if (from == s.length()) {
        ++ends;
        return;
    }
    if (children[s[from] - 'a'] == -1) {
        children[s[from] - 'a'] = last_index++;
    }

    nodes[children[s[from] - 'a']].add_string(s, from + 1);
}

void bor::calc() {
    int removes = 0;
    vector<int> left;
    for (int i = 0; i < 26; i++) {
        if (children[i] != -1) {
            int child_id = children[i];
            nodes[child_id].calc();
            removes += nodes[child_id].d.first;
            left.push_back(nodes[child_id].d.second);
        }
    }

    sort(left.begin(), left.end());
    int pref_sum = ends;
    for (int i = 0; i < left.size(); i++) {
        if (pref_sum + left[i] > k) {
            removes += left.size() - i;
            break;
        }

        pref_sum += left[i];
    }

    d = { removes, pref_sum };
}


int main() {
    int n;

    cin >> n >> k;

    nodes.resize(3 * 100003);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        nodes[0].add_string(s, 0);
    }

    nodes[0].calc();

    if (nodes[0].d.second == 0) {
        cout << nodes[0].d.first;
    }
    else {
        cout << nodes[0].d.first + 1;
    }

    return 0;
}