#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <string>
#include <unordered_map>
#include <cassert>

using namespace std;

typedef long long ll;
bool board[310][310];
bool used[310][310] ;
int fs = 0;
int qs = 0;

bool is_f(int i, int j) {
    return board[i][j] && board[i][j + 1] && board[i][j + 2] && 
           board[i + 1][j] && 
           board[i + 2][j] && board[i + 2][j + 1] &&
           board[i + 3][j] &&
           board[i + 4][j];
}

bool is_q(int i, int j) {
    return board[i][j] && board[i][j + 1] && board[i][j + 2] && 
           board[i + 1][j] &&                board[i + 1][j + 2] &&
           board[i + 2][j] && board[i + 2][j + 1] && board[i + 2][j + 2] &&
                                                    board[i + 3][j + 2] &&
                                                    board[i + 4][j + 2];
}

void set_f(int i, int j) {
    fs++;
    used[i][j] = 1;
    used[i][j + 1] = 1;
    used[i][j + 2] = 1;
    used[i + 1][j] = 1;
    used[i + 2][j] = 1;
    used[i + 2][j + 1] = 1;
    used[i + 3][j] = 1;
    used[i + 4][j] = 1;
}

void set_q(int i, int j) {
    qs++;
    used[i][j] = 1;
    used[i][j + 1] = 1;
    used[i][j + 2] = 1;
    used[i + 1][j] = 1;
    used[i + 1][j + 2] = 1;
    used[i + 2][j] = 1;
    used[i + 2][j + 1] = 1;
    used[i + 2][j + 2] = 1;
    used[i + 3][j + 2] = 1;
    used[i + 4][j + 2] = 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < m; j++) {
            board[i][j] = s[j] == '#';
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (board[i][j] && !used[i][j]) {
                if (is_f(i, j) && is_q(i, j)) {
                    if (!board[i + 1][j + 3]) {
                        set_q(i, j);
                    } else if (used[i + 1][j + 3]) {
                        set_q(i, j);
                    } else if (board[i + 2][j + 3]) {
                        set_q(i, j);
                    } else {
                        set_f(i, j);
                    }
                } else if (is_f(i, j)) {
                    set_f(i, j);
                } else if (is_q(i, j)) {
                    set_q(i, j);
                } else {
                    assert(false);
                }
            }
        }
    }
    cout << qs << " " << fs << "\n";

}