#include <bits/stdc++.h>

#define MAX_C 2'000'000'007

using namespace std;

// vector<vector<pair<int, int>>> g(20007, vector<pair<int, int>>());

int main() {
    iostream::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<vector<pair<int, int>>> g(n + 1, vector<pair<int, int>>());

    int u, v, c1;
    for (int i = 0; i < m; i++) {
        cin >> u >> v >> c1;
        g[u].emplace_back(v, c1);
        g[v].emplace_back(u, c1);
    }

    priority_queue<pair<pair<int, int>, int>> q;
    vector<bool> used(n + 1, false);

    vector<pair<int, int>> dp1(n + 1, {n + 1, MAX_C});
    dp1[1] = {0, MAX_C};

    q.push({{0, -MAX_C}, 1});
    while (!q.empty()) {
        int i;
        i = q.top().second;
        q.pop();
        if (used[i]) {
            continue;
        }
        used[i] = true;
        for (auto[to, c] : g[i]) {
            pair<int, int> new_dp = {dp1[i].first + 1, min(dp1[i].second, c)};
            if (new_dp <= dp1[to]) {
                dp1[to] = new_dp;
                q.push({{-dp1[to].first, -dp1[to].second}, to});
            }
        }
    }

    vector<pair<int, int>> dp2(n + 1, {n + 1, -1});
    dp2[1] = {0, -1};

    used.assign(n + 1, false);
    q.push({{0, -1}, 1});
    while (!q.empty()) {
        int i;
        i = q.top().second;
        q.pop();
        if (used[i]) {
            continue;
        }
        used[i] = true;
        for (auto[to, c] : g[i]) {
            pair<int, int> new_dp = {dp2[i].first + 1, max(dp2[i].second, c)};
            if (new_dp.first < dp2[to].first || (new_dp.first == dp2[to].first && new_dp.second >= dp2[to].second)) {
                dp2[to] = new_dp;
                q.push({{-dp2[to].first, dp2[to].second}, to});
            }
        }
    }

    vector<pair<int, int>> dp(n + 1, {n + 1, 0});
    vector<int> prev(n + 1, -1);
    dp[1] = {0, 0};

    used.assign(n + 1, false);
    q.push({{0, 0}, 1});
    while (!q.empty()) {
        int i;
        i = q.top().second;
        q.pop();
        if (used[i]) {
            continue;
        }
        used[i] = true;
        for (auto[to, c] : g[i]) {
            int diff = max({
                max(0, c - dp1[i].second),
                max(0, dp2[i].second - c),
                dp[i].second
            });
            pair<int, int> new_dp = {dp[i].first + 1, diff};
            if (new_dp.first < dp[to].first || (new_dp.first == dp[to].first && new_dp.second >= dp[to].second)) {
                dp[to] = new_dp;
                prev[to] = i;
                q.push({{-dp[to].first, dp[to].second}, to});
            }
        }
    }

    vector<int> path = {n};
    int cur = prev[n];
    while (cur != -1) {
        path.push_back(cur);
        cur = prev[cur];
    }
    reverse(path.begin(), path.end());

    cout << dp[n].first << endl;
    for (int x : path) {
        cout << x << " ";
    }
    return 0;
}