﻿#include <iostream>
#include <string>
#include <stack>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <deque>
#include <queue>
#include <cmath>

#define int long long
#define fast_io std::ios_base::sync_with_stdio(false); std::cin.tie(0)

struct p{
    int l = 1e9, r = -1, dist = -1;
};

void relax(std::pair<int,int> &from, int w) {
    from.first = std::min(from.first, w);
    from.second = std::max(from.second, w);
}

signed main() {
    fast_io;
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<std::pair<int,int>>> g(n);
    for (int i = 0;i < m; ++i) {
        int x, y, c;
        std::cin >> x >> y >> c;
        x--; y--;
        g[x].push_back({y, c});
        g[y].push_back({x, c});
    }
    std::vector<p> best(n);
    std::queue<int> q;
    best[0] = {0, 0, 0};

    for (auto i:g[0]) {
        q.push(i.first);
        best[i.first] = {i.second, i.second, 1};
    }

    while (!q.empty()) {
        // МБ надо сделать проверку что мы та самая лучшая вершина
        auto v = q.front();
        q.pop();
        for (auto i:g[v]) {
            if (best[i.first].dist == -1 || best[i.first].dist == best[v].dist + 1) {
                best[i.first].dist = best[v].dist + 1;

                std::pair<int,int> from = {best[v].l, best[v].r};
                relax(from, i.second);
                if (best[i.first].r - best[i.first].l < from.second - from.first) {
                    best[i.first].l = from.first;
                    best[i.first].r = from.second;
                }
                q.push(i.first);
            }
        }
    }
    std::vector<int> ans;
    ans.push_back(n);
    int v = n - 1;
    while (best[v].dist != 1) {
        for (auto u : g[v]) {
            if (best[u.first].dist + 1 == best[v].dist) {
                // may be parent
                std::pair<int,int> from = {best[u.first].l, best[u.first].r};
                relax(from, u.second);
                if (from == std::make_pair(best[v].l, best[v].r)) {
                    v = u.first;
                    ans.push_back(v + 1);
                    break;
                }
            }
        }
    }
    ans.push_back(1);
    std::cout << ans.size() - 1 << '\n';
    for (int i = (int)ans.size() - 1; i >=0; --i) {
        std::cout << ans[i] << ' ';
    }
}