#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <queue>
#include <numeric>
#include <map>

using namespace std;

const int INF = 1e9 + 7;

struct edge {
    int to;
    int w;
    edge(int to, int w) : to(to), w(w) {}
};

vector<vector<edge>> a;
int n, m;

vector<int> build_way(int u, int v) {
    vector<int> ans = {v};
    if (u == v) {
        return ans;
    }
    vector<int> pr(n, -1);
    vector<int> used(n);
    queue<int> q;
    q.push(u);
    while (!q.empty()) {
        int vv = q.front();
        q.pop();
        used[vv] = true;
        for (auto x : a[vv]) {
            int uu = x.to;
            int ww = x.w;
            if (used[uu] == false) {
                used[uu] = true;
                q.push(uu);
                pr[uu] = vv;
            }
        }
    }
    int x = v;
    while (pr[x] != -1) {
        ans.push_back(pr[x]);
        x = pr[x];
    }
    reverse(ans.begin(), ans.end());
    return ans;
}
 

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), 
    cout.tie(0);
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < m; i++)
    {
        int x, y, w;
        cin >> x >> y >> w;
        x--;
        y--;
        a[x].push_back(edge(y, w));
        a[y].push_back(edge(x, w));
        if (x == 0 && y == n - 1 || x == n - 1 && y == 0) {
            cout << "1\n1 " << n;
            return 0;
        }
    }
    vector<int> maxx(n, -1), minn(n, INF), dist(n, 0), used(n);
    vector<pair<int, int>> minnn(n), maxxx(n);
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        used[v] = true;
        for (auto x : a[v]) {
            int u = x.to;
            int w = x.w;
            if (used[u] == false) {
                used[u] = true;
                q.push(u);
                dist[u] = dist[v] + 1;
            }
            if (dist[u] == dist[v] + 1) {
                if (w < minn[u]) {
                    minn[u] = w;
                    minnn[u].first = v;
                    minnn[u].second = u;
                }
                if (minn[v] < minn[u]) {
                    minn[u] = minn[v];
                    minnn[u] = minnn[v];
                }
                if (w > maxx[u]) {
                    maxx[u] = w;
                    maxxx[u].first = v;
                    maxxx[u].second = u;
                }
                if (maxx[v] > maxx[u]) {
                    maxxx[u] = maxxx[v];
                    maxxx[u] = maxxx[v];
                }
            } 
        }
    }
    vector<int> maxx2(n, -1), minn2(n, INF), dist2(n, 0), used2(n);
    vector<pair<int, int>> minnn2(n), maxxx2(n);
    queue<int> q2;
    q2.push(n - 1);
    while (!q2.empty()) {
        int v = q2.front();
        // cout << v << endl;
        q2.pop();
        used2[v] = true;
        for (auto x : a[v]) {
            int u = x.to;
            int w = x.w;
            // cout << u << " " << w << endl;
            if (used2[u] == false) {
                used2[u] = true;
                q2.push(u);
                dist2[u] = dist2[v] + 1;
            }
            if (dist2[u] == dist2[v] + 1) {
                if (w < minn2[u]) {
                    minn2[u] = w;
                    minnn2[u].first = v;
                    minnn2[u].second = u;
                }
                if (minn2[v] < minn2[u]) {
                    minn2[u] = minn2[v];
                    minnn2[u] = minnn2[v];
                }
                if (w > maxx2[u]) {
                    maxx2[u] = w;
                    maxxx2[u].first = v;
                    maxxx2[u].second = u;
                }
                if (maxx2[v] > maxx2[u]) {
                    maxxx2[u] = maxxx2[v];
                    maxxx2[u] = maxxx2[v];
                }
            } 
        }
    }
    int ans = 0;
    int answ = 0;
    vector<int> arr;
    for (int i = 1; i < n - 1; i++) {
        if (dist[i] + dist2[i] == dist[n - 1]) {
            if (maxx[i] - minn2[i] >= answ) {
                arr = {0, maxxx[i].first, maxxx[i].second, i, minnn2[i].second, minnn2[i].first, n - 1};
                answ = maxx[i] - minn2[i];
            }
            if (maxx2[i] - minn[i] >= answ) {
                arr = {0, minnn[i].first, minnn[i].second, i, maxxx2[i].second, maxxx2[i].first, n - 1};
                answ = maxx2[i] - minn[i];
            }
        }
    }
    vector<int> answer;
    for (int i = 0; i < arr.size() - 1; i++) {
        // cout << arr[i] << " " << arr[i + 1] << endl;
        vector<int> way = build_way(arr[i], arr[i + 1]);
        for (int u : way) {
            if (answer.size() == 0 || answer.back() != u) {
                answer.push_back(u);
            }
        }
    }
    cout << answer.size() - 1 << "\n";
    for (int u : answer) {
        cout << u + 1 << " ";
    }
}

