funcs = {
        # lmax lmin pl
        (False, False, False): "x 3 - 4 ^ y -5 + 2 ^ +",
        (False, False, True): "1",
        (True, True, False): "-1 x y + ^",
        (True, True, True): "-1 x y + ^ 1 0 x 2 ^ ^ - *",
        (False, True, False): "x 2 ^ y 2 ^ + 2 ^ 1 0 x 5 - 2 ^ y 5 - 2 ^ + ^ - *",
        (False, True, True): "x 2 ^ y 2 ^ + 2 ^ 1 0 x 5 - 2 ^ y 5 - 2 ^ + ^ - * 1 0 x 7 - 2 ^ ^ - *",
        (True, False, False): "x 2 ^ y 2 ^ + 2 ^ 1 0 x 5 - 2 ^ y 5 - 2 ^ + ^ - * -1 *",
        (True, False, True): "x 2 ^ y 2 ^ + 2 ^ 1 0 x 5 - 2 ^ y 5 - 2 ^ + ^ - * 1 0 x 7 - 2 ^ ^ - * -1 *",
}


def eval_polish(formula, x, y):
    stack = []
    for instr in formula.split():
        if instr == "+":
            a = stack.pop()
            b = stack.pop()
            stack.append(b + a)
        elif instr == "-":
            a = stack.pop()
            b = stack.pop()
            stack.append(b - a)
        elif instr == "*":
            a = stack.pop()
            b = stack.pop()
            stack.append(b * a)
        elif instr == "/":
            a = stack.pop()
            b = stack.pop()
            stack.append(b / a)
        elif instr == "^":
            a = stack.pop()
            b = stack.pop()
            if b == -1 and a < 0:
                a = -a
            stack.append(b ** a)
        elif instr == "x":
            stack.append(x)
        elif instr == "y":
            stack.append(y)
        else:
            stack.append(int(instr))
    z = stack.pop()
    assert len(stack) == 0
    return z


def main():
    lmax = "Yes" in input()
    lmin = "Yes" in input()
    pl = "Yes" in input()
    f = funcs[(lmax, lmin, pl)]
    print(f)
    return

    for i in range(-10, 11):
        for j in range(-10, 11):
            print("{: <9}".format(eval_polish(f, i, j)), end="")
        print()


if __name__ == "__main__":
    main()
