funcs = {
        # lmax lmin pl
        (False, False, False): "x 3 - 4 ^ y -5 + 2 ^ +",
        (False, False, True): "1",
        (True, True, False): "-1 x y + 2 ^ ^",
        (True, True, True): "-1 x y + 2 ^ ^ 1 0 x 2 ^ ^ - *",
        (False, True, False): "x 2 ^ y 2 ^ + 2 ^ 1 0 x 5 - 2 ^ y 5 - 2 ^ + ^ - *",
        (False, True, True): "x 2 ^ y 2 ^ + 2 ^ 1 0 x 5 - 2 ^ y 5 - 2 ^ + ^ - * 1 0 x 7 - 2 ^ ^ - *",
        (True, False, False): "x 2 ^ y 2 ^ + 2 ^ 1 0 x 5 - 2 ^ y 5 - 2 ^ + ^ - * -1 *",
        (True, False, True): "x 2 ^ y 2 ^ + 2 ^ 1 0 x 5 - 2 ^ y 5 - 2 ^ + ^ - * 1 0 x 7 - 2 ^ ^ - * -1 *",
}


def eval_polish(formula, x, y):
    stack = []
    for instr in formula.split():
        if instr == "+":
            a = stack.pop()
            b = stack.pop()
            stack.append(b + a)
        elif instr == "-":
            a = stack.pop()
            b = stack.pop()
            stack.append(b - a)
        elif instr == "*":
            a = stack.pop()
            b = stack.pop()
            stack.append(b * a)
        elif instr == "^":
            a = stack.pop()
            b = stack.pop()
            stack.append(b ** a)
        elif instr == "x":
            stack.append(x)
        elif instr == "y":
            stack.append(y)
        else:
            stack.append(int(instr))
    z = stack.pop()
    assert len(stack) == 0
    return z


def has_extrem(f, i, j, sign):
    x = eval_polish(f, i, j)
    for dx, dy in [(0,1), (0,-1), (1,0), (-1,0)]:
        y = eval_polish(f, i+dx, j+dy)
        if y <= x and sign == "min":
            return False
        if y >= x and sign == "max":
            return False
        if x == y and sign == "eq":
            return True
    if sign == "eq":
        return False
    return True


def count(f, sign):
    cnt = 0
    for i in range(-10, 11):
        for j in range(-10, 11):
            if has_extrem(f, i, j, sign):
                cnt += 1
    return cnt >= 2


def main():
    lmax = "Yes" in input()
    lmin = "Yes" in input()
    pl = "Yes" in input()
    f = funcs[(lmax, lmin, pl)]
    print(f)


def amain():
    for k, f in funcs.items():
        print(k == (count(f, "max"), count(f, "min"), count(f, "eq")))


if __name__ == "__main__":
    main()
