#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;

int n, m;
vector<char> grid;
char zero = '.';

int qs = 0;
int fs = 0;

inline char& at(int x, int y) {
    if (x < 0 || y < 0 || x >= m || y >= n) return zero;
    return grid[x + y * m];
}

vector<pair<int, int>> q;

const vector<pair<int, int>> QSHAPE = {
    { 0, 0 },
    { 1, 0 },
    { 2, 0 },
    { 2, 1 },
    { 2, 2 },
    { 2, -1 },
    { 2, -2 },
    { 0, -1 },
    { 0, -2 },
    { 1, -2 },
};

const vector<pair<int, int>> FSHAPE = {
    { 0, 0 },
    { 0, -1 },
    { 0, -2 },
    { 0, -3 },
    { 0, -4 },
    { 1, -4 },
    { 2, -4 },
    { 1, -2 },
};

int main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    cin >> n >> m;
    grid.resize(n * m);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> at(j, i);
            if (at(j, i) == '#') {
                q.emplace_back(j, i);
            }
        }
    }

    sort(q.begin(), q.end(), [&](const auto& lhs, const auto& rhs) {
        if (lhs.first != rhs.first) {
            return lhs.first < rhs.first;
        }
        return lhs.second > rhs.second;
    });

    for (const auto& [x, y] : q) {
        if (at(x, y) != '#') continue;
        bool is_q = true;
        for (const auto& [dx, dy] : QSHAPE) {
            auto nx = dx + x;
            auto ny = dy + y;
            if (at(nx, ny) == '.') {
                is_q = false;
                break;
            }
        }

        for (const auto& [dx, dy] : (is_q ? QSHAPE : FSHAPE)) {
            auto nx = dx + x;
            auto ny = dy + y;
            at(nx, ny) = '.';
        }

        (is_q ? qs : fs)++;
    }

    cout << qs << " " << fs << endl;
    return 0;
}
