#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <set>
#include <cmath>
#include <unordered_map>
#include <cstring>

using namespace std;

typedef long long ll;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g1(n);
    for (int i = 0; i < m; ++i) {
        int v, u, c;
        cin >> v >> u >> c;
        v--, u--;
        g1[v].push_back({u, c});
        g1[u].push_back({v, c});
    }
    vector<int> d(n, -1);
    queue<int> q;
    d[0] = 0;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto p : g1[v]) {
            int u = p.first;
            if (d[u] == -1) {
                d[u] = d[v] + 1;
                q.push(u);
            }
        }
    }
    vector<vector<pair<int, int>>> g2(n), g3(n);
    for (int i = 0; i < n; ++i) {
        for (auto e : g1[i]) {
            int j = e.first;
            if (d[i] + 1 == d[j]) {
                g2[i].push_back(e);
                g3[j].push_back({i, e.second});
            }
        }
    }
    vector<int> dp1(n, -1), dp2(n, -1);
    q.push(0);
    dp1[0] = 0;
    vector<int> p1(n, -1), p2(n, -1);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto e : g2[v]) {
            int u = e.first, c = e.second;
            if (dp1[u] == -1) {
                q.push(u);
            }
            if (max(dp1[v], c) > dp1[u]) {
                dp1[u] = max(dp1[v], c);
                p1[u] = v;
            }
        }
    }
    q.push(n - 1);
    dp2[n - 1] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto e : g3[v]) {
            int u = e.first, c = e.second;
            if (dp2[u] == -1) {
                q.push(u);
            }
            if (max(dp2[v], c) > dp2[u]) {
                dp2[u] = max(dp2[v], c);
                p2[u] = v;
            }
        }
    }
    int maxx = -1, i1 = -1, i2 = -1;
    for (int i = 0; i < n; ++i) {
        for (auto e : g2[i]) {
            int j = e.first;
            if (max(e.second, max(dp1[i], dp2[j])) - e.second > maxx) {
                maxx = max(dp1[i], dp2[j] - e.second);
                i1 = i, i2 = j;
            }
        }
    }
    vector<int> path1, path2;
    int i = i1;
    while (i >= 0) {
        path1.push_back(i);
        i = p1[i];
    }
    i = i2;
    while (i >= 0) {
        path2.push_back(i);
        i = p2[i];
    }
    vector<int> ans;
    reverse(path1.begin(), path1.end());
    for (int x : path1) {
        ans.push_back(x);
    }
    for (int x : path2) {
        ans.push_back(x);
    }
    cout << ans.size() - 1 << '\n';
    for (int x : ans) {
        cout << x + 1 << ' ';
    }
    cout << '\n';
}

bool multitest = false;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //cout.precision(10);
    size_t number_of_tests = 1;
    if (multitest) {
        cin >> number_of_tests;
    }
    for (size_t _ = 0; _ < number_of_tests; ++_) {
        solve();
    }
    return 0;
}