#include <cassert>
#include <utility>
#include <tuple>
#include <iostream>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <set>
#include <sstream>
#include <unordered_map>
#include <map>

using namespace std;
using ll = long long;

//#define int ll

#define pb push_back
#define eb emplace_back
#define agn assign
#define DEBUG(x) cerr << #x << ": " << x << "\n";
#define F first
#define S second

#define BOUNDS_1(x, n) (x >= 0 && x < n)
#define BOUNDS_2(x, n) (x > 0 && x <= n)
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define FOR(i, a, b) for (int i = a; i < b; ++i)

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<double, int> pdi;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<ll> vll;
typedef vector<pii> vpii;
typedef vector<pll> vpll;

const int INF = 1000 * 1000 * 1000 + 10;
//const int M = 1000 * 1000 * 1000 + 7;
const ll INFLL = 1000ll * 1000 * 1000 * 1000 * 1000 * 1000;

const int MOD = 998244353;

struct T {
    int p = 0, m = 0, s = 0;
    int len = 1;
};

const int N = (1 << 19);
//const int N = (1 << 4);
T t[2 * N];

T recalc(T l, T r) {
    T v;
    v.len = l.len + r.len;

    if (l.p == l.len)
        v.p = l.len + r.p;
    else
        v.p = l.p;

    if (r.s == r.len)
        v.s = l.s + r.len;
    else
        v.s = r.s;

    v.m = max(max(l.m, r.m), l.s + r.p);

    return v;
}

void set_v(int v, bool f) {
    v += N;
    t[v].len = 1;

    if (f)
        t[v].p = t[v].s = t[v].m = 1;
    else
        t[v].p = t[v].s = t[v].m = 0;
}

void update(int v, bool f) {
    set_v(v, f);
    v += N;
    for (v /= 2; v; v /= 2)
        t[v] = recalc(t[2 * v], t[2 * v + 1]);
}

void solve() {
    int n, m;
    cin >> n >> m;

    vi a(n);
    for (int &x : a)
        cin >> x;

    vi days;
    for (int x : a)
        days.pb(x / m);
    vi days_2;
    for (int d : days)
        days_2.pb(d + 1);
    for (int d : days_2)
        days.push_back(d);

    sort(ALL(days));
    days.erase(unique(ALL(days)), days.end());

    vi cnt(days.size(), 0);
    map<int, vi> rems;
    vi di(a.size());

    for (int i = 0; i < a.size(); ++i) {
        di[i] = lower_bound(ALL(days), a[i] / m) - days.begin();
        int r = m - a[i] % m;
        if (r < m) rems[r].pb(i);
        ++cnt[di[i]];
    }

    for (int i = 0; i < cnt.size(); ++i)
        update(i, cnt[i] > 0);

    int ms = t[1].m, mt = 0;
    for (auto&[r, inds] : rems) {
        for (int i : inds) {
            assert(days[di[i]] == a[i] / m && days[di[i] + 1] == a[i] / m + 1);
            int cd = di[i];
            int nd = di[i] + 1;

            --cnt[cd];
            update(cd, cnt[cd] > 0);
            ++cnt[nd];
            update(nd, cnt[nd] > 0);
        }

        int s = t[1].m;
        if (s > ms) {
            ms = s, mt = r;
        }
    }

    assert(mt < m);

    for (int i = 0; i < cnt.size(); ++i)
        update(i, false);

    cout << ms << " " << mt << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int T;
    cin >> T;
    while (T--)
        solve();
//    solve();
}

