#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;


struct vertex {
    int w = 0;
    vector <int> sons = vector<int>(26, -1);
};

vector <vertex> g;
vector <int> sz;
int ans = 0;
int n, k;


int dfs(int v) {
    int res = g[v].w;
    for (int son : g[v].sons) {
        if (son != -1) {
            res += dfs(son);
        }
    }
    sz[v] = res;
    return res;
}

void calcans(int v) {
    int szv = g[v].w;
    vector <int> a;
    a.reserve(26);
    if (sz[v] > k) {
        for (int son: g[v].sons) if (son != -1) {
            if (sz[son] > k) {
                calcans(son);
            } else if (sz[son] == k) {
                ans++;
                sz[son] = 0;
            }
            szv += sz[son];
            a.push_back(sz[son]);
        }
    }
    sort(a.rbegin(), a.rend());
    int i = 0;
    while (szv > k) {
        ans++;
        szv -= a[i++];
    }
    sz[v] = szv;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    g.reserve(n);
    g.push_back(vertex());
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        int cur = 0;
        for (int c : s) {
            if (g[cur].sons[c - 'a'] == -1) {
                g[cur].sons[c - 'a'] = g.size();
                cur = g.size();
                g.push_back(vertex());
            } else {
                cur = g[cur].sons[c - 'a'];
            }
        }
        g[cur].w++;
    }
    sz.resize(g.size(), 0);
    dfs(0);
    calcans(0);
    ans += (sz[0] > 0);
    cout << ans;
    return 0;
}