#include <bits/stdc++.h>
       
using namespace std;
       
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
       
#define size(s) (ll)(s).size()
#define all(s) (s).begin(), s.end()
#define rall(s) (s).rbegin(), s.rend()
       
const ll INF = 2e9 + 1;
const ll MOD = 1e9 + 7;
const ll MAXN = 2e6 + 42;
const ld EPS = 1e-12;
const ld PI = acos(-1);
const ll XX[] = {0, 0, 1, -1};
const ll YY[] = {1, -1, 0, 0};
const ll ALPH = 31;
 
mt19937 gen(time(NULL));

void bye() {
    cout << "\n";
    exit(0);
}

struct Edge {
    ll u, v, w;
};

struct Data {
    ll w, mx, mn, idx;
};


struct Solution {
    void solve() {
        ll n, m;

        cin >> n >> m;
        vector<vector<Edge> > g(n);

        for (ll i = 0; i < m; i++) {
            Edge now;

            cin >> now.u >> now.v >> now.w;
            now.u--, now.v--;

            Edge rnow = {now.v, now.u, now.w};
            g[now.u].push_back(now);
            g[now.v].push_back(rnow);
        }

        vector<Data> d(n);
        for (ll i = 0; i < n; i++) {
            d[i] = {INF, 0, INF, i};
        }
        d[0] = {0, 0, INF, 0};
        
        auto cmp = [](const Data &a, const Data &b) {
            return a.w < b.w || (a.w == b.w && a.mx - a.mn > b.mx - b.mn) 
                || (a.w == b.w && a.mx - a.mn == b.mx - b.mn && a.idx < b.idx);
        };

        vector<ll> p(n, -1);

        set<Data, decltype(cmp)> q(cmp);
        q.insert(d[0]);
        while (!q.empty()) {
            ll v = q.begin() -> idx;
            q.erase(q.begin());

            for (auto to : g[v]) {
                Data nw = {d[v].w + 1, max(d[v].mx, to.w), min(d[v].mn, to.w), to.v};
                if (cmp(nw, d[to.v])) {
                    q.erase(d[to.v]);
                    d[to.v] = nw;
                    p[to.v] = v;
                    q.insert(d[to.v]);
                }
            }
        }
        vector<ll> ans;
        ll pr = n - 1;
        while (pr != -1) {
            ans.push_back(pr);
            pr = p[pr];
        }
        reverse(all(ans));

        cout << size(ans) << "\n";

        for (auto v : ans) {
            cout << v + 1 << " ";
        }
    }

};
 
signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll TEST_COUNT = 1;
    // cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}