#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <deque>
#include <queue>

using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");

using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll const inf = 1e18;

random_device rd;
mt19937 mersenne(rd());

ll gcd(ll a, ll b, ll& x, ll& y) // ax + by == gcd
{
	if (b == 0)
	{
		x = 1;
		y = 0;
		return a;
	}
	ll g = gcd(b, a % b, x, y);
	ll xx = y;
	ll yy = x - (a / b) * y;
	x = xx;
	y = yy;
	return g;
}

ll min_solve(ll m, ll k, ll c)
{
	ll x, y;
	ll g = gcd(m, c, x, y);
	if (k % g != 0)
		return -1;

	x *= k / g;
	y *= k / g;
	ll cg = c / g;
	x = (x % cg + cg) % cg;
	return x;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll n, m, c; cin >> n >> m >> c;

	ll ansx = 0, ansy = 0, ans = n;

	for (int i = 0; i <= c; ++i)
	{
		{
			ll x = min_solve(m, n + i, c);
			if (x != -1)
			{
				ll y = (n - m * x + i) / c;
				if (y >= 0)
				{
					if (abs(m * x + c * y - n) < ans)
					{
						ansx = x;
						ansy = y;
						ans = abs(m * x + c * y - n);
					}
				}
			}
		}
		{
			ll x = min_solve(m, n - i, c);
			if (x != -1)
			{
				ll y = (n - m * x - i) / c;
				if (y >= 0)
				{
					if (abs(m * x + c * y - n) < ans)
					{
						ansx = x;
						ansy = y;
						ans = abs(m * x + c * y - n);
					}
				}
			}
		}
		
	}

	cout << ansx << " " << ansy;

	return 0;
}