#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <deque>
#include <queue>

using namespace std;

ifstream fin("input.txt");
ofstream fout("output.txt");

using ll = long long;
using ld = long double;
using ull = unsigned long long;

ll const inf = 1e18;

random_device rd;
mt19937 mersenne(rd());

struct Bor 
{
	struct Node
	{
		ll dp = 0;
		map<char, ll> children;

		Node()
		{

		}
	};

	vector<Node> tree;
	ll root = 0;

	Bor() 
	{
		tree.push_back(Node());
	}

	void add(string s)
	{
		ll node = 0;
		ll i = 0;
		while (true)
		{
			tree[node].dp++;
			if (i == s.size())
			{
				return;
			}
			if (!tree[node].children.count(s[i]))
			{
				tree.push_back(Node());
				tree[node].children[s[i]] = { tree.size() - 1 };
			}
			ll child = tree[node].children[s[i]];
			node = child;
			i = i + 1;
		}
	}
	
	void dfs(ll v, ll k, ll& ans)
	{
		for (auto& u : tree[v].children)
		{
			if (tree[u.second].dp > k)
				dfs(u.second, k, ans);
		}
		vector<ll> c;
		ll sum = 0;
		for (auto& u : tree[v].children)
		{
			c.push_back( -tree[u.second].dp );
			sum += tree[u.second].dp;
		}
		sort(c.begin(), c.end());
		ll i = 0;
		while (sum > k)
		{
			sum += c[i];
			if (c[i] != 0)
				++ans;
			++i;
		}
		tree[v].dp = sum;
		if (v == 0 && tree[v].dp > 0)
		{
			++ans;
		}
	}

};

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll n, k; cin >> n >> k;
	Bor bor;

	for (int i = 0; i < n; ++i)
	{
		string s; cin >> s;
		bor.add(s);
	}
	ll ans = 0;
	vector<ll> del(bor.tree.size(), 0);
	bor.dfs(0, k, ans);
	cout << ans << '\n';

	return 0;
}