#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, m, v, u, c, INF = 2'000'000'000;
    cin >> n >> m;
    vector<pair<int, int>> edges[n];
    bool easy_win = false;
    for (int i = 0; i < m; ++i) {
        cin >> v >> u >> c;
        edges[v - 1].push_back(make_pair(u - 1, c));
        edges[u - 1].push_back(make_pair(v - 1, c));
        if (v == 1 && u == n || v == n && u == 1)
            easy_win = true;
    }

    if (easy_win) {
        cout << 1 << endl << 1 << ' ' << n;
        return 0;
    }

    queue<pair<int, pair<int, int>>> que_max; // v, par_v, c;
    queue<pair<int, pair<int, int>>> que_min;
    queue<pair<int, pair<int, int>>> rev_que_max;
    queue<pair<int, pair<int, int>>> rev_que_min;

    que_max.push(make_pair(0, make_pair(0, -1)));
    que_min.push(make_pair(0, make_pair(0, INF)));
    rev_que_max.push(make_pair(n - 1, make_pair(n - 1, -1)));
    rev_que_min.push(make_pair(n - 1, make_pair(n - 1, INF)));

    vector<int> par_max(n, -1);
    vector<int> par_min(n, -1);
    vector<int> rev_par_max(n, -1);
    vector<int> rev_par_min(n, -1);

    vector<int> col_max(n, -1);
    vector<int> col_min(n, INF);
    vector<int> rev_col_max(n, -1);
    vector<int> rev_col_min(n, INF);

    vector<int> len_max(n, INF);
    vector<int> len_min(n, INF);
    vector<int> rev_len_max(n, INF);
    vector<int> rev_len_min(n, INF);

    len_max[0] = 0;
    len_min[0] = 0;
    rev_len_max[n - 1] = 0;
    rev_len_min[n - 1] = 0;

    while (!que_max.empty()) {
        auto el = que_max.front();
        que_max.pop();
        v = el.first, u = el.second.first, c = el.second.second;
        if (col_max[v] < max(col_max[u], c) && len_max[u] < len_max[v]) {
            par_max[v] = u;
            col_max[v] = max(col_max[u], c);
            len_max[v] = len_max[u] + 1;
        }

        for (auto edge : edges[v]) {
            u = edge.first, c = edge.second;
            if (len_max[u] == INF) {
                que_max.push(make_pair(u, make_pair(v, c)));
            }
        }
    }

    while (!que_min.empty()) {
        auto el = que_min.front();
        que_min.pop();
        v = el.first, u = el.second.first, c = el.second.second;
        if (col_min[v] > min(col_min[u], c) && len_min[u] < len_min[v]) {
            par_min[v] = u;
            col_min[v] = min(col_min[u], c);
            len_min[v] = len_min[u] + 1;
        }

        for (auto edge : edges[v]) {
            u = edge.first, c = edge.second;
            if (len_min[u] == INF) {
                que_min.push(make_pair(u, make_pair(v, c)));
            }
        }
    }

    while (!rev_que_max.empty()) {
        auto el = rev_que_max.front();
        rev_que_max.pop();
        v = el.first, u = el.second.first, c = el.second.second;
        if (rev_col_max[v] < max(rev_col_max[u], c) && rev_len_max[u] < rev_len_max[v]) {
            rev_par_max[v] = u;
            rev_col_max[v] = max(rev_col_max[u], c);
            rev_len_max[v] = rev_len_max[u] + 1;
        }

        for (auto edge : edges[v]) {
            u = edge.first, c = edge.second;
            if (rev_len_max[u] == INF) {
                rev_que_max.push(make_pair(u, make_pair(v, c)));
            }
        }
    }

    while (!rev_que_min.empty()) {
        auto el = rev_que_min.front();
        rev_que_min.pop();
        v = el.first, u = el.second.first, c = el.second.second;
        if (rev_col_min[v] > min(rev_col_min[u], c) && rev_len_min[u] < rev_len_min[v]) {
            rev_par_min[v] = u;
            rev_col_min[v] = min(rev_col_min[u], c);
            rev_len_min[v] = rev_len_min[u] + 1;
        }

        for (auto edge : edges[v]) {
            u = edge.first, c = edge.second;
            if (rev_len_min[u] == INF) {
                rev_que_min.push(make_pair(u, make_pair(v, c)));
            }
        }
    }

    int ans = -1, ans_len = INF, ans_col = -1;
    bool max_rev_min = true; // true: max + rev_min
    for (int i = 1; i < n - 1; ++i) {
        if (len_max[i] + rev_len_min[i] < ans_len ||
            len_max[i] + rev_len_min[i] == ans_len && ans_col < col_max[i] - rev_col_min[i]) {
            ans = i;
            ans_len = len_max[i] + rev_len_min[i];
            ans_col = col_max[i] - rev_col_min[i];
            max_rev_min = true;
        }

        if (len_min[i] + rev_len_max[i] < ans_len ||
            len_min[i] + rev_len_max[i] == ans_len && ans_col < rev_col_max[i] - col_min[i]) {
            ans = i;
            ans_len = len_min[i] + rev_len_max[i];
            ans_col = rev_col_max[i] - col_min[i];
            max_rev_min = false;
        }
    }

    vector<int> ans_vec;
    if (max_rev_min) {
        int i = ans;
        while (par_max[i] != i && par_max[i] != -1) {
            ans_vec.push_back(i);
            i = par_max[i];
        }
        reverse(ans_vec.begin(), ans_vec.end());
        ans_vec.pop_back();
        i = ans;
        while (rev_par_min[i] != i && rev_par_min[i] != -1) {
            ans_vec.push_back(i);
            i = rev_par_min[i];
        }
    }
    else {
        int i = ans;
        while (par_min[i] != i && par_min[i] != -1) {
            ans_vec.push_back(i + 1);
            i = par_min[i];
        }
        ans_vec.push_back(1);
        reverse(ans_vec.begin(), ans_vec.end());
        i = ans;
        while (rev_par_max[i] != i && rev_par_max[i] != -1) {
            i = rev_par_max[i];
            ans_vec.push_back(i + 1);
        }
    }

    cout << ans_len << endl;
    for (int el : ans_vec) {
        cout << el << ' ';
    }
    return 0;
}
