#include <bits/stdc++.h>
using namespace std;

const int MAXALPH = 512;
const int MAXN = 2e6;
const int ROOT = 1;

struct Vertex {
  int prev;
  int count;
  int next[MAXALPH];
};

Vertex trie[MAXN];
int ptr = ROOT + 1;

void add(const string &s) {
  int current = ROOT;
  for (char edge : s) {
    if (!trie[current].next[edge]) {
      trie[ptr] = Vertex{current, 0};
      trie[current].next[edge] = ptr;
      ptr++;
    }
    trie[current].count++;
    current = trie[current].next[edge];
  }
  trie[current].count++;
}

int find(int k, int vertex = ROOT) {
  if (trie[vertex].count <= k) {
    return vertex;
  }
  int best = -1;
  for (int next_v : trie[vertex].next) {
    if (!next_v) {
      continue;
    }
    if (int tmp = find(k, next_v); best == -1 || trie[best].count < trie[tmp].count) {
      best = tmp;
    }
  }
  return best;
}

void clean_up(int vertex, int to_subtract) {
  int current = vertex;
  while (current) {
    trie[current].count -= to_subtract;
    current = trie[current].prev;
  }
}

void run() {
  int n;
  int k;
  cin >> n >> k;
  for (int i = 0; i < n; i++) {
    string s;
    cin >> s;
    add(s);
  }
  int answer = 0;
  while (trie[ROOT].count) {
    auto tmp = find(k);
    clean_up(tmp, trie[tmp].count);
    answer++;
  }
  cout << answer << '\n';
}

signed main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(16);
  run();
  return 0;
}