#include <iostream>
#include <vector>
#include <set>
using namespace std;

struct Vertex {
    static const int ALPHABET = 26;
    vector <size_t> next;
    multiset<int, greater<>> sort_counts;
    bool isEnd;
    int count;
    Vertex() : next(ALPHABET, -1), isEnd(false), count(0), sort_counts() { }
};
vector<bool> ans;
vector <Vertex> bor(1);
int root = 0;
int k;

void add(const string& s) {
    size_t v = root;
    for (int x : s) {
        bor[v].count++;
        if (bor[v].next[x - 'a'] == -1) {
            bor.emplace_back();
            bor[v].next[x - 'a'] = bor.size() - 1;
        }
        v = bor[v].next[x - 'a'];
    }
    bor[v].count++;
    bor[v].isEnd = true;
}

void make_set(size_t v){
    for (size_t u : bor[v].next){
        if (u == -1) { continue; }
        if (bor[u].count <= k){
            bor[v].sort_counts.insert(bor[u].count);
        }
        else{
            make_set(u);
        }
    }
}

int dfs(size_t v){
    int res = 0;
    for (size_t u : bor[v].next){
        if (u == -1 || bor[u].count <= k) { continue; }
//        cout << "!";
        bor[v].count -= bor[u].count;
        res += dfs(u);
    }
//    cout << "count: " << bor[v].count << " k=" << k << "\n";
    for (int x : bor[v].sort_counts){
//        cout << x << " ";
        if (bor[v].count <= k){
            ++res;
            break;
        }
        bor[v].count -= x;
        ++res;
    }
//    cout << "\n";
    bor[v].count = 0;
    return res;
}

int main() {
    int n;
    cin >> n >> k;
    string s;
    for (int i = 0; i < n; ++i){
        cin >> s;
        add(s);
    }
    make_set(root);
    cout << dfs(root) << "\n";
    return 0;
}
