// @author: noisegain

fun main() {
    class Node(val c: Char) {
        val child = arrayOfNulls<Node>(26)
        var size = 0
        var flag = 0


        fun add(c: Int): Node {
            child[c] = Node('a' + c)
            return child[c]!!
        }

        fun add(s: String) {
            var cur = this
            for (c in s) {
                cur = cur.child[c - 'a'] ?: cur.add(c - 'a')
            }
            cur.flag++
            cur.size = flag
        }

        fun update() {
            size = flag
            for (x in child) {
                x?.update()
                size += x?.size ?: 0
            }
        }
    }

    val root = Node('0')
    var ans = 0
    val (n, k) = readInts(2)
    readLines(n).forEach(root::add)
    root.update()

    fun dfs(node: Node) {
        for (i in 0..25) {
            if ((node.child[i]?.size ?: 0) > k) {
                node.size -= node.child[i]!!.size
                dfs(node.child[i]!!)
                node.size += node.child[i]!!.size
            }
            if (node.child[i]?.size == k) {
                node.child[i] = null
                node.size -= k
                ans++
            }
        }
        val a = mutableListOf<Pair<Int, Int>>()
        node.child.forEachIndexed { i, x ->
            if (x != null) {
                a.add(x.size to i)
            }
        }
        a.sortBy { it.first }
        while (node.size > k) {
            node.size -= a.last().first
            node.child[a.last().second] = null
            ans++
        }
    }

    dfs(root)
    if (root.size > 0) ans++
    println(ans)
}

private fun <E> List<E>.toPair(): Pair<E, E> = Pair(this[0], this[1])

fun maxOf(ans: Pair<Int, Int>, b: Pair<Int, Int>): Pair<Int, Int> =
    if (ans.first > b.first || ans.first == b.first && ans.second > b.second) ans else b

private fun <T1 : Comparable<T1>, T2 : Comparable<T2>> pairCmp(): Comparator<Pair<T1, T2>> =
    Comparator { a, b ->
        val res = a.first.compareTo(b.first)
        if (res == 0) a.second.compareTo(b.second) else res
    }


val INPUT = System.`in`
const val BUFFER_SIZE = 1 shl 16
val buffer = ByteArray(BUFFER_SIZE)
var bufferPt = 0
var bytesRead = 0

tailrec fun readChar(): Char {
    if (bufferPt == bytesRead) {
        bufferPt = 0
        bytesRead = INPUT.read(buffer, 0, BUFFER_SIZE)
    }
    return if (bytesRead < 0) Char.MIN_VALUE
    else {
        val c = buffer[bufferPt++].toChar()
        if (c == '\r') readChar()
        else c
    }
}


fun readLine(): String? {
    var c = readChar()
    return if (c == Char.MIN_VALUE) null
    else buildString {
        while (true) {
            when (c) {
                '\n', Char.MIN_VALUE -> return@buildString
                else -> {
                    append(c)
                    c = readChar()
                }
            }
        }
    }
}

fun readLn() = readLine()!!

fun read() = buildString {
    var c = readChar()
    while (c <= ' ') {
        if (c == Char.MIN_VALUE) return@buildString
        c = readChar()
    }
    do {
        append(c)
        c = readChar()
    } while (c > ' ')
}

fun readInt() = read().toInt()
fun readDouble() = read().toDouble()
fun readLong() = read().toLong()
fun readStrings(n: Int) = List(n) { read() }
fun readLines(n: Int) = List(n) { readLn() }
fun readInts(n: Int) = List(n) { read().toInt() }
fun readIntArray(n: Int) = IntArray(n) { read().toInt() }
fun readDoubles(n: Int) = List(n) { read().toDouble() }
fun readDoubleArray(n: Int) = DoubleArray(n) { read().toDouble() }
fun readLongs(n: Int) = List(n) { read().toLong() }
fun readLongArray(n: Int) = LongArray(n) { read().toLong() }
private fun println(x: Any?) = print("$x\n")
private fun printm(vararg x: Any?) = println(x.joinToString(" "))