#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <queue>
#include <set>
#include <bitset>

//#pragma warning(disable : 4996)

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define ff first
#define ss second

const int maxn = 1e6 + 13;
const int INF = 3e18 + 1;
const int MOD = 1e9 + 7;// 1e9 + 9, 1e9 + 21, 1e9 + 33, 1e9 + 321

struct uvc {
	int u, v, c;
};

vector<pair<int, int>> gr[maxn];
vector<pair<int, int>> gr2[maxn];
bool ok[maxn];
uvc toNmin[maxn];
uvc to1min[maxn];
uvc toNmax[maxn];
uvc to1max[maxn];
int dist[maxn];

vector<int> getWay(int u, int v, int n) {
	if (u == v) return { u };
	queue<int> q;
	q.push(u);
	vector<int> par(n + 1);
	vector<bool> ok(n + 1);
	par[u] = u;
	while (!q.empty()) {
		int vv = q.front();
		q.pop();
		ok[vv] = 1;
		for (auto t : gr2[vv]) {
			if (ok[t.first])continue;
			q.push(t.first);
			par[t.first] = vv;
		}
	}
	vector<int> res;
	int e = v;
	while (par[e] != e) {
		res.push_back(e);
		e = par[e];
	}
	res.push_back(u);
	reverse(all(res));
	return res;
}

void printWay(pair<int, int> u1, pair<int, int> u2, int n) {
	if (u1 == u2) {
		vector<int> w1 = getWay(1, u1.first, n);
		vector<int> w2 = getWay(u1.second, n, n);
		cout << w1.size() + w2.size() - 1 << "\n";
		for (auto t : w1)cout << t << " ";
		for (auto t : w2)cout << t << " ";
		return;
	}
	vector<int> w1 = getWay(1, u1.first, n);
	vector<int> w2 = getWay(u1.second, u2.first, n);
	vector<int> w3 = getWay(u2.second, n, n);
	cout << w1.size() + w2.size() + w3.size() - 1 << "\n";
	for (auto t : w1)cout << t << " ";
	for (auto t : w2)cout << t << " ";
	for (auto t : w3)cout << t << " ";
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	
	int n, m;
	cin >> n >> m;
	
	for (int i = 1; i <= m; ++i) {
		int u, v, c;
		cin >> u >> v >> c;
		gr[u].push_back({ v, c });
		gr[v].push_back({ u, c });
	}
	queue<int> q;
	q.push(1);
	fill(dist, dist + n + 1, INF);
	dist[1] = 0;
	while (!q.empty()) {
		int v = q.front();
		ok[v] = 1;
		q.pop();
		for (auto t : gr[v]) {
			if (ok[t.first])continue;
			dist[t.first] = dist[v] + 1;
			q.push(t.first);
			ok[t.first] = 1;
		}
	}

	set<int> st, st2;
	int dst = dist[n] - 1;
	st.insert(n);
	while (dst >= 0) {
		for (auto t : st) {
			for (auto u : gr[t]) {
				if (dst != dist[u.first])continue;
				gr2[u.first].push_back({t, u.second});
				gr2[t].push_back(u);
				st2.insert(u.first);
			}
		}
		swap(st, st2);
		st2.clear();
		dst--;
	}
	st.clear();
	st.insert(n);
	st2.clear();
	fill(ok, ok + n + 1, 0);
	for (int i = 1; i <= n; ++i)
		to1min[i] = { INF, INF, INF }, toNmin[i] = { INF, INF, INF};

	while (!st.empty()) {
		for (auto t : st) {
			for (auto u : gr2[t]) {
				if (dist[u.first] >= dist[t])continue;
				st2.insert(u.first);
				toNmin[u.first] = toNmin[t];
				if (u.second < toNmin[u.first].c) {
					toNmin[u.first] = {u.first, t, u.second};
				}
				toNmax[u.first] = toNmax[t];
				if (u.second > toNmax[u.first].c) {
					toNmax[u.first] = { u.first, t, u.second };
				}
			}
		}
		swap(st, st2);
		st2.clear();
	}
	st.insert(1);
	while (!st.empty()) {
		for (auto t : st) {
			for (auto u : gr2[t]) {
				if (dist[u.first] <= dist[t])continue;
				st2.insert(u.first);
				to1min[u.first] = to1min[t];
				if (u.second < to1min[u.first].c) {
					to1min[u.first] = { t, u.first, u.second };
				}
				to1max[u.first] = to1max[t];
				if (u.second > to1max[u.first].c) {
					to1max[u.first] = { t, u.first, u.second };
				}
			}
		}
		swap(st, st2);
		st2.clear();
	}

	if (dist[n] == 1) {
		cout << "1\n1 " << n;
		return 0;
	}

	

	int maxd = -INF;
	for (int i = 2; i < n; ++i) {
		maxd = max(maxd, toNmax[i].c - to1min[i].c);
		maxd = max(maxd, to1max[i].c - toNmin[i].c);
	}

	for (int i = 2; i < n; ++i) {
		if (toNmax[i].c - to1min[i].c == maxd) {
			printWay({to1min[i].u, to1min[i].v}, {toNmax[i].u, toNmax[i].v}, n);
			return 0;
		}
		if (to1max[i].c - toNmin[i].c == maxd){
			printWay({ to1max[i].u, to1max[i].v }, { toNmin[i].u, toNmin[i].v }, n);
			return 0;
		}
	}

	return 0;
}