#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")

/** Fast input-output */
 
template <class T = int> inline T readInt();
inline double readDouble();
inline int readUInt();
inline int readChar(); // first non-blank character
inline void readWord( std::string &s );
inline bool readLine( char *s ); // do not save '\n'
inline bool isEof();
inline int getChar();
inline int peekChar();
inline bool seekEof();
inline void skipBlanks();
 
template <class T> inline void writeInt( T x, char end = 0, int len = -1 );
inline void writeChar( int x );
inline void writeWord( const char *s );
inline void writeDouble( double x, int len = 0 );
inline void flush();
 
static struct buffer_flusher_t {
    ~buffer_flusher_t() {
        flush();
    }
} buffer_flusher;
 
/** Read */
 
static const int buf_size = 4096;

static unsigned char buf[buf_size];
static int buf_len = 0, buf_pos = 0;
 
inline bool isEof() {
    if (buf_pos == buf_len) {
        buf_pos = 0, buf_len = fread(buf, 1, buf_size, stdin);
        if (buf_pos == buf_len)
            return 1;
    }
    return 0;
}
 
inline int getChar() {
    return isEof() ? -1 : buf[buf_pos++];
}
 
inline int peekChar() {
    return isEof() ? -1 : buf[buf_pos];
}
 
inline bool seekEof() {
    int c;
    while ((c = peekChar()) != -1 && c <= 32)
        buf_pos++;
    return c == -1;
}
 
inline void skipBlanks() {
    while (!isEof() && buf[buf_pos] <= 32U)
        buf_pos++;
}
 
inline int readChar() {
    int c = getChar();
    while (c != -1 && c <= 32)
        c = getChar();
    return c;
}
 
inline int readUInt() {
    int c = readChar(), x = 0;
    while ('0' <= c && c <= '9')
        x = x * 10 + c - '0', c = getChar();
    return x;
}
 
template <class T>
inline T readInt() {
    int s = 1, c = readChar();
    T x = 0;
    if (c == '-')
        s = -1, c = getChar();
    else if (c == '+')
        c = getChar();
    while ('0' <= c && c <= '9')
        x = x * 10 + c - '0', c = getChar();
    return s == 1 ? x : -x;
}
 
inline double readDouble() {
    int s = 1, c = readChar();
    double x = 0;
    if (c == '-')
        s = -1, c = getChar();
    while ('0' <= c && c <= '9')
        x = x * 10 + c - '0', c = getChar();
    if (c == '.') {
        c = getChar();
        double coef = 1;
        while ('0' <= c && c <= '9')
            x += (c - '0') * (coef *= 1e-1), c = getChar();
    }
    return s == 1 ? x : -x;
}
 
inline void readWord( std::string &s ) {
    int c = readChar();
    while (c > 32)
        s.push_back(c), c = getChar();
}
 
inline bool readLine( char *s ) {
    int c = getChar();
    while (c != '\n' && c != -1 && c != ' ')
        *s++ = c, c = getChar();
    *s = 0;
    return c != -1;
}
 
/** Write */
 
static int write_buf_pos = 0;
static char write_buf[buf_size];
 
inline void writeChar( int x ) {
    if (write_buf_pos == buf_size)
        fwrite(write_buf, 1, buf_size, stdout), write_buf_pos = 0;
    write_buf[write_buf_pos++] = x;
}
 
inline void flush() {
    if (write_buf_pos) {
        fwrite(write_buf, 1, write_buf_pos, stdout), write_buf_pos = 0;
        fflush(stdout);
    }
}
 
template <class T>
inline void writeInt( T x, char end, int output_len ) {
    if (x < 0)
        writeChar('-'), x = -x;
 
    char s[24];
    int n = 0;
    while (x || !n)
        s[n++] = '0' + x % 10, x /= 10;
    while (n < output_len)
        s[n++] = '0';
    while (n--)
        writeChar(s[n]);
    if (end)
        writeChar(end);
}
 
inline void writeWord( const char *s ) {
    while (*s)
        writeChar(*s++);
}
 
inline void writeDouble( double x, int output_len ) {
    if (x < 0)
        writeChar('-'), x = -x;
    assert(x <= (1LLU << 63) - 1);
    long long t = (long long)x;
    writeInt(t), x -= t;
    writeChar('.');
    for (int i = output_len - 1; i > 0; i--) {
        x *= 10;
        t = std::min(9, (int)x);
        writeChar('0' + t), x -= t;
    }
    x *= 10;
    t = std::min(9, (int)(x + 0.5));
    writeChar('0' + t);
}
 
using namespace std;
 
#define se second
#define fi first
 
typedef long long ll;
typedef long double ld;
 
long long T(long long n){ return n * (n + 1) >> 1; }
long long MOD(long long a, long long mod){ return (a % mod + mod) % mod; }
long long gcd(long long a, long long b) { return (b == 0 ? a : gcd(b, a % b)); }
 
long long fpow(long long a, long long b, long long mod){
    if(b == 0)
        return 1;
    if(b == 1)
        return a;
    if(b & 1)
        return fpow(a, b ^ 1, mod) * a % mod;
 
    long long res = fpow(a, b >> 1, mod);
    return res * res % mod;
}
 
long long fpow(long long a, long long b){
    if(b == 0)
        return 1;
    if(b == 1)
        return a;
    if(b & 1)
        return fpow(a, b ^ 1) * a;
 
    long long res = fpow(a, b >> 1);
    return res * res;
}
 
const int mod = 1e9 + 7;
const int mod2 = 998244353;
const int INF32 = 2e9;
const int SZ = 50'001;
const long long INF64 = 4e18;
const long double eps = 1e-6;

long long Solve1(long long n){
    vector<long long> a;

    for(int i = 1; i <= n - 1; i++)
        if(gcd(i, n) == 1)
            a.push_back(i);

    return a[(a.size() - 1) / 2];
}

void Solve(){
    long long n; cin >> n;

    for(long long i = n / 2; ; i--)
        if(gcd(i, n) == 1){
            cout << i << '\n';
            return;
        }
}

signed main(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
    srand(time(NULL));
    cout << fixed << setprecision(10);
 
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
 
    int test = 1;
    cin >> test;
 
    for(int i = 1; i <= test; i++){
        Solve();
    }
}