#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <queue>

using namespace std;

using ll = long long;
const int INF = (1e9 + 7);
const int N = 1e5 + 7;

struct node {
  int mx = -INF, mn = INF, opt = 0, opt_prev = -1;
};

node nds[N];
vector<int> layers[N];
vector<pair<int, int>> g[N];

void solver(int n) {
  int s = 0;
  queue<int> q;
  vector<int> d(n, INF);
  d[s] = 0;
  q.push(s);
  while (!q.empty()) {
    int from = q.front();
    if (from == n - 1) {
//      cout << "FOUND OK\n";
      break;
    }
//    cout << "process: id:" << from+1 << "\n";
    q.pop();
    for (auto [to, w] : g[from]) {
//      cout << "process_neighbour: id:" << to+1 << '\n';
      if (d[to] > d[from] + 1) {
//        cout << "GOOD\n";
        d[to] = d[from] + 1;
        q.push(to);
      }
    }
  }
  for (int i = 0; i < n; i++) {
//    cout << "ID:" << i+1 << " ";
//    cout << "d:" << d[i] << "\n";
    if (d[i] != INF) {
      layers[d[i]].push_back(i);
    }
  }
  for (int i = 1; !layers[i].empty(); i++) {
    for (int v : layers[i]) {
//      cout << "PROCESS: id:" << v + 1 << "\n";
      for (auto [u, w] : g[v]) {
        if (d[u] != d[v] - 1) {
          continue;
        }
//        cout << "process_next: id:" << u + 1 << " val:" << w << "\n";

        nds[v].mx = max(nds[v].mx, w);
        nds[v].mx = max(nds[v].mx, nds[u].mx);

        nds[v].mn = min(nds[v].mn, w);
        nds[v].mn = min(nds[v].mn, nds[u].mn);

        if (nds[v].opt < nds[u].opt) {
          nds[v].opt_prev = u;
          nds[v].opt = nds[u].opt;
        }

        if (nds[v].opt < nds[u].mx - w) {
          nds[v].opt_prev = u;
          nds[v].opt = nds[u].mx - w;
        }

        if (nds[v].opt < w - nds[u].mn) {
          nds[v].opt_prev = u;
          nds[v].opt = w - nds[u].mn;
        }
      }
    }
  }

//  cout << "DEBUG:\n";
//  for (int i = 0; i < n; i++) {
//    cout << "\tID:" << i + 1 << " max:" << nds[i].mx << " min:" << nds[i].mn << " opt:"
//         << nds[i].opt << " prev:" << nds[i].opt_prev + 1 << "\n";
//  }

  int cur = n-1;
  vector<int> path;
  while (cur != -1) {
    path.push_back(cur);
    cur = nds[cur].opt_prev;
  }
  path.push_back(0);
  std::reverse(path.begin(), path.end());
  cout << path.size()-1 << '\n';
  for (auto x : path) {
    cout << x+1 << ' ';
  }
  cout << "\n";
}


signed main() {
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; i++) {
    int a, b, w;
    cin >> a >> b >> w;
    --a, --b;
    g[a].emplace_back(b, w);
    g[b].emplace_back(a, w);
  }
  solver(n);

}
/*
 */
