#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <ctime>
#include <algorithm>
#include <random>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <chrono>
#include <cassert>
#include <cstdint>
#include <cstddef>
#include <utility>
#include <functional>
#include <stdexcept>

#define FILE 0
#define RANDOM 0

using namespace std;

#if RANDOM
const unsigned seed = (unsigned)chrono::system_clock::now().time_since_epoch().count();
mt19937 rnd(seed);
#endif

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef ll typ;
typedef unsigned int ui;

const int N = 1e5 + 10, K = 26, M = 110;
const ll INF = 5e18 + 3;
const ld EPS = 5e-7, PI = acos(-1);
const int MOD = 998244353, INFI = 2e9 + 7, SQ = 50;
const ull A = 239, P = 1e9 + 9;

int t, k, s[M], x[N], u[N], r[N];
string v[N];
vector<int> g[N];
map<string, int> threads[M], final;
vector<int> ans;

void dfs(int v) {
    u[v] = 1;
    for (auto to : g[v]) {
        if (u[to] == 1) {
            cout << "No" << endl;
            exit(0);
        } else if (u[to] == 0) {
            dfs(to);
        }
    }
    u[v] = 2;
    ans.push_back(r[v]);
}

int get(int i, const string &var) {
    return (threads[i].find(var) == threads[i].end() ? -1 : threads[i][var]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#if FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> t;
    for (int i = 0; i < t; i++) {
        int l;
        cin >> l;
        s[i + 1] = s[i] + l;
        for (int j = 0; j < l; j++) {
            int p = s[i] + j;
            r[p] = i + 1;
            if (j > 0) {
                g[p - 1].push_back(p);
            }
            char c;
            while (true) {
                cin >> c;
                if (c == '=') {
                    break;
                }
                v[p].push_back(c);
            }
            cin >> x[p];
            threads[i][v[p]] = p;
        }
    }
    cin >> k;
    for (int i = 0; i < k; i++) {
        string var;
        int val;
        cin >> var >> val;
        final[var] = val;
    }
    for (auto [var, val] : final) {
        bool f = false;
        for (int i = 0; i < t; i++) {
            int p = get(i, var);
            if (x[p] == val) {
                f = true;
                for (int j = 0; j < t; j++) {
                    if (j != i) {
                        int q = get(j, var);
                        if (x[q] != val) {
                            g[q].push_back(p);
                        }
                    }
                }
            }
        }
        if (!f) {
            cout << "No" << endl;
            return 0;
        }
    }
    for (int i = 0; i < s[t]; i++) {
        if (u[i] == 0) {
            dfs(i);
        }
    }
    cout << "Yes" << endl;
    for (int i = s[t] - 1; i >= 0; i--) {
        cout << ans[i] << ' ';
    }
    cout << endl;

#if FILE
    fclose(stdin);
    fclose(stdout);
#endif

    return 0;
}