// #pragma GCC optimize("O3", "unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,lzcnt,abm,bmi,bmi2,mmx,avx,avx2,fma")

// #include <bits/stdc++.h>

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

// #define int long long

struct Trie {
    struct Node {
        int children[26];
        int size;
        int left_size;

        Node() {
            for (int i = 0; i < 26; ++i) {
                children[i] = -1;
            }
            size = 0;
            left_size = 0;
        }
    };

    vector <Node> all_nodes;

    Trie() {
        all_nodes.push_back(Node());
    }

    void add(string s) {
        int vi = 0;
        for (char c : s) {
            all_nodes[vi].size += 1;
            if (all_nodes[vi].children[c - 'a'] == -1) {
                all_nodes.push_back(Node());
                all_nodes[vi].children[c - 'a'] = all_nodes.size() - 1;
            }
            vi = all_nodes[vi].children[c - 'a'];
        }
        all_nodes[vi].size += 1;
    }

    int calc_dp(map <int, int> &dp, int new_size, int new_value, int size, int k, int max_size) {
        int temp = -1;
        if (new_size >= size - k) {
            temp = new_size;
            new_size = size - k;
        }
        new_size = -new_size;
        int prev_op = 1000000000;
        if (dp.count(new_size)) {
            prev_op = dp[new_size];
        }
        dp[new_size] = min(prev_op, new_value);
        if (prev_op > new_value && temp != -1) {
            max_size = temp;
        } else if (prev_op == new_value && temp != -1) {
            max_size = max(max_size, temp);
        }
        return max_size;
    }

    int calc(int vi, int k) {
        int size = all_nodes[vi].size;
        map <int, int> dp;
        dp[0] = 0;
        for (int childi : all_nodes[vi].children) {
            if (childi == -1) continue;
            int child_size = all_nodes[childi].size, child_op = calc(childi, k);
            for (auto [s1, op1] : dp) {
                all_nodes[vi].left_size = calc_dp(dp, -s1 + child_size, op1 + child_op + 1, size, k, all_nodes[vi].left_size);
                all_nodes[vi].left_size = calc_dp(dp, -s1 + all_nodes[childi].left_size, op1 + child_op, size, k, all_nodes[vi].left_size);
            }
        }
        return dp[-(size - k)];
    }
};

signed main() {
    // #ifdef LOCAL
    //     freopen("input.txt", "r", stdin);
    //     freopen("output.txt", "w", stdout);
    // #endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    int n, k;
    cin >> n >> k;
    Trie t;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        t.add(s);
    }
    int res = t.calc(0, k);
    if (t.all_nodes[0].left_size == n) {
        cout << res;
    } else {
        cout << res + 1;
    }
}