// #pragma GCC optimize("O3", "unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,lzcnt,abm,bmi,bmi2,mmx,avx,avx2,fma")

// #include <bits/stdc++.h>

#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <map>

using namespace std;

// #define int long long

bool result = false;

void dfs(int u, int p, vector <vector <int>> &graph, vector <bool> &visited, vector <int> order) {
    visited[u] = true;
    for (int v : graph[u]) {
        if (visited[v] && v != p) result = true;
        if (!visited[v]) {
            dfs(v, u, graph, visited, order);
        }
    }
    order.push_back(u);
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    int t;
    cin >> t;
    vector <vector <pair <string, int>>> threads(t);
    int n = 0;
    for (int i = 0; i < t; ++i) {
        int l;
        cin >> l;
        n += l;
        for (int j = 0; j < l; ++j) {
            string input;
            cin >> input;
            int pos = input.find('=');
            string var = input.substr(0, pos);
            int val = stoi(input.substr(pos + 1));
            threads[i].push_back({var, val});
        }
    }
    int k;
    cin >> k;
    map<string, int> values;
    for (int i = 0; i < k; ++i) {
        string var;
        int val;
        cin >> var >> val;
        values[var] = val;
    }
    vector <vector <int>> graph(n + 1);
    int v = 0;
    for (int i = 0; i < t; ++i) {
        ++v;
        for (int j = 1; j < threads[i].size(); ++j) {
            graph[v - 1].push_back(v);
            ++v;
        }
    }
    unordered_map<string, vector <int>> good, bad;
    v = 0;
    for (int i = 0; i < t; ++i) {
        ++v;
        for (int j = 0; j < threads[i].size(); ++j) {
            string var = threads[i][j].first;
            int val = threads[i][j].second;
            if (values[var] == val) {
                good[var].push_back(v);
            } else {
                bad[var].push_back(v);
            }
            ++v;
        }
    }
    for (auto p : good) {
        string var = p.first;
        for (int i : p.second) {
            if (bad.count(var) == 0) continue;
            for (int j : bad[var]) {
                graph[j].push_back(i);
            }
        }
    }
    vector <bool> visited(n);
    vector <int> order;
    for (int u = 0 ;u < n; ++u) {
        if (!visited[u]) {
            dfs(u, -1, graph, visited, order);
        }
    }
    if (result) {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    reverse(order.begin(), order.end());
    for (int u : order) {
        cout << u + 1 << ' ';
    }
}