#include <iostream>
#include <vector>
using namespace std;

int q = 0, f = 0;

bool matchesQ(vector <vector <char> > &grid, int i, int j) {
    bool ok = true;
    ok &= (grid[i][j] == '#');
    ok &= (grid[i + 1][j] == '#');
    ok &= (grid[i + 2][j] == '#');
    ok &= (grid[i][j + 1] == '#');
    ok &= (grid[i + 2][j + 1] == '#');
    for (int k = 0; k < 5; k++)
        ok &= (grid[i + k][j + 2] == '#');
    return ok;
}

void deleteQ(vector <vector <char> > &grid, int i, int j) {
    grid[i][j] = '0';
    grid[i + 1][j] = '0';
    grid[i + 2][j] = '0';
    grid[i][j + 1] = '0';
    grid[i + 2][j + 1] = '0';
    for (int k = 0; k < 5; k++)
        grid[i + k][j + 2] = '0';
}

bool matchesF(vector <vector <char> > &grid, int i, int j) {
    bool ok = true;
    for (int k = 0; k < 5; k++)
        ok &= (grid[i + k][j] == '#');
    ok &= (grid[i][j + 1] == '#');
    ok &= (grid[i][j + 2] == '#');
    ok &= (grid[i + 2][j + 1] == '#');
    return ok;
}

void deleteF(vector <vector <char> > &grid, int i, int j) {
    for (int k = 0; k < 5; k++)
        grid[i + k][j] = '0';
    grid[i][j + 1] = '0';
    grid[i][j + 2] = '0';
    grid[i + 2][j + 1] = '0';
}

void restoreF(vector <vector <char> > &grid, int i, int j) {
    for (int k = 0; k < 5; k++)
        grid[i + k][j] = '#';
    grid[i][j + 1] = '#';
    grid[i][j + 2] = '#';
    grid[i + 2][j + 1] = '#';
}

bool backtrack(vector <vector <char> > &grid, int i, int j) {
    if (j == grid[0].size()) {
        j = 0;
        i++;
    }
    while (i < grid.size() && grid[i][j] != '#') {
        j++;
        if (j == grid[0].size()) {
            j = 0;
            i++;
        }
    }
    if (i == grid.size()) return true;

    bool ok;
    if (matchesF(grid, i, j)) {
        f++;
        deleteF(grid, i, j);
        ok = backtrack(grid, i, j + 1);
        if (!ok) {
            f--;
            restoreF(grid, i, j);
        }
    }
    if (matchesQ(grid, i, j)) {
        q++;
        deleteQ(grid, i, j);
        ok = backtrack(grid, i, j + 1);
    }
    return ok;
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector <vector <char> > grid(n, vector <char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cin >> grid[i][j];
        getchar();
    }
    backtrack(grid, 0, 0);
    cout << q << " " << f;
}
