#include <iostream>
#include <vector>

using namespace std;

pair<int, int> find(int n, int m, const vector <vector <char> >& grid)
{
    for (int j = 0; j < m; j++)
    {
        for(int i = 0; i < n; i++)
        {
            if (grid[i][j] == '#')
                return {i,j};
        }
    }
    return {-1,-1};
}

int deleteQ(int i, int j, vector <vector <char> >& grid)
{
    grid[i][j] = '0';
    grid[i + 1][j] = '0';
    grid[i + 2][j] = '0';
    grid[i][j + 1] = '0';
    grid[i + 2][j + 1] = '0';
    for (int k = 0; k < 5; k++)
        grid[i + k][j + 2] = '0';
    return 1;
}

int deleteF(int i, int j, vector <vector <char> >& grid)
{
    for (int k = 0; k < 5; k++)
        grid[i + k][j] = '0';
    grid[i][j + 1] = '0';
    grid[i][j + 2] = '0';
    grid[i + 2][j + 1] = '0';
    return 1;
}

int main()
{
    int q = 0, f = 0;
    int n, m;
    cin >> n >> m;
    vector <vector <char> > grid(n, vector <char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cin >> grid[i][j];
        getchar();
    }
    pair<int, int> tmp = find(n, m, grid);
    while (tmp.first != -1)
    {
        if (grid[tmp.first + 3][tmp.second] == '#')
        {
            deleteF(tmp.first, tmp.second, grid);
            f++;

        }
        else {
            deleteQ(tmp.first, tmp.second, grid);
            q++;
        }
        tmp = find(n, m, grid);
    }

    cout << q << " " << f;

    return 0;
}
