#pragma comment(linker, "/STACK:128777216")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <tuple>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <cassert>
#include <random>

using namespace std;

#define Forn(i, n) for (int i = 0; i < (n); ++i)
#define sz(v) (int)(v).size()
#define forx(_name, _from, to, value) for (int name = from; name < to; name += value)
#define rforx(_name, from, to, value) for (int name = from; name > to; name -= _value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST, _SECOND) make_pair(_FIRST,_SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-9;
mt19937 rnd(42);

void start() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout.setf(ios::fixed);
#ifdef LOCAL
    //freopen("output.out", "w", stdout);
    freopen("input.in", "r", stdin);
#endif
}

const int MAX_N = (int) 1e7 + 10;
const int MAX_M = (int) 1e6 + 10;
const int MOD = (int) 1e9;
const int INF = (int) 1e9 + 7;

ll n, m, c;

ll calc_val(ll M, ll C) {
    return abs(M * m + C * c - n);
}

void solve() {
    cin >> n >> m >> c;

    ll best_m = 0, best_c = 0, best_v = calc_val(0, 0);

    for (int i = 0; i * c % m != 0 || i == 0; ++i) {
        ll M1 = max(0ll, (n - i * c) / m);
        ll M2 = M1 + 1;
        ll d1 = calc_val(M1, i);
        ll d2 = calc_val(M2, i);
        if (best_v > d1) {
            best_m = M1, best_c = i, best_v = d1;
        }
        if (best_v > d2) {
            best_m = M2, best_c = i, best_v = d2;
        }
    }
    cout << best_m << " " << best_c << endl;
}

int main() {
    start();
    solve();
    //multitest();
#ifdef LOCAL
    //cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
    return 0;
}
