#include <iostream>
#include <math.h>
#include <vector>
#include <tuple>
#include <queue>

using namespace std;

using line = vector <int>;
using matrix = vector <line>;

const int INF = 0x3f3f3f3f;

line dist, used;
vector <vector <tuple<int, int>>> d;

int main() {
    // ...
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;

    dist.resize(n, INF);
    used.resize(n);

    d.resize(n);

    for (int i(0); i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;

        --a, --b;
        d[a].push_back({ b, w });
        d[b].push_back({ a, w });
    }
    
    // refr
    int maximum = -INF;
    vector <int> answer;

    dist[0] = 0;

    queue <tuple <int, int, int, vector <int>>> q;
    q.push({ 0, INF, -INF, vector <int>() });

    while (!q.empty()) {
        auto [curr, mn, mx, path] = q.front();
        q.pop();

        path.push_back(curr);

        if (curr == n - 1) {
            //cout << curr << " " << mn << " " << mx << '\n';

            if (maximum < mx - mn) {
                answer = path;
                maximum = mx - mn;
            }
        }

        //if (used[curr]) {
        //    continue;
        //}

        used[curr] = true;

        for (auto e : d[curr]) {
            auto [b, w] = e;

            if (dist[b] >= dist[curr] + 1) {
                q.push({ b, min(mn, w), max(mx, w), path});
                dist[b] = min(dist[b], dist[curr] + 1);
            }
        }
    }

    cout << answer.size() - 1 << '\n';
    for (auto i : answer) {
        cout << i + 1 << ' ';
    }

    return 0;
}