#include <iostream>
#include <math.h>
#include <vector>
#include <tuple>
#include <queue>
#include <algorithm>

using namespace std;

using line = vector <int>;
using matrix = vector <line>;

const int INF = 0x3f3f3f3f;

line dist, used;
vector <vector <tuple<int, int>>> d;

//vector <int> deik(int from, int to) {
//
//}

int main() {
    // ...
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;

    dist.resize(n, INF);
    used.resize(n);

    d.resize(n);

    for (int i(0); i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;

        --a, --b;
        d[a].push_back({ b, w });
        d[b].push_back({ a, w });
    }
    
    // refr
    int maximum = -INF;
    int A1(-1), B1(-1), A2(-1), B2(-1);

    dist[0] = 0;

    queue <tuple <int, int, int, int, int, int, int>> q;
    q.push({ 0, INF, -INF, -1, -1, -1, -1});

    while (!q.empty()) {
        auto [curr, mn, mx, a1, b1, a2, b2] = q.front();
        q.pop();

        if (curr == n - 1) {
            //cout << mn << " " << mx << " | " << a1 + 1 << " " << b1 + 1 << " | " << a2 + 1 << " " << b2 + 1 << '\n';

            if (maximum < mx - mn) {
                maximum = mx - mn;
                A1 = a1;
                B1 = b1;

                A2 = a2;
                B2 = b2;
            }
        }

        for (auto e : d[curr]) {
            auto [next, w] = e;

            if (dist[next] >= dist[curr] + 1) {
                int _a1 = a1;
                int _b1 = b1;

                int _a2 = a2;
                int _b2 = b2;

                if (mn > w) {
                    _a1 = curr;
                    _b1 = next;
                }

                if (mx < w) {
                    _a2 = curr;
                    _b2 = next;
                }

                q.push({ next, min(mn, w), max(mx, w), _a1, _b1, _a2, _b2});
                dist[next] = min(dist[next], dist[curr] + 1);
            }
        }
    }

    //cout << A1 + 1 << " " << B1 + 1 << '\n';
    //cout << A2 + 1 << " " << B2 + 1 << '\n';

    

    vector <int> parent(n);
    fill(dist.begin(), dist.end(), INF);
    dist[0] = 0;

    priority_queue <tuple <int, int>, std::vector<tuple <int, int>>, std::greater<tuple <int, int>>> qq;
    qq.push({ -1, 0 });

    while (!qq.empty()) {
        auto [unused, curr] = qq.top();
        qq.pop();

        if (used[curr]) {
            continue;
        }

        used[curr] = true;

        for (auto e : d[curr]) {
            auto [next, unused] = e;

            int w = 1;
            if ((curr == A1 && next == B1) || (curr == A2 && next == B2)) {
                w = 0;
            }

            if (dist[next] > dist[curr] + w) {
                dist[next] = dist[curr] + w;
                parent[next] = curr;
                qq.push({ dist[next], next });
            }
        }
    }

    vector <int> path;

    int curr = n - 1;
    while (curr) {
        path.push_back(curr);
        curr = parent[curr];
    }
    path.push_back(0);
    reverse(path.begin(), path.end());

    cout << path.size() - 1 << '\n';
    for (auto i : path) {
        cout << i + 1 << ' ';
    }

    return 0;
}