from math import gcd

n, m = [int(x) for x in input().split()]

count = 0
for _ in range(n):
	string = input()
	count += string.count("#")

def extended_gcd(a, b):
    assert a >= 0 and b >= 0

    if b == 0:
        d, x, y = a, 1, 0
    else:
        (d, p, q) = extended_gcd(b, a % b)
        x = q
        y = p - q * (a // b)

    assert a % d == 0 and b % d == 0
    assert d == a * x + b * y

    return (d, x, y)

def diophantine(a, b, c):
    assert (
        c % gcd(a, b) == 0
    )
    (d, x, y) = extended_gcd(a, b)
    r = c / d
    return (r * x, r * y)

def diophantine_all_soln(a, b, c, n = 2):

    (x0, y0) = diophantine(a, b, c)  # Initial value
    d = gcd(a, b)
    p = a // d
    q = b // d

    i = 0
    x = -1
    y = -1
    while not(x >= 0 and y >= 0):
        x = x0 + i * q
        y = y0 - i * p
        i += 1

    return (int(x), int(y))

x, y = diophantine_all_soln(8, 10, count)
print(x, y)