#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

struct Node {
	bool isEnd = false;
	map <char, int> childs;
};

Node trie[300500];
int arr[300500] = { 0 };
int m = 0;
int ans = 0;

bool isEnd(int n) {
	return trie[n].isEnd;
}
bool canGo(int n, char c) {
	return trie[n].childs.count(c);
}
int go(int n, char c) {
	return trie[n].childs[c];
}
int addNode(int n, char c) {
	m++;
	trie[n].childs[c] = m;
	return m;
}
void addEnd(int n) {
	trie[n].isEnd = true;
}
void insert(string s) {
	int i = 0;
	arr[0]++;
	for (char c : s) {
		if (canGo(i, c))
			i = go(i, c);
		else
			i = addNode(i, c);
		arr[i]++;
	}
	addEnd(i);
}
pair <int, int> dfs(int n, int k) {
	int sum = 0, res = 0;
	vector <pair<int, int>> v;
	pair <int, int> p;
	for (auto i : trie[n].childs) {
		int a = go(n, i.first);
		v.push_back({ -arr[a],a });
	}
	sort(v.begin(), v.end());
	for (auto i : v) {
		if (arr[i.second] <= k) {
			res += arr[i.second];
			sum++;
		}
		else {
			p = dfs(i.second, k);
			sum += p.first;
			res += p.second;
		}
		if (arr[n] - res <= k)
			break;
	}
	if (res + k == arr[n]) {
		sum++;
		res += k;
	}
	return { sum, res };
}

int main() {
	string s;
	int n, k;
	cin >> n >> k;
	for (int i = 0; i < n; i++) {
		cin >> s;
		insert(s);
	}
	auto p = dfs(0, k);
	int a = p.first;
	cout << a;
}