﻿#define _USE_MATH_DEFINES
#include<iostream>
#include<fstream>
#include<string>
#include<vector>
#include<utility>
#include<algorithm>
#include<climits>
#include<set>
#include<map>
#include<cmath>
#include<iomanip>
#include<iterator>
#include<queue>
#include<stack>
#include<cctype>
#include<deque>
#include<time.h>
#include<bitset>
#include<random>
#include<functional>
#include<unordered_set>
#include<unordered_map>
#include<random>
#include<numeric>
#include<sstream>
#include<cassert>
#include<chrono>
#include<complex>

//by Skeef79

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#pragma warning(disable : 4996)
#pragma comment(linker, "/STACK:16777216")
#define pb push_back
#define en '\n'
#define forn(i,n) for(int i = 0;i<n;i++)
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define vec vector
#define pii pair<int,int>
#define pll pair<ll,ll>
#define szof(x) int(x.size())

using namespace std;

const int INF = 1000000000 + 1e8;
const ll LINF = 2000000000000000000;

const int N = 6e5 + 1010;
struct node {
	int pref, suff, mx, len;
	node() {
		pref = 0, suff = 0, mx = 0, len = 0;
	}
	node(int val) {
		pref = suff = mx = val;
		len = 1;
	}
};


node combine(node a, node b) {
	node res;
	res.pref = (a.pref == a.len ? a.len + b.pref : a.pref);
	res.suff = (b.suff == b.len ? b.len + a.suff : b.suff);
	res.mx = max(max(a.mx, b.mx), a.suff + b.pref);
	res.len = a.len + b.len;
	return res;
}

node t[4 * N];
int cnt[N];

void build(int v, int vl, int vr) {
	if (vl == vr) {
		t[v] = node(cnt[vl] > 0);
		return;
	}
	int vm = (vl + vr) / 2;
	build(2 * v + 1, vl, vm);
	build(2 * v + 2, vm + 1, vr);
	t[v] = combine(t[2 * v + 1], t[2 * v + 2]);
}

int get() {
	return t[0].mx;
}


void modify(int v, int vl, int vr, int pos, int val) {
	if (vl == vr) {
		t[v] = node(val);
		return;
	}
	int vm = (vl + vr) / 2;
	if (pos <= vm)
		modify(2 * v + 1, vl, vm, pos, val);
	else
		modify(2 * v + 2, vm + 1, vr, pos, val);

	t[v] = combine(t[2 * v + 1], t[2 * v + 2]);
}


void solve() {
	int n, m;
	cin >> n >> m;
	vec<int>coords;

	vec<int>a(n);

	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		a[i] = x;
		int day = x / m;
		coords.pb(day);
		if (day != 0)
			coords.pb(day - 1);
		coords.pb(day + 1);
	}

	sort(all(coords));
	coords.resize(unique(all(coords)) - coords.begin());
	map<int, vec<int>>mp;
	
	int sz = szof(coords);
	fill(cnt, cnt + sz, 0);

	for (int i = 0; i < n; i++) {
		int day = a[i] / m;
		int idx = lower_bound(all(coords), day) - coords.begin();
		cnt[idx]++;
	}


	for (int i = 0; i < n; i++) {
		if (a[i] % m == 0)
			continue;
		
		int day = a[i] / m;

		int t = (a[i] / m + 1)*m - a[i];
		int idx = lower_bound(all(coords), day) - coords.begin();

		mp[t].pb(idx);
	}

	int ans_len = 0, ans_t = 0;
	build(0, 0, sz - 1);
	ans_len = get();

	for (auto to : mp) {
		for (auto day : to.second) {
			cnt[day]--;
			if (cnt[day] == 0) {
				modify(0, 0, sz - 1, day, 0);
			}

			cnt[day + 1]++;
			if (cnt[day + 1] == 1) {
				modify(0, 0, sz - 1, day+1, 1);
			}
		}

		if (get() > ans_len) {
			ans_len = get();
			ans_t = to.first;
		}
	}

	cout << ans_len << ' ' << ans_t << en;
}


int main() {
	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif

	int tst = 1;
	cin >> tst;

	while (tst--) {
		solve();
	}

}