﻿#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <array>
#include <set>
#include <list>
#include <cmath>
#include <string>
#include <bitset>
#include <queue>
#include <stack>
#include <unordered_map>
#include <map>
#include <iterator>
#ifdef DEBUG__
#include <chrono>
#define FILE__ "test"
#else
//#define FILE__ "negcycle"
#endif

#define int long long
#define float double
using namespace std;

#define loop(i,start,end) for(auto i = start;i < end;i ++)
#define loopi(end) loop(i,0,end)
#define loopj(end) loop(j,0,end)

#define FIRST_SOLUTION__
#ifdef FIRST_SOLUTION__

struct eq_space : std::ctype<char> {
	eq_space() : std::ctype<char>(get_table()) {}
	static mask const* get_table()
	{
		static mask rc[table_size];
		rc[' '] = std::ctype_base::space;
		rc['\n'] = std::ctype_base::space;
		rc['='] = std::ctype_base::space;
		return &rc[0];
	}
};

void solve()
{
	std::cin.imbue(std::locale(cin.getloc(), new eq_space));
	int t;
	std::cin >> t;
	std::vector<std::map<std::string, int>> end_states(t);
	std::vector<std::vector<std::pair<std::string, int>>> cmd(t);
	for (int i = 0; i < t; ++i) {

		int orders;
		std::cin >> orders;
		for (int j = 0; j < orders; ++j) {
			std::string n;
			int v;
			std::cin >> n >> v;

			cmd[i].push_back({ n, v });
			end_states[i][n] = v;
		}
	}

	std::map<std::string, int> results;
	int vars;
	std::cin >> vars;
	for (int i = 0; i < vars; ++i) {
		std::string n;
		int a;
		std::cin >> n >> a;
		results[n] = a;
	}

	std::vector<int> states;
	std::set<std::string> removed;
	bool did_anything = true;

	while (did_anything) {
		did_anything = false;
		for (int i = 0; i < t; ++i) {

			if (cmd[i].empty())
				continue;

			auto& back = cmd[i].back();
			if (results[back.first] == back.second) {

				states.push_back(i + 1);
				results.erase(back.first);
				removed.insert(back.first);
				cmd[i].pop_back();
				did_anything = true;
				break;
			}

			if (removed.count(back.first)) {
				cmd[i].pop_back();
				states.push_back(i + 1);
				did_anything = true;
				break;
			}
		}
	}

	bool all_emp = true;
	for (auto& c : cmd)
		if (!c.empty())
			all_emp = false;

	if (!all_emp) {
		cout << "No";
		return;
	}

	cout << "Yes" << endl;
	std::reverse(states.begin(), states.end());
	for (auto& r : states)
		cout << r << " ";
}


#else



void solve()
{
	std::vector<std::vector<int>> plane(21, std::vector<int>(21, 0));
	char useless_buf[64];
	char useable_buf[16];
	std::bitset<3> params;
	for (int i = 0; i < 3; ++i) {
		scanf("%[^:]: %s", useless_buf, useable_buf);
		params.set(i, useable_buf[0] == 'Y');
	}

	for (int i = 0; i < 21 && params[2]; ++i) {
		for (int j = 0; j < 21; ++j) {
			plane[i][j] = j - 10;
		}
	}

	if (params[0]) {

		plane[21 / 2][21 / 2] += 3;
		plane[21 / 2][21 / 2 + 3] += 3;
	}

	if (params[1]) {

		plane[21 / 2 + 3][21 / 2] -= 3;
		plane[21 / 2 + 3][21 / 2 + 3] -= 3;
	}

	for (auto& m : plane) {
		for (auto& l : m)
			cout << l << " ";
		cout << endl;
	}



	return;
}
#endif

std::int32_t main() {
#ifdef DEBUG__
	auto timestamn = std::chrono::system_clock::now();
#else
	cin.tie(0);
	cout.tie(0);
	ios::sync_with_stdio(0);
#endif
#ifdef FILE__
	freopen(FILE__".in", "r", stdin);
	//freopen(FILE__".out", "w", stdout);
#endif
	solve();
#ifdef DEBUG__
	cout << endl << "Time elansed: " << chrono::duration_cast<chrono::milliseconds>(std::chrono::system_clock::now() - timestamn).count() << " ms" << endl;
#endif
	return 0;
}
