#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int cur_min;
vector<vector<int> > ps;

struct arc {
    int e, c;
};

void dfs(vector<vector<arc> > &g, vector<bool> &used, int v, int d, vector<int> &path){
    used[v] = true;
    path.push_back(v);
    int mn = path[0], mx = path[1];

    if (v == d) {
        int l = path.size() - 2;
        if (l < cur_min) {
            ps.clear();
            cur_min = l;
        }

        if (l == cur_min) {
            ps.push_back(path);
        }
    } else {
        for (int w = 0; w < g[v].size(); w++) {
            int to = g[v][w].e;
            if (!used[to]) {
                path[0] = min(path[0], g[v][w].c);
                path[1] = max(path[1], g[v][w].c);
                dfs(g, used, to, d, path);
            }
            path[0] = mn;
            path[1] = mx;
        }
    }

    path.pop_back();
    used[v] = false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    int n, m; cin >> n >> m;

    vector<vector<arc> > g(n+1);
    int s, e, c;
    for (int i = 0; i < m; i++) {
        cin >> s >> e >> c;
        g[s].push_back({e, c});
        g[e].push_back({s, c});
    }

    s = 1;
    e = n;
    cur_min = 1000000009;

    vector<bool> used(n+1, false);
    vector<int> path = { 1000000009, -1}; // min , max
    dfs(g, used, s, e, path);

    int mdiff = -1, ixs = -1;

    for (int i = 0; i < ps.size(); i++) {
        // cout << ps[i][1] << " " << ps[i][0] << " " << mdiff << endl;
        if ((ps[i][1] - ps[i][0]) > mdiff) {
            mdiff = ps[i][1] - ps[i][0];
            ixs = i;
        }
    }

    // cout << mdiff << endl;
    cout << ps[ixs].size() - 3 << endl;
    for (int i = 2; i < ps[ixs].size(); i++) {
        cout << ps[ixs][i] << " ";
    }
}