#include "bits/stdc++.h"


using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 3e5 + 32;


vector<pair<int, int>> g[MAXN];

int dpmin[MAXN];
int dpminprv[MAXN];

int dpmax[MAXN];
int dpmaxprv[MAXN];


int dst[MAXN];
int dst2[MAXN];
int prv2[MAXN];

int n, m;

const int inf = 1e9;


vector<int> layers[MAXN];

void bfs( ) {

    queue<int> q;
    for (int i = 0; i < n; ++i) {
        dst[i] = inf;
    }

    dst[0] = 0;

    q.push(0);

    while (q.size()) {

        auto tp = q.front();
        q.pop();


        for (auto e: g[tp]) {
            if (dst[e.first] > dst[tp] + 1) {
                dst[e.first] = dst[tp] + 1;

                q.push(e.first);
            }
        }
    }

    for (int i = 0; i < n; ++ i) {
        layers[dst[i]].push_back(i);
    }
}

void bfs2( ) {

    queue<int> q;
    for (int i = 0; i < n; ++i) {
        dst2[i] = inf;
    }

    dst2[n - 1] = 0;

    q.push(n - 1);

    while (q.size()) {

        auto tp = q.front();
        q.pop();


        for (auto e: g[tp]) {
            if (dst2[e.first] > dst2[tp] + 1) {
                dst2[e.first] = dst2[tp] + 1;

                prv2[e.first] = tp;

                q.push(e.first);
            }
        }
    }
}



void solve() {


    cin >> n >> m;

    for (int i = 0; i < m; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a;
        --b;
        g[a].push_back({b, w});
        g[b].push_back({a, w});
    }

    bfs();
    bfs2();

    for (int i = 0; i < n; ++i) {

        dpmin[i] = inf;
        dpmax[i] = 0;

    }

    for (int l = 0; l < MAXN; ++l) {

        for (auto e: layers[l]) {

            for (auto nxt: g[e]) {
                if (dst[nxt.first] != 1 + dst[e]) continue;

                if (min(dpmin[e], nxt.second) < dpmin[nxt.first]) {
                    dpmin[nxt.first] = min(dpmin[e], nxt.second);
                    dpminprv[nxt.first] = e;
                }

                if (max(dpmax[e], nxt.second) > dpmax[nxt.first]) {
                    dpmax[nxt.first] = max(dpmax[e], nxt.second);
                    dpmaxprv[nxt.first] = e;
                }
            }
        }
    }

    int answr = -1;

    for (int i = 1; i < n; ++i) {
        if (dst[i] + dst2[i] != dst[n - 1]) continue;
        for (auto nxt: g[i]) {
            if (dst[nxt.first] != dst[i] + 1) continue;
            if (dst[nxt.first] + dst2[nxt.first] != dst[n - 1]) continue;

            int curr = abs(nxt.second - dpmin[i]);
            curr = max(curr, abs(nxt.second - dpmax[i]));

            if (curr > answr) {
                answr = curr;
            }
        }
    }


//    cerr << answr << "\n";

    cout << dst[n - 1] << "\n";

    if (dst[n - 1] == 1) {
        cout << "1 " << n << "\n";
        return;
    }


    for (int i = 1; i < n; ++i) {
        if (dst[i] + dst2[i] != dst[n - 1]) continue;
        for (auto nxt: g[i]) {
            if (dst[nxt.first] != dst[i] + 1) continue;
            if (dst[nxt.first] + dst2[nxt.first] != dst[n - 1]) continue;

            int curr = abs(nxt.second - dpmin[i]);

            if (curr == answr) {

                vector<int> p1;
                vector<int> p2;

                int vrt = nxt.first;
                while (vrt != n - 1) {
                    p2.push_back(vrt);
                    vrt = prv2[vrt];
                }
                p2.push_back(n - 1);

                vrt = i;

                while (vrt != 0) {
                    p1.push_back(vrt);
                    vrt = dpminprv[vrt];
                }
                p1.push_back(0);

                reverse(p1.begin(), p1.end());

                for (auto e : p1) {
                    cout << e + 1 << " ";
                }

                for (auto e : p2) {
                    cout << e + 1 << " ";
                }

                return;
            }

            curr = max(curr, abs(nxt.second - dpmax[i]));


            if (curr == answr) {

                vector<int> p1;
                vector<int> p2;

                int vrt = nxt.first;
                while (vrt != n - 1) {
                    p2.push_back(vrt);
                    vrt = prv2[vrt];
                }
                p2.push_back(n - 1);

                vrt = i;

                while (vrt != 0) {
                    p1.push_back(vrt);
                    vrt = dpmaxprv[vrt];
                }
                p1.push_back(0);

                reverse(p1.begin(), p1.end());

                for (auto e : p1) {
                    cout << e + 1 << " ";
                }

                for (auto e : p2) {
                    cout << e + 1 << " ";
                }

                return;
            }
        }
    }


}

clock_t z = clock();

int main () {
    std::cin.tie();
    std::cout.tie();

    std::ios_base::sync_with_stdio(0);

    cout << fixed << setprecision(6);
//
//#ifndef ONLINE_JUDGE
//    freopen("../input.in", "r", stdin);
//#endif

    solve();

//    cerr << (clock() - z + 0.) / CLOCKS_PER_SEC << "\n";
}
