#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define x first
#define y second

ll n, m;
vector<vector<pair<ll, ll>>> graph;
map<pair<ll, ll>, ll> edges;
const ll INF = 1e18;


void dijkstra(vector<ll>& d, vector<vector<ll>>& p, vector<pair<ll, ll>>& kekes, ll s, ll f) {
//    vector<ll> d(n, INF);
//    vector<vector<ll>> p(n);
//    vector<pair<ll, ll>> kekes(n, {INF, -1});
    d[s] = 0;
    set<pair<ll, ll>>q;
    q.insert(make_pair(d[s], s));

    while (!q.empty()) {
        ll v = q.begin()->second;
        q.erase(q.begin());

        for (size_t j = 0; j < graph[v].size(); ++j) {
            ll to = graph[v][j].first;
            ll len = 1;

            ll edge = graph[v][j].second;

            if (d[v] + len < d[to]) {
                q.erase(make_pair(d[to], to));
                d[to] = d[v] + len;

                kekes[to] = {min(kekes[v].first, edge), max(kekes[v].second, edge)};
                p[to] = {v};
                q.insert(make_pair(d[to], to));
            } else if (d[v] + len == d[to]) {
                auto diff_kekes = kekes[to].y - kekes[to].x;
                auto curr_diff = -min(kekes[v].first, edge) + max(kekes[v].second, edge);
                if (curr_diff > diff_kekes) {
                    kekes[to] = {min(kekes[v].first, edge), max(kekes[v].second, edge)};
                }
                p[to].push_back(v);
            }
        }
    }
}



int main() {
//    ios::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);

    cin >> n >> m;

    graph.resize(n);


    for (int i = 0; i < m; ++i) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        graph[a].push_back({b, c});
        graph[b].push_back({a, c});

        edges[{a, b}] = c;
        edges[{b, a}] = c;
    }

    vector<ll> d_1(n, INF);
    vector<vector<ll>> p_1(n);
    vector<pair<ll, ll>> kekes_1(n, {INF, -1});


    dijkstra(d_1, p_1, kekes_1, 0, n - 1);


    vector<ll> d_2(n, INF);
    vector<vector<ll>> p_2(n);
    vector<pair<ll, ll>> kekes_2(n, {INF, -1});

    dijkstra(d_2, p_2, kekes_2, n - 1, 0);

    cout << d_1[n - 1] << '\n';

    pair<ll, ll> road = {INF, -1};
    ll mx = -1;
    ll vertex = -1;
    for (int i = 0; i < n; ++i) {
        if (!p_1[i].empty()) {
//            cout << i + 1 << '\n';
//            cout << kekes_1[i].x << " " << kekes_1[i].y << "      " << kekes_2[i].x << " " << kekes_2[i].y << '\n';
            auto diff = -min(kekes_1[i].x, kekes_2[i].x) + max(kekes_1[i].y, kekes_2[i].y);
//            cout << diff << '\n';
            if (diff > mx) {
                mx = diff;
                vertex = i;
                road = {min(kekes_1[i].x, kekes_2[i].x), max(kekes_1[i].y, kekes_2[i].y)};
            }
        }
    }

//    cout << vertex << " " << mx << "  " << road.x << " " << road.y << '\n';

    ll t = vertex;

    ll end_vertex = road.x;
    ll start_vertex = road.y;
//    cout << kekes_2[vertex].y << ' ' << road.y << '\n';
    if (kekes_2[vertex].y == road.y) {
        end_vertex = road.y;
        start_vertex = road.x;
    }

    vector<ll> ans1, ans2;
    t = vertex;
    while (true) {
        ans1.push_back(t);
        ll vertex_1 = p_2[t].front();
        for (auto i : p_2[t]) {
            if (kekes_2[i].x == end_vertex or kekes_2[i].y == end_vertex or edges[{vertex_1, i}] == end_vertex or end_vertex == -1) {
                vertex_1 = i;
                if (edges[{vertex_1, i}] == end_vertex) {
                    end_vertex = -1;
                }
                break;
            }
        }
        t = vertex_1;

        if (p_2[t].empty()) {
            break;
        }
    }

//    cout << start_vertex << " " << end_vertex << '\n';

    t = vertex;
    while (true) {
        ans2.push_back(t);
        ll vertex_1 = p_1[t].front();
        for (auto i : p_1[t]) {
            if (kekes_1[i].x == start_vertex or kekes_1[i].y == start_vertex or edges[{vertex_1, i}] == start_vertex or start_vertex == -1) {
                vertex_1 = i;
                if (edges[{vertex_1, i}] == start_vertex) {
                    start_vertex = -1;
                }
                break;
            }
        }

        t = vertex_1;
        if (p_1[t].empty()) {
            break;
        }
    }

    cout << 1 << " ";
    reverse(ans2.begin(), ans2.end());
    ans2.pop_back();
    for (auto i : ans2) {
        cout << i + 1 << " ";
    }

    for (auto i : ans1) {
        cout << i + 1 << " ";
    }
    cout << n;


//    vector<ll> answer;
//    ll t = n - 1;
//    while (true) {
//        answer.push_back(t);
//        unordered_map<ll, pair<ll, ll>> cur_answers;
//        ll vertex = p_1[t].front();
//        for (auto i : p_1[t]) {
//            pair<ll, ll> kek = {min(kekes_1[i].x, kekes_2[i].x), max(kekes_1[i].y, kekes_2[i].y)};
//            if (road.x == kek.x and road.y == kek.y) {
//                vertex = i;
//            }
//        }
//
//        t = vertex;
//        if (p_1[t].empty()) {
//            break;
//        }
//    }
//
//    cout << 1 << ' ';
//    reverse(answer.begin(), answer.end());
//    for (auto i : answer) {
//        cout << i + 1 << " ";
//    }



    return 0;
}