#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>

using namespace std;

#define MAX_N 600010

struct Node {
    char pref;
    int count;
    vector <int> children;
};

int t_first_empty = 1;
Node T[MAX_N];

void add_to_tree(string x, int v) {
    bool fl = false;
    ++T[v].count;

    for (int i = 0; i < T[v].children.size(); ++i) {
        Node child = T[T[v].children[i]];
        if (x.size() == 0 && child.pref == ' ') {
            ++child.count;
            fl = true;
            break;
        }
        
        if (child.pref == x[0]) {
            add_to_tree(x.substr(1), T[v].children[i]);
            fl = true;
        }
    }

    if (!fl) {
        T[v].children.push_back(t_first_empty);
        ++t_first_empty;
        if (x.size() != 0) {
            T[t_first_empty - 1].pref = x[0];
            T[t_first_empty - 1].count = 0;
            add_to_tree(x.substr(1), t_first_empty - 1);
        }
        else {
            T[t_first_empty - 1].pref = ' ';
            T[t_first_empty - 1].count = 1;
        }
    }
}

pair <int, string> find_largest_group(int v, int k) {
    if (T[v].count <= k) {
        string s = "";
        if (v != 0) {
            s += T[v].pref;
        }

        return make_pair(v, s);
    }

    string largest_group_path = "";
    int largest_group = 0, largest_group_index = -1;    

    for (int i = 0; i < T[v].children.size(); ++i) {
        int child = T[v].children[i];
        pair <int, string> child_largest = find_largest_group(child, k);
        if (T[child_largest.first].count > largest_group) {
            largest_group = T[child_largest.first].count;
            largest_group_index = child_largest.first;
            largest_group_path = child_largest.second;
        }
    }

    if (v != 0) {
        return make_pair(largest_group_index, T[v].pref + largest_group_path);
    }
    else {
        return make_pair(largest_group_index, largest_group_path);
    }
}

void remove_group(string x, int v, int u) {
    if (x.size() == 0) {
        T[v].count = 0;
        return;
    }

    for (int i = 0; i < T[v].children.size(); ++i) {
        Node child = T[T[v].children[i]];
        if (x.size() == 0 && child.pref == ' ') {
            T[v].count -= T[u].count;
            remove_group(x.substr(1), T[v].children[i], u);
        }
        
        if (child.pref == x[0]) {
            T[v].count -= T[u].count;
            remove_group(x.substr(1), T[v].children[i], u);
        }
    }
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int n, k;
    cin >> n >> k;

    ios_base::sync_with_stdio(false);

    T[0].pref = ' ';

    for (int i = 0; i < n; ++i) {
        string x;
        getline(cin, x);

        add_to_tree(x, 0);
    }

    /*
    for (int i = 0; i < MAX_N; ++i) {
        cout << i << " " << T[i].pref << ' ' << T[i].count << " {";
        for (int j = 0; j < T[i].children.size(); ++j) {
            cout << T[i].children[j];

            if (j != T[i].children.size() - 1) {
                cout << " ";
            }
        }

        cout << "}\n";
    }
    */

    int g;
    while (T[0].count != 0) {
        pair <int, string> u = find_largest_group(0, k);
        //cout << u.second + "*" << endl;
        remove_group(u.second, 0, u.first);
        ++g;
    }
    
    cout << g;
    
    return 0;
}