#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
 
using namespace std;
 
#define MAX_N 700000
 
struct Node {
    char pref;
    long long count;
    vector <long long> children;
};
 
long long t_first_empty = 1;
Node T[MAX_N];
 
void add_to_tree(string x, long long v) {
    bool fl = false;
    ++T[v].count;
 
    for (long long i = 0; i < T[v].children.size(); ++i) {
        Node child = T[T[v].children[i]];
        if (x.size() == 0 && child.pref == ' ') {
            ++child.count;
            fl = true;
            break;
        }
         
        if (child.pref == x[0]) {
            add_to_tree(x.substr(1), T[v].children[i]);
            fl = true;
        }
    }
 
    if (!fl) {
        T[v].children.push_back(t_first_empty);
        ++t_first_empty;
        if (x.size() != 0) {
            T[t_first_empty - 1].pref = x[0];
            T[t_first_empty - 1].count = 0;
            add_to_tree(x.substr(1), t_first_empty - 1);
        }
        else {
            T[t_first_empty - 1].pref = ' ';
            T[t_first_empty - 1].count = 1;
        }
    }
}
 
pair <long long, string> find_largest_group(long long v, long long k) {
    if (T[v].count <= k) {
        string s = "";
        if (v != 0) {
            s += T[v].pref;
        }
 
        return make_pair(v, s);
    }
 
    string largest_group_path = "";
    long long largest_group = 0, largest_group_index = -1;    
 
    for (long long i = 0; i < T[v].children.size(); ++i) {
        long long child = T[v].children[i];
        if (T[child].pref != ' ') {
            pair <long long, string> child_largest = find_largest_group(child, k);
            if (T[child_largest.first].count > largest_group) {
                largest_group = T[child_largest.first].count;
                largest_group_index = child_largest.first;
                largest_group_path = child_largest.second;
            }
        }
    }
 
    if (v != 0) {
        return make_pair(largest_group_index, T[v].pref + largest_group_path);
    }
    else {
        return make_pair(largest_group_index, largest_group_path);
    }
}
 
void remove_group(string x, long long v, long long u) {
    if (x.size() == 0) {
        T[v].count = 0;
        return;
    }
 
    for (long long i = 0; i < T[v].children.size(); ++i) {
        Node child = T[T[v].children[i]];
        if (x.size() == 0 && child.pref == ' ') {
            T[v].count -= T[u].count;
            remove_group(x.substr(1), T[v].children[i], u);
        }
         
        if (child.pref == x[0]) {
            T[v].count -= T[u].count;
            remove_group(x.substr(1), T[v].children[i], u);
        }
    }
}
 
long long main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
 
    long long t_first_empty = 1;
    for (long long i = 0; i < MAX_N; ++i) {
        T[i].pref = ' ';
        T[i].count = 0;
        T[i].children.assign(0, 0);
    }

    long long n, k;
    cin >> n >> k;
 
    T[0].pref = ' ';
 
    for (long long i = 0; i < n; ++i) {
        string x;
        cin >> x;
 
        add_to_tree(x, 0);
    }
 
    /*
    for (long long i = 0; i < MAX_N; ++i) {
        cout << i << " " << T[i].pref << ' ' << T[i].count << " {";
        for (long long j = 0; j < T[i].children.size(); ++j) {
            cout << T[i].children[j];
 
            if (j != T[i].children.size() - 1) {
                cout << " ";
            }
        }
 
        cout << "}\n";
    }
    */
 
    long long g = 0;
    while (T[0].count != 0) {
        pair <long long, string> u = find_largest_group(0, k);
        //cout << u.second + "*" << endl;
        remove_group(u.second, 0, u.first);
        ++g;
    }
     
    cout << g;
     
    return 0;
}