#define ln '\n'
#define All(x) x.begin(), x.end()
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <iterator>
#include <cmath>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <cstdlib>
#include <climits>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

typedef vector<bool> vb;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<double> vd;
typedef vector<char> vc;
typedef vector<string> vs;

typedef vector<vb> vvb;
typedef vector<vi> vvi;
typedef vector<vll> vvll;
typedef vector<vc> vvc;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

class String
{
public:
	static vector<ll> Z_foo(string& s)
	{
		ll n = s.size();
		vll res(n);
		res[0] = n;
		for (ll i = 1, l = 0, r = 0; i < n; i++)
		{
			if (i <= r)
				res[i] = min(r - i + 1, res[i - l]);
			while (i + res[i] < n && s[res[i]] == s[i + res[i]])
				res[i]++;
			if (i + res[i] - 1 > r)
			{
				l = i;
				r = i + res[i] - 1;
			}
		}
		return res;
	}
	template <typename T>
	static vector<ll> Z_foo(vector<T>& s)
	{
		ll n = s.size();
		vll res(n);
		res[0] = n;
		for (ll i = 1, l = 0, r = 0; i < n; i++)
		{
			if (i <= r)
				res[i] = min(r - i + 1, res[i - l]);
			while (i + res[i] < n && s[res[i]] == s[i + res[i]])
				res[i]++;
			if (i + res[i] - 1 > r)
			{
				l = i;
				r = i + res[i] - 1;
			}
		}
		return res;
	}

	static vector<ll> PI_foo(string& s)
	{
		ll n = s.size();
		vll res(n);
		res[0] = 0;
		for (ll i = 1; i < n; i++)
		{
			ll j = res[i - 1];
			while (j > 0 && s[i] != s[j])
				j = res[j - 1];
			if (s[i] == s[j])
				j++;
			res[i] = j;
		}
		return res;
	}
	template<typename T>
	static vector<ll> PI_foo(vector<T>& s)
	{
		ll n = s.size();
		vll res(n);
		res[0] = 0;
		for (ll i = 1; i < n; i++)
		{
			ll j = res[i - 1];
			while (j > 0 && s[i] != s[j])
				j = res[j - 1];
			if (s[i] == s[j])
				j++;
			res[i] = j;
		}
		return res;
	}
};
class Vector
{
public:
	template <typename T>
	static void Print(vector<T>& v)
	{
		copy(All(v), ostream_iterator<T>(cout, " "));
	}
	template <typename T>
	static void Read(vector<T>& v)
	{
		for (int i = 0; i < v.size(); i++)
			cin >> v[i];
	}
};
class Math
{
public:
	template <typename T>
	static T gcd(T a, T b) {
		return (a == 0) ? b : gcd(b % a, a);
	}
};

bool CheckForQ(vvc& a, int i, int j)
{
	if (a[i][j + 1] == '#'
		&& a[i][j + 2] == '#'
		&& a[i + 1][j] == '#'
		&& a[i + 1][j + 2] == '#'
		&& a[i + 2][j] == '#'
		&& a[i + 2][j + 1] == '#'
		&& a[i + 2][j + 2] == '#'
		&& a[i + 3][j + 2] == '#'
		&& a[i + 4][j + 2] == '#')
		return 1;
	else
		return 0;
}
bool CheckForF(vvc& a, int i, int j)
{
	if (a[i][j + 1] == '#'
		&& a[i][j + 2] == '#'
		&& a[i + 1][j] == '#'
		&& a[i + 2][j] == '#'
		&& a[i + 2][j + 1] == '#'
		&& a[i + 3][j] == '#'
		&& a[i + 4][j] == '#')
		return 1;
	else
		return 0;
}

void rec(vvc a)
{

}

void solve()
{
	ll n, m;
	cin >> n >> m;
	vvc a(n, vc(m));
	for (int i = 0; i < n; i++)
		Vector::Read(a[i]);

	ll q = 0, f = 0;
	for (int t = 0; t < 100; t++)
	{
		for (int i = 0; i < n - 4; i++)
		{
			for (int j = 0; j < m - 2; j++)
			{
				if (a[i][j] == '#')
				{
					if (CheckForF(a, i, j))
					{
						if (CheckForQ(a, i, j))
						{
							continue;
						}
						else
						{
							f++;
							a[i][j + 1] =
								a[i][j + 2] =
								a[i + 1][j] =
								a[i + 2][j] =
								a[i + 2][j + 1] =
								a[i + 3][j] =
								a[i + 4][j] = '.';
						}
					}
					else
						if (CheckForQ(a, i, j))
						{
							q++;
							a[i][j + 1] =
								a[i][j + 2] =
								a[i + 1][j] =
								a[i + 1][j + 2] =
								a[i + 2][j] =
								a[i + 2][j + 1] =
								a[i + 2][j + 2] =
								a[i + 3][j + 2] =
								a[i + 4][j + 2] = '.';
						}
				}
			}
		}
	}
	cout << q << ' ' << f << ln;
}

/*
8 8
###..###
#....#.#
##...###
#..###.#
#..#.#.#
...###..
.....#..
.....#..

10 11
...........
.###..###..
.#....#.#..
.##...###..
.#..###.#..
.#..#.#.#..
....###....
......#....
......#....
...........
*/

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//int t;
	//cin >> t;
	//while (t--)
		solve();
}