﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;

namespace Olimp
{
    class Program
    {
        static void Main()
        {
            var inputParams = Console.ReadLine().Split().Select(x => int.Parse(x)).ToArray();
            var height = inputParams[0];
            var width = inputParams[1];
            var usedByFMap = new int[height, width];
            var picture = new List<string>();
            var countF = 0;
            var countQ = 0;
            for (int i = 0; i < height; i++)
            {
                picture.Add(Console.ReadLine());
            }

            for (int i = 0; i < width - 2; i++)
            {
                for (int j = 0; j < height - 4; j++)
                {
                    var fIsUnused = GetFUsedThumbprint(usedByFMap, j, i).All(x => x == 0);
                    if (fIsUnused &&
                        (i < 2 || usedByFMap[j, i - 1] > 0 ||
                         !IsSharp(picture[j][i - 1])) &&
                        GetFThumbprint(picture, j, i).All(c => IsSharp(c)) &&
                        !IsSharp(picture[j + 1][i + 1]))
                    {
                        IncreaseFUsedThumbprint(usedByFMap, j, i);
                        countF++;
                        j += 4;
                    }
                    else
                    {
                        if (IsSharp(picture[j][i]) && GetQThumbprint(picture, j, i).All(IsSharp) &&
                            GetQUsedThumbprint(usedByFMap, j, i).All(x => x == 0))
                        {
                            IncreaseQUsedThumbprint(usedByFMap, j, i);
                            countQ++;
                            j += 4;
                        }
                    }
                }
            }

            Console.WriteLine($"{countQ} {countF}");
        }

        static bool ItIsF(List<string> map, int[,] usedMap, int x, int y)
        {
            if (IsSharp(map[x][y]) &&
                IsSharp(map[x][y + 1]) &&
                IsSharp(map[x][y + 2]) &&
                IsSharp(map[x + 1][y]) &&
                IsSharp(map[x + 2][y]) &&
                IsSharp(map[x + 2][y + 1]) &&
                IsSharp(map[x + 3][y]) &&
                IsSharp(map[x + 4][y]) &&
                !IsSharp(map[x + 1][y + 1]))
            {
                usedMap[x, y]++;
                usedMap[x, y + 1]++;
                usedMap[x, y + 2]++;
                usedMap[x + 1, y]++;
                usedMap[x + 2, y]++;
                usedMap[x + 2, y + 1]++;
                usedMap[x + 3, y]++;
                usedMap[x + 4, y]++;
                return true;
            }

            return false;
        }

        static bool ItIsQ(List<string> map, int[,] usedMap, int x, int y)
        {
            if (IsSharp(map[x][y]) && usedMap[x, y] == 0 &&
                IsSharp(map[x][y + 1]) && usedMap[x, y + 1] == 0 &&
                IsSharp(map[x][y + 2]) && usedMap[x, y + 2] == 0 &&
                IsSharp(map[x + 1][y]) && usedMap[x + 1, y] == 0 &&
                IsSharp(map[x + 1][y + 2]) && usedMap[x + 1, y] == 0 &&
                IsSharp(map[x + 2][y]) && usedMap[x + 2, y] == 0 &&
                IsSharp(map[x + 2][y + 1]) && usedMap[x + 2, y + 1] == 0 &&
                IsSharp(map[x + 2][y + 2]) && usedMap[x + 2, y + 2] == 0 &&
                IsSharp(map[x + 3][y + 2]) && usedMap[x + 3, y + 2] == 0 &&
                IsSharp(map[x + 4][y + 2]) && usedMap[x + 4, y + 2] == 0 &&
                !IsSharp(map[x + 1][y + 1]))
            {
                usedMap[x, y]++;
                usedMap[x, y + 1]++;
                usedMap[x, y + 2]++;
                usedMap[x + 1, y]++;
                usedMap[x + 1, y + 2]++;
                usedMap[x + 2, y]++;
                usedMap[x + 2, y + 1]++;
                usedMap[x + 2, y + 2]++;
                usedMap[x + 3, y + 2]++;
                usedMap[x + 4, y + 2]++;

                return true;
            }

            return false;
        }

        static bool IsSharp(char c)
        {
            return c == '#';
        }

        static char[] GetQThumbprint(List<string> map, int x, int y)
        {
            return new[]
            {
                map[x][y],
                map[x][y + 1],
                map[x][y + 2],
                map[x + 1][y],
                map[x + 1][y + 2],
                map[x + 2][y],
                map[x + 2][y + 1],
                map[x + 2][y + 2],
                map[x + 3][y + 2],
                map[x + 4][y + 2]
            };
        }

        static int[] GetQUsedThumbprint(int[,] map, int x, int y)
        {
            return new[]
            {
                map[x, y],
                map[x, y + 1],
                map[x, y + 2],
                map[x + 1, y],
                map[x + 1, y + 2],
                map[x + 2, y],
                map[x + 2, y + 1],
                map[x + 2, y + 2],
                map[x + 3, y + 2],
                map[x + 4, y + 2]
            };
        }

        static void IncreaseQUsedThumbprint(int[,] map, int x, int y)
        {
            map[x, y]++;
            map[x, y + 1]++;
            map[x, y + 2]++;
            map[x + 1, y]++;
            map[x + 1, y + 2]++;
            map[x + 2, y]++;
            map[x + 2, y + 1]++;
            map[x + 2, y + 2]++;
            map[x + 3, y + 2]++;
            map[x + 4, y + 2]++;
        }

        static char[] GetFThumbprint(List<string> map, int x, int y)
        {
            return new[]
            {
                map[x][y],
                map[x][y + 1],
                map[x][y + 2],
                map[x + 1][y],
                map[x + 2][y],
                map[x + 2][y + 1],
                map[x + 3][y],
                map[x + 4][y]
            };
        }

        static int[] GetFUsedThumbprint(int[,] map, int x, int y)
        {
            return new[]
            {
                map[x, y],
                map[x, y + 1],
                map[x, y + 2],
                map[x + 1, y],
                map[x + 2, y],
                map[x + 2, y + 1],
                map[x + 3, y],
                map[x + 4, y]
            };
        }

        static void IncreaseFUsedThumbprint(int[,] map, int x, int y)
        {
            map[x, y]++;
            map[x, y + 1]++;
            map[x, y + 2]++;
            map[x + 1, y]++;
            map[x + 2, y]++;
            map[x + 2, y + 1]++;
            map[x + 3, y]++;
            map[x + 4, y]++;
        }

        static bool ThumbprintIsFilled(int[] thumbprint)
        {
            return thumbprint.All(x => x > 0);
        }
    }
}