#include<iostream>
#include<string>
#include<vector>
#include<stack>
#include<map>

using namespace std;

pair<string, int> split(const string& expr)
{
	int i = 0;
	string name = "";
	string num = "";
	for (; expr[i] != '=' && expr[i] != ' '; ++i)
	{
		name.push_back(expr[i]);
	}
	++i;
	for (; i < expr.size(); ++i)
	{
		num.push_back(expr[i]);
	}
	return {name, stoi(num)};
}

int main()
{
	int n;
	cin >> n;

	vector< vector<pair<string, int>> > threads(n);
	for (int i = 0; i < n; ++i)
	{
		int k;
		cin >> k;
		cin >> ws;
		for (int j = 0; j < k; ++j)
		{
			string expression;
			getline(cin, expression, '\n');
			threads[i].push_back(split(expression));
		}
	}
	int cvar;
	cin >> cvar;
	cin >> ws;
	map < string, int > pos;
	vector<int> totals(cvar);
	for (int i = 0; i < cvar; ++i)
	{
		string expression;
		getline(cin, expression, '\n');
		auto r = split(expression);
		pos[r.first] = i;
		totals[i] = r.second;
	}

	vector< stack<pair<int, bool>> > sth(n);
	for (int i = 0; i < n; ++i)
	{
		for (const auto& k : threads[i])
		{
			sth[i].push({ pos[k.first], k.second == totals[pos[k.first]] });
		}
	}
	pos.clear();

	stack<int> result;
	vector<bool> changeble(cvar, false);
	bool cnt, wrong(false);
	do
	{
		wrong = true;
		for (int i = 0; i < n; ++i)
		{
			if (sth.size())
			{
				auto cur = sth[i].top();
				if (changeble[cur.first] || cur.second)
				{
					changeble[cur.first] = true;
					result.push(i + 1);
					sth[i].pop();
					wrong = false;
				}
			}
		}

		cnt = false;
		for (const auto& i : sth)
		{
			if (i.size())
			{
				cnt = true;
				break;
			}
		}
	} while (cnt&&!wrong);

	if (cnt)
	{
		cout << "No";
	}
	else
	{
		cout << "Yes\n";
		while (result.size())
		{
			cout << result.top() << ' ';
			result.pop();
		}
	}

	return 0;
}