#include <bits/stdc++.h>
#include <unordered_set>

using namespace std;

#define PI 3.1415926535897932384626433832795
#define MOD 1000000007

typedef long long ll;
typedef unsigned long long ull;

constexpr ll INF64 = numeric_limits<ll>::max();
constexpr int INF32 = numeric_limits<int>::max();

string itoa(int a) { ostringstream s; s << a; return s.str(); };
int atoi(string x) { int k(0); for (int i(0); i < x.size(); i++) k = k * 10 + (x[i] - '0'); return k; }
ll powmod(ll a, ll b) { ll res = 1; a %= MOD; assert(b >= 0); for (; b; b >>= 1) { if (b & 1)res = res * a % MOD; a = a * a % MOD; }return res; }

/**
 * Limits in C++ for reference
 * _____________________________________________________________________________________
 * |Sr| Macro Name | Description                     | Value
 * |No|____________|_________________________________|__________________________________
 * |1.| ULLONG_MAX | Maximum value unsigned long long| 18,446,744,073,709,551,615 (10^20)
 * |2.| LLONG_MAX  | Maximum value long long         | 9,223,372,036,854,775,807 (10^19)
 * |3.| LLONG_MIN  | Minimum value long long         |-9,223,372,036,854,775,808 -1*(10^19)
 * |4.| INT_MAX    | Maximum value int               | 2,147,483,647 (10^10)
 * |5.| INT_MIN    | Minimum value int               |-2,147,483,648 (10^10)
*/

void solve(ll test_case) {
    ll n, m, c;
    cin >> n >> m >> c;
    ll M = -1, C = -1;
    ll best = INF32;
    for (ll i = 0; i * m < n; i++) {
        ll l = 0, r = 6'000'000;
        while (r - l > 1) {
            ll mid = l + (r - l) / 2;
            ll tmp = abs(i * m + mid * c - n);
            if (tmp < best) {
                best = tmp;
                M = i;
                C = mid;
            }
            ll tmp1 = abs(i * m + l * c - n),
                tmp2 = abs(i * m + r * c - n);
            if (tmp1 <= tmp2) {
                r = mid - 1;
            } else {
                l = mid + 1;
            }
        }
    }
    cout << M << ' ' << C << endl;
}

// #define IOFILES
// #define MANY_TESTS

int main() {
#ifdef IOFILES
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

#ifdef MANY_TESTS
    ll t, t1 = 0;
    cin >> t;
    while (t1 < t) {
        solve(t1 + 1);
        t1++;
    }
#else
    solve(0);
#endif
}