#include <bits/stdc++.h>
#include <unordered_set>

using namespace std;

#define PI 3.1415926535897932384626433832795
#define MOD 1000000007

typedef long long ll;
typedef unsigned long long ull;

constexpr ll INF64 = numeric_limits<ll>::max();
constexpr int INF32 = numeric_limits<int>::max();

string itoa(int a) { ostringstream s; s << a; return s.str(); };
int atoi(string x) { int k(0); for (int i(0); i < x.size(); i++) k = k * 10 + (x[i] - '0'); return k; }
ll powmod(ll a, ll b) { ll res = 1; a %= MOD; assert(b >= 0); for (; b; b >>= 1) { if (b & 1)res = res * a % MOD; a = a * a % MOD; }return res; }

/**
 * Limits in C++ for reference
 * _____________________________________________________________________________________
 * |Sr| Macro Name | Description                     | Value
 * |No|____________|_________________________________|__________________________________
 * |1.| ULLONG_MAX | Maximum value unsigned long long| 18,446,744,073,709,551,615 (10^20)
 * |2.| LLONG_MAX  | Maximum value long long         | 9,223,372,036,854,775,807 (10^19)
 * |3.| LLONG_MIN  | Minimum value long long         |-9,223,372,036,854,775,808 -1*(10^19)
 * |4.| INT_MAX    | Maximum value int               | 2,147,483,647 (10^10)
 * |5.| INT_MIN    | Minimum value int               |-2,147,483,648 (10^10)
*/

vector<pair<int, int>> Q = {
    {0, 0}, {0, 1}, {0, 2},
    {1, 0},         {1, 2},
    {2, 0}, {2, 1}, {2, 2},
                    {3, 2},
                    {4, 2}
};
vector<pair<int, int>> F = {
    {0, 0}, {0, 1}, {0, 2},
    {1, 0},
    {2, 0}, {2, 1},
    {3, 0},
    {4, 0}
};

vector<vector<char>> gr;
int n, m;

bool isQ(const vector<vector<char>>& grid, int x, int y) {
    for (int i = 0; i < Q.size(); i++) {
        auto [l, r] = Q[i];
        if (l + x >= n || r + y >= m) {
            return false;
        }
        if (grid[l + x][r + y] != '#') {
            return false;
        }
    }
    return true;
}

bool isF(const vector<vector<char>>& grid, int x, int y) {
    for (int i = 0; i < F.size(); i++) {
        auto [l, r] = F[i];
        if (l + x >= n || r + y >= m) {
            return false;
        }
        if (grid[l + x][r + y] != '#') {
            return false;
        }
    }
    return true;
}

void changeQ(vector<vector<char>>& grid, int x, int y) {
    for (int i = 0; i < Q.size(); i++) {
        auto [l, r] = Q[i];
        grid[l + x][r + y] = '.';
    }
}
void changeF(vector<vector<char>>& grid, int x, int y) {
    for (int i = 0; i < F.size(); i++) {
        auto [l, r] = F[i];
        grid[l + x][r + y] = '.';
    }
}

int rresQ, rresF;

bool requrse(vector<vector<char>> tmp, int count, int i, int j, int resQ, int resF) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            bool is_q = isQ(tmp, i, j);
            bool is_f = isF(tmp, i, j);
            if (is_q && is_f) {
                vector<vector<char>> tmp1 = tmp,
                    tmp2 = tmp;
                changeQ(tmp1, i, j);
                changeF(tmp2, i, j);
                if (requrse(tmp1, count - 10, i, j, resQ + 1, resF)) {
                    return true;
                } else if (requrse(tmp2, count - 8, i, j, resQ, resF + 1)) {
                    return true;
                }
            }
            else if (is_q) {
                for (int z = 0; z < Q.size(); z++) {
                    auto [l, r] = Q[z];
                    tmp[l + i][r + j] = '.';
                    count--;
                }
                resQ++;
            }
            else if (is_f) {
                for (int z = 0; z < F.size(); z++) {
                    auto [l, r] = F[z];
                    tmp[l + i][r + j] = '.';
                    count--;
                }
                resF++;
            }
        }
    }
    if (count == 0) {
        rresQ = resQ;
        rresF = resF;
        return true;
    }
    else {
        return false;
    }
}

void solve(ll test_case) {
    cin >> n >> m;
    gr.resize(n, vector<char>(m));
    int count = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> gr[i][j];
            if (gr[i][j] == '#') {
                ++count;
            }
        }
    }
    requrse(gr, count, 0, 0, 0, 0);
    cout << rresQ << ' ' << rresF << endl;
}

// #define IOFILES
// #define MANY_TESTS

int main() {
#ifdef IOFILES
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

#ifdef MANY_TESTS
    ll t, t1 = 0;
    cin >> t;
    while (t1 < t) {
        solve(t1 + 1);
        t1++;
    }
#else
    solve(0);
#endif
}