#include <bits/stdc++.h>

using namespace std;

const int CHAR_SIZE = 128;

int n, k;
long long ans = 0;

class Trie
{
public:
    bool isLeaf;
    Trie *character[CHAR_SIZE];
    int amountOfChildren;

    Trie()
    {
        this->isLeaf = false;
        this->amountOfChildren = 0;

        for (int i = 0; i < CHAR_SIZE; i++)
        {
            this->character[i] = nullptr;
        }
    }

    void insert(string &);
    Trie *maxChild();
};

void Trie::insert(string &key)
{
    Trie *curr = this;
    for (int i = 0; i < key.length(); i++)
    {
        if (curr->character[key[i]] == nullptr)
            curr->character[key[i]] = new Trie();

        curr->amountOfChildren++;
        curr = curr->character[key[i]];
    }

    curr->amountOfChildren++;
    curr->isLeaf = true;
}

Trie *Trie::maxChild()
{
    Trie *curr = this;
    Trie *maxChild = nullptr;

    for (int i = 0; i < CHAR_SIZE; i++)
    {
        if (curr->character[i] && (!maxChild || curr->character[i]->amountOfChildren > maxChild->amountOfChildren))
            maxChild = curr->character[i];
    }

    return maxChild;
}

void dfs(Trie *node, int &lazy)
{
    while (node->amountOfChildren > 0)
    {
        auto maxChild = node->maxChild();
        if (maxChild->amountOfChildren <= k)
        {
            ans++;
            lazy += maxChild->amountOfChildren;
            node->amountOfChildren -= maxChild->amountOfChildren;
            maxChild->amountOfChildren = 0;
            return;
        }
        else
        {
            int nextLazy = 0;
            dfs(maxChild, nextLazy);
            node->amountOfChildren -= nextLazy;
            lazy += nextLazy;
            if (node->amountOfChildren <= k)
                return;
        }
    }
}

void solve()
{
    Trie *root = new Trie();
    cin >> n >> k;
    for (auto i = 0; i < n; ++i)
    {
        string cur;
        cin >> cur;
        root->insert(cur);
    }
    int lazy = 0;
    while (root->amountOfChildren > 0)
    {
        if (root->amountOfChildren <= k)
        {
            ans++;
            break;
        }
        dfs(root, lazy);
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    solve();

    return 0;
}
