"""
usefull snippets:
    - map(int, input().split())
    - map(int, sys.stdin.readline().split()))
    - int(input())
    - int(sys.stdin.readline().strip())
    - sys.stdout.write()
    - sys.stdout.write(" ".join(map(str, c) # writes c - collection of ints
"""
# import collections
import heapq
import sys
from bisect import bisect_left
from collections import deque
from math import gcd
from collections import defaultdict


# recursion increase
# sys.setrecursionlimit(10000)

# number with big precision
# from decimal
# getcontext().prec = 10_000


# input parser
# n, d, li, ld, ls, s - int, float, list of ints, list of floats, list of string, string
# lists are lines with ' '(space) delimiters
def get_from_input(format: str, wrap_lists=True):
    result = []
    selected_types = format.split()
    for type in selected_types:
        input = sys.stdin.readline().strip()
        if type == 'n':
            result.append(int(input))
        elif type == 'd':
            result.append(float(input))
        elif type == 's':
            result.append(input)
        elif type == 'li':
            mapped = map(int, input.split())
            result.append(list(mapped) if wrap_lists else mapped)
        elif type == 'ld':
            mapped = map(float, input.split())
            result.append(list(mapped) if wrap_lists else mapped)
        elif type == 'ls':
            result.append(list(input.split()))

    if len(result) == 1:
        return result[0]
    return result


# splits aaasfffsga into (aaa, s, fff, s, g, a) blocks with signature (startPos, length, type)
def split_into_blocks(s):
    blocks = []

    i = 0
    curr_type = s[0]
    curr_len = 0
    while i < len(s):
        if s[i] == curr_type:
            curr_len += 1
            i += 1
        else:
            blocks.append((i - curr_len, curr_len, curr_type))
            curr_type = s[i]
            curr_len = 0

    blocks.append((i - curr_len, curr_len, curr_type))

    return blocks


# longest common prefix
def get_lcp(s, suffix_array):
    s = s + "$"
    n = len(s)
    lcp = [0] * (n)
    pos = [0] * (n)
    for i in range(n - 1):
        pos[suffix_array[i]] = i
    k = 0
    for i in range(n - 1):
        if k > 0:
            k -= 1
        if pos[i] == n - 1:
            lcp[n - 1] = -1
            k = 0
            continue
        else:
            j = suffix_array[pos[i] + 1]
            while max([i + k, j + k]) < n and s[i + k] == s[j + k]:
                k += 1
            lcp[pos[i]] = k

    return lcp


def get_suffix_array(word):
    suffix_array = [("", len(word))]

    for position in range(len(word)):
        sliced = word[len(word) - position - 1:]
        suffix_array.append((sliced, len(word) - position - 1))

    suffix_array.sort(key=lambda x: x[0])
    return [item[1] for item in suffix_array]


def get_ints():
    return map(int, sys.stdin.readline().strip().split())


def bin_search(collection, element):
    i = bisect_left(collection, element)
    if i != len(collection) and collection[i] == element:
        return i
    else:
        return -1


def bp(a, aim):
    l = -1
    r = len(a)
    while l < r - 1:
        m = (l + r) // 2
        if a[m] < aim:
            l = m
        else:
            r = m

    return r


def main():
    n, k = get_ints()
    d = defaultdict(set)
    cnt = defaultdict(int)

    start = ""
    for i in range(n):
        s = str(input())
        last = ""
        cnt[start] += 1
        for j in range(1, len(s) + 1):
            pref = s[:j]
            cnt[pref] += 1
            d[last].add(pref)
            last = pref

    ans = 0
    v = defaultdict(list)

    while cnt[start] != 0:
        max_cnt, max_pref = 0, ""
        h = []
        q = deque()
        q.append(start)
        for pref in d[start]:
            if cnt[pref] == k:
                cnt[pref] = 0
                cnt[start] -= k
                ans += 1
            elif cnt[pref] < k:
                v[start].append(cnt[pref])
            else:
                q.appendleft(pref)

        while q:
            pref = q.popleft()
            if cnt[pref] == 0:
                continue
            elif cnt[pref] < k:
                if pref != start:
                    v[pref[:len(pref) - 1]].append(cnt[pref])
                else:
                    ans += 1
                    cnt[start] = 0
                continue
            elif cnt[pref] == k:
                ans += 1
                for i in range(len(pref) + 1):
                    cnt[pref[:i]] -= k
                continue


            need_again = False
            for e in d[pref]:
                if cnt[e] == 0:
                    continue
                elif cnt[e] == k:
                    for i in range(len(e) + 1):
                        cnt[e[:i]] -= k
                    ans += 1
                elif cnt[e] < k:
                    v[pref].append(cnt[e])
                else:
                    if not need_again:
                        q.appendleft(pref)
                        need_again = True
                    q.appendleft(e)

            if not need_again:
                if cnt[pref] == k:
                    cnt[pref] = 0
                    ans += 1
                    continue
                elif 0 < cnt[pref] < k:
                    if pref == start:
                        ans += 1
                        cnt[pref] = 0
                        continue
                    v[pref[:len(pref) - 1]].append(cnt[pref])
                    continue

                v[pref].sort(reverse=True)
                curr = cnt[pref]
                ind = 0
                while curr > k and ind < len(v[pref]):
                    curr -= v[pref][ind]
                    ind += 1
                    ans += 1

                if curr == k:
                    ans += 1
                    curr = 0

                for i in range(len(pref) + 1):
                    cnt[pref[:i]] -= cnt[pref] - curr

                if ind == len(v[pref]):
                    print('WTF')
                    exit()

        if 0 < cnt[start] <= k:
            ans += 1
            cnt[start] = 0

    print(ans)


if __name__ == "__main__":
    main()
