﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace icpcsharp
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split();
            int a, b;
            b = Convert.ToInt32(s[0]);
            a = Convert.ToInt32(s[1]);
            Grid g = new Grid(a, b);
            for (int k = 0; k < b; k++)
            {
                for (int i = 0; i < a; i++)
                {
                    char c = Console.ReadKey().KeyChar;
                    if (c != '#' && c!='.')
                    {
                        i--;
                        continue;
                    }
                    g[i, k] =  c == '#';
                }
            }
            int q = 0, f = 0;
            for (int y = 0; y < b; y++)
            {
                for (int x = 0; x < a; x++)
                {

                    if (g[x, y])
                    {
                        if (g.CheckQ(x, y))
                        {
                            q++;
                            g.EraseQ(x, y);
                        }
                        else
                        {
                            f++;
                            g.EraseF(x, y);
                        }
                    }
                }
            }
            Console.WriteLine(q + " " + f);
        }
    }
    class Custom
    {
        public bool Ended = false;
        public bool Empty = false;
        public Dictionary<string, Custom> dict = new Dictionary<string, Custom>();

        public void Add(string word)
        {
            if (word == "") dict.Add("", new Custom { Ended = true });
            else
            {
                if (!dict.ContainsKey(word[0].ToString())) dict[word[0].ToString()] = new Custom();
                dict[word[0].ToString()].Add(word.Substring(1, word.Length - 1));
            }
        }
        public int GetWordsCount()
        {
            if (Empty) return 0;
            if (Ended) return 1;
            int count = 0;
            foreach (var i in dict)
            {
                if (i.Key == "") count++;
                else
                {
                    count += i.Value.GetWordsCount();
                }
            }
            return count;
        }

        public long GetMaxWordsCount(long max)
        {
            int s = GetWordsCount();
            if (s <= max) return s;
            else
            {
                long mm = 0;
                foreach (var i in dict)
                {
                    mm = Math.Max(mm, i.Value.GetMaxWordsCount(max));
                }
                return mm;
            }
        }
        public void DeleteMaxWords(long max)
        {
            int s = GetWordsCount();
            if (s <= max)
            {
                Empty = true;
            }
            else
            {
                long mm = 0;
                string h = "";
                foreach (var i in dict)
                {
                    if (i.Value.Empty) continue;
                    if (mm < i.Value.GetMaxWordsCount(max))
                    {
                        h = i.Key;
                        mm = i.Value.GetMaxWordsCount(max);
                    }
                }
                dict[h].DeleteMaxWords(max);
            }
        }
    }

    class Grid
    {
        bool[,] grid;
        int sizeX;
        int sizeY;

        public bool this[int a, int b]
        {
            get
            {
                if (a < 0 || b < 0 || a >= sizeX || b >= sizeY) return false;
                return grid[a, b];
            }
            set
            {
                grid[a, b] = value;

            }
        }

        public Grid(int n, int m)
        {
            grid = new bool[n, m];
            sizeX = n;
            sizeY = m;
        }

        public bool CheckQ(int x,int y)
        {
            if (
                this[x, y] &&
                this[x + 1, y] &&
                this[x + 2, y] &&
                this[x + 2, y + 1] &&
                this[x + 2, y + 2] &&
                this[x, y + 1] &&
                this[x, y + 2] &&
                this[x + 1, y + 2] &&
                this[x + 2, y + 3] &&
                this[x + 2, y + 4] &&
                !CheckQ(x + 2, y + 1) &&
                !CheckF(x + 2, y + 1))
            {
                return true;
            }
            else return false;
        }
        public bool CheckF(int x,int y)
        {
            if (
                this[x, y] &&
                this[x + 1, y] &&
                this[x + 2, y] &&
                this[x, y + 1] &&
                this[x, y + 2] &&
                this[x, y + 3] &&
                this[x, y + 4] &&
                this[x + 1, y + 2] &&
                !CheckQ(x - 2, y + 3))
            {
                return true;
            }
            else return false;
        }
        public void EraseQ(int x, int y)
        {
            this[x, y] = false;
            this[x + 1, y] = false;
            this[x + 2, y] = false;
            this[x + 2, y + 1] = false;
            this[x + 2, y + 2] = false;
            this[x, y + 1] = false;
            this[x, y + 2] = false;
            this[x + 1, y + 2] = false;
            this[x + 2, y + 3] = false;
            this[x + 2, y + 4] = false;
        }

        public void EraseF(int x, int y)
        {
            this[x, y] = false;
            this[x + 1, y] = false;
            this[x + 2, y] = false;
            this[x, y + 1] = false;
            this[x, y + 2] = false;
            this[x, y + 3] = false;
            this[x, y + 4] = false;
            this[x + 1, y + 2] = false;
        }
    }
}
