import java.io.BufferedReader;
import java.io.Console;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;


public class Main {
    static class Tree {
        private String name;
        private HashMap<Character, Tree> childs = new HashMap<>();
        public int count;
        public void addWord(String word, int from) {
            count+=1;

            if (from >= word.length())
                return;
            if(!childs.containsKey(word.charAt(from))) {
                childs.put(word.charAt(from), new Tree());
            }
            childs.get(word.charAt(from)).addWord(word, from + 1);
        }
        public int deleteWordsByPrefix(int max) {
            try {
                if(count <= max) {
                    int wasCount = count;
                    count = 0;
                    childs.clear();
                    return wasCount;
                }
                int maxT = -1;
                Tree maxTree = null;
                Character maxKey = null;

                for (var c:
                        childs.entrySet()) {
                    if (c.getValue().count > maxT) {
                        maxT = c.getValue().count;
                        maxTree = c.getValue();
                        maxKey = c.getKey();
                    }
                }
                var deletedCount = maxTree.deleteWordsByPrefix(max);
                count -= deletedCount;
                childs.remove(maxKey);
                return deletedCount;
            } catch (NullPointerException e) {
                return 0;
            }
        }
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        var inn = sc.nextLine().split(" ");
        var begTree = new Tree();
        long count = Long.parseLong(inn[0]);
        int max = Integer.parseInt(inn[1]);
        for (int i = 0; i < count; i++) {
            String wd = sc.nextLine();
            begTree.addWord(wd, 0);
        }
        int deleteCount = 0;
        while (begTree.count > 0) {
            deleteCount+=1;
            begTree.deleteWordsByPrefix(max);
        }

        System.out.println(deleteCount);
    }
}
