/*
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XX   XXXXXXXXX  XXXXXXXXXXXXXXXX  XXXXXXXXXXXXXXXXXXXXXXXXX X
X XXX XX   XXXX XXXX    X XXX XXX XXXX   XXXX XXXX   XXXXXX X
X XXXXXXXXX XXX XXX XXXXX XXX XXX XXXXXXX XX   XX XXX XX    X
X XXXXX     XXX XXX XXXXX XXX XXX XXX     XXX XXX     X XXX X
X XXX X XXX XXX XXX XXXXX XXX XXX XXX XXX XXX XXX XXXXX XXX X
XX   XXX    XX   XXX    XX    XX   XXX    XXX  XXX    XX    X
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXX     XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXX XXXXX   XXXX   XX  X XXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXX XXXX XXX XXXXXX X X X XXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXX XXXX     XX     X X X XXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXX XXXX XXXXXX XXX X XXX XXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXX XXXXX    XXX    X XXX XXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
*/

#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <chrono>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <array>
#include <set>
#include <list>
#include <cmath>
#include <string>
#include <queue>
#include <stack>
#include <unordered_map>
#include <map>
#include <iterator>
#include <cstring>
using namespace std;

#define loop(i,start,end) for(auto i = start; i < end; i++)
#define loopi(end) loop(i,0,end)
#define loopj(end) loop(j,0,end)
#define loopk(end) loop(k,0,end)
#define get_i(n) int n; cin >> n;
#define get_ch(n) char x; cin >> x;
#define get_doub(n) double n; cin >> n;
#define pb push_back
#define ll long long 
#define pii pair<int,int>
#define pll pair<ll, ll>
#define vb vector<bool>
#define vi vector<int>
#define vpi vector<pii>
#define vll vector<long long>
#define vvi vector<vector<int>>
#define vvll vector<vector<long long>>
#define all(a) (a).begin(), (a).end()
const long long modulo = 1e9 + 7;
const ll INF = 1e18;
const int inf = 2e9;
const double PI = 3.141592653589793238463;

//#define FILE "scavhunt"
#define FAST_IO
#define FSOL
//#define DEBUG

int n, m;
int cnt_q = 0, cnt_f = 0;
bool used[305][305] = { 0 };
int grid[305][305] = { 0 };

int f_i[] = { 0, -1, -2, -2, -3, -4, -4, -4 },
	f_j[] = { 0, 0, 0, 1, 0, 0, 1, 2 };

int q_i[] = { 0, -1, -2, -2, -2, -3, -3, -4, -4, -4 },
	q_j[] = { 0, 0, 0, -1, -2, 0, -2, 0, -1, -2 };

bool in(int i, int j) {
	return i >= 0 && j >= 0 && i < n && j < m;
}

// 1 - letter f, -1 - letter q
int checkLetter(int i, int j) {
	// checking if f
	bool f = 1, q = 1;
	loopk(8) {
		int to_i = i + f_i[k], to_j = j + f_j[k];
		if (!in(to_i, to_j) || !grid[to_i][to_j] || used[to_i][to_j]) {
			f = 0;
			break;
		}
	}

	loopk(10) {
		int to_i = i + q_i[k], to_j = j + q_j[k];
		if (!in(to_i, to_j) || !grid[to_i][to_j] || used[to_i][to_j]) {
			q = 0;
			break;
		}
	}

	if (!q && !f)
		return 0;

	if (q) {
		loopk(10) {
			int to_i = i + q_i[k], to_j = j + q_j[k];
			used[to_i][to_j] = 1;
		}
		return -1;
	}

	loopk(8) {
		int to_i = i + f_i[k], to_j = j + f_j[k];
		used[to_i][to_j] = 1;
	}
	return 1;
}

void bfs(int i, int j) {
	if (!grid[i][j]) {
		used[i][j] = 1;
		return;
	}
	int a = checkLetter(i, j);
	if (a == 1)
		++cnt_f;
	else if (a == -1)
		++cnt_q;
}

#ifdef FSOL
void solve() {
	cin >> n >> m;
	char x;
	loopi(n) loopj(m)
		cin >> x, grid[i][j] = x == '#';

	for (int i = n - 1; i >= 0; --i)
		for (int j = m - 1; j >= 0; --j)
			if (!used[i][j])
				bfs(i, j);

	cout << cnt_q << " " << cnt_f;
}

#else 
void solve() {

}
#endif

int main() {
#ifdef FAST_IO
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
#ifdef DEBUG
	freopen("debug.in", "r", stdin);
	freopen("debug.txt", "w", stdout);
	auto timestamp = std::chrono::system_clock::now();
#else 
#ifdef FILE
	freopen(FILE".in", "r", stdin);
	freopen(FILE".out", "w", stdout);
#endif
#endif
	solve();
#ifdef DEBUG 
	cout << endl << "Time elapsed: " << chrono::duration_cast<chrono::milliseconds>(std::chrono::system_clock::now() - timestamp).count() << " ms" << endl;
#endif
	return 0;
}