
/*
    author: MrS4g0
    created: 11.12.2021 12:14:29
*/


#include <algorithm>
#include <iostream>
#include <map>
#include <vector>


using namespace std;

#define nl ('\n')

using i64 = long long;
using ui64 = unsigned long long;
using ld = long double;

// using i128 = __int128;
// using ui128 = unsigned __int128;
// inline i128 iget() { i64 x; cin >> x; return (i128)x; }
// inline ui128 uiget() { ui64 x; cin >> x; return (ui128)x; }

using vb = vector<bool>;
using vc = vector<char>;
using vi = vector<int>;
using vi64 = vector<i64>;
using vui64 = vector<ui64>;

using pi = pair<int, int>;
using pi64 = pair<i64, i64>;
using pui64 = pair<ui64, ui64>;
using graph = vector<vi>;

template <typename T = int>
inline T nxt() { T x; cin >> x; return x; }

constexpr int MOD = int(1e9) + 7;
constexpr int NMOD = 998244353;



/*
Complexity:
    insert O(|s|)
    erase O(|s|)
    search O(|s|)
Memory:
    O(sum(|s|))
*/

constexpr int ALPH_SIZE = 26;
constexpr int MAXN = int(100);

struct Node {
    map<char, int> go;
    int count = 0;
    bool end = false;
};

Node trie[MAXN];
int trie_size = 1;

bool can_go(int v, char c) {
    return trie[v].go.count(c) && trie[v].count;
}
int go(int v, char c) {
    return trie[v].go[c];
}
bool is_end(int v) {
    return trie[v].end;
}
void create_vertice(int v, char c) {
    trie[v].go[c] = trie_size++;
}

void insert(string& s) {
    int v = 0;
    for (auto& c : s) {
        if (!can_go(v, c)) {
            create_vertice(v, c);
        }
        trie[v].count++;
        v = go(v, c);
    }
    trie[v].end = true;
}

void erase(string& s) {
    int v = 0;
    for (auto& c : s) {
        if (!can_go(v, c)) {
            return;
        }
        v = go(v, c);
    }
    trie[v].end = false;
}

bool search(string& s) {
    int v = 0;
    for (auto& c : s) {
        if (!can_go(v, c)) {
            return false;
        }
        v = go(v, c);
    }
    return is_end(v);
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    string s[MAXN];
    int n = nxt(), k = nxt();
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        insert(s[i]);
    }

    sort(s, s + n, [&](auto& a, auto& b) { return a.size() > b.size(); });

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (n - ans <= k) {
            ++ans;
            break;
        }
        int v = 0;
        for (auto& c : s[i]) {
            if (!can_go(v, c) || trie[v].count == 0) {
                break;
            }

            if (trie[v].count <= k) {
                trie[v].count = 0;
                trie[v].end = true;
                ++ans;
                break;
            }
            else {
                trie[v].count -= k;
            }
            v = go(v, c);
        }
    }

    cout << ans << nl;

    return 0;
}

