#include <iostream>
#include <vector>
#include <string>
#include <unordered_map>
using namespace std;

struct Tree {
    char c;
    int count = 0;
    Tree *parent = nullptr;
    Tree *children[26];
};

void print_tree(Tree* tree) {
    cout << tree->c << " " << tree->count << "\n";
    for (int i = 0; i < 26; ++i) {
        if (tree->children[i] != 0) {
            print_tree(tree->children[i]);
        }
    }
}

void append_child(Tree* tree) {
    tree->count++;
    if (tree->parent != 0) {
        append_child(tree->parent);
    }
}

void decrease_child(Tree* tree) {
    Tree* parent = tree->parent;
    if (parent != 0) {
        decrease_child(parent);
        parent->count -= tree->count + 1;
    }
}

int del_count = 0;

int traverse_tree(Tree* tree, int k, int sum) {
    int max = 0, max_idx = -1;
    for (int i = 0; i < 26; ++i) {
        if (tree->children[i] != 0) {
            int count = tree->children[i]->count;
            if (count > max && count <= k) {
                max = count;
                max_idx = i;
            }
        }
    }
    //cout << max_idx << endl;
    if (max_idx != -1) {
        Tree *child = tree->children[max_idx];
        //tree->count -= max + 1;
        decrease_child(child);
        tree->children[max_idx] = 0;
        del_count++;
        sum -= max;
        return max; // sum
    }
    int res = 0;
    for (int i = 0; i < 26; ++i) {
        if (tree->children[i] != 0) {
            int tmp = traverse_tree(tree->children[i], k, sum);
            sum -= tmp;
            res += tmp;
        }
    }
    return res;
}

int tree_first(Tree* tree) {
    int res = 0;
    for (int i = 0; i < 26; ++i) {
        res += (tree->children[i] != 0);
        if (tree->children[i] != 0) {
            //cout << tree->children[i]->c << " ";
        }
    }
    //cout << "\n";
    return res;
}

int main() {
    int n, k;
    cin >> n >> k;

    Tree *root = new Tree();
    root->parent = nullptr;

    for (int i = 0; i < n; ++i) {
        string str;
        cin >> str;
        Tree *tree = root;
        for (int j = 0; j < str.size(); ++j) {
            int c = int(str[j]) - 97;
            if (tree->children[c] == 0) {
                tree->children[c] = new Tree();
                tree->children[c]->parent = tree;
                tree->children[c]->c = str[j];
            }
            tree = tree->children[c];
        }
        append_child(tree);
    }

    //print_tree(root);

    int diff = INT_MAX;
    while (true) {
        //cout << tree_first(root) << endl;
        int diff = traverse_tree(root, k, root->count);
        //cout << tree_first(root) << endl;
        if (tree_first(root) == k) {
            del_count += 1;
            break;
        }
        if (diff == 0) {
            break;
        }
    }
    cout << del_count << "\n";

    //print_tree(root);
    /*
    if (root->count == k) {
        cout << del_count + 1 << "\n";
    }
    else {
        cout << del_count + root->count << "\n";
    }
    */
    return 0;
}