#include <iostream>
#include <string>
#include <map>

using namespace std;

int MaxSumLength = 300500;
const int AlphabetSize = 26;

struct Node {
    map<char, int> go;
    bool isEnd = false;
    int words = 0;
};

Node *t = new Node[300500];
int treeSize = 0;

int createNewTransition(int v, char c) {
    treeSize++;
    t[v].go[c] = treeSize;
    return treeSize;
}

bool canGo(int v, char c) {
    return t[v].go.count(c);
}

int go(int v, char c) {
    return t[v].go[c];
}

bool isEnd(int v) {
    return t[v].isEnd;
}

void truncate(const string &s) {
    int v = 0;
    for (auto c: s) {
        v = go(v, c);
    }
    int words = t[v].words;
    v = 0;
    t[v].words -= words;
    for (auto c: s) {
        v = go(v, c);
        t[v].words -= words;
    }
}

void insert(const string &s) {
    int v = 0;
    t[0].words++;
    for (auto c: s) {
        if (!canGo(v, c)) {
            v = createNewTransition(v, c);
        } else {
            v = go(v, c);
        }
        t[v].words++;
    }
    t[v].isEnd = true;
}


int next_command(const int &v, const int &k, const string &s) {
    char route;
    int max = 0;
    int num = 0;
    bool flag = false;
    for (auto i: t[v].go) {
        if (t[i.second].words > k) {
            num += next_command(i.second, k, s + i.first);
            flag = true;
        }else if (t[i.second].words > max) {
            route = i.first;
            max = t[i.second].words;
        }
    }
    if (!flag) {
        truncate(s + route);
        return 1;
    }
    return num;
}


int main() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        insert(s);
    }
    int num = 0;
    while (t[0].words > k) {
        num += next_command(0, k, "");
    }
    if (t[0].words != 0) {
        num++;
    }
    cout << num;
}
