#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

#define ll long long

using namespace std;

struct node
{
	int cnt, parent, from;
	vector <int> to;
};

vector <node> trie(1);
int n, k;

void add(string& s)
{
	int cur_state = 0;

	for (auto c : s)
	{
		if (trie[cur_state].to[c - 'a'] == -1)
		{
			node new_node;
			new_node.to.resize(26, -1);
			new_node.parent = cur_state;
			new_node.from = c - 'a';
			new_node.cnt = 0;
			trie[cur_state].to[c - 'a'] = trie.size();
			trie.push_back(new_node);
		}

		trie[cur_state].cnt++;
		cur_state = trie[cur_state].to[c - 'a'];
	}

	trie[cur_state].cnt++;
}

set <pair <int, int> > rm;

void DFS(int state)
{
	if (trie[state].parent != -1)
	{
		int par = trie[state].parent;

		trie[par].to[trie[state].from] = -1;
	}

	rm.erase({ trie[state].cnt, state });

	for (auto to : trie[state].to)
		if (to != -1)
			DFS(to);
}

void kill(int state)
{
	int z = trie[state].parent;

	while (z != -1)
	{
		if (rm.find({ trie[z].cnt, z }) != rm.end())
			rm.erase({ trie[z].cnt, z });

		trie[z].cnt -= trie[state].cnt;

		if (trie[z].cnt <= k && trie[z].cnt > 0)
			rm.insert({ trie[z].cnt, z });

		z = trie[z].parent;
	}

	DFS(state);
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	trie[0].to.resize(26, -1);
	trie[0].parent = -1;
	trie[0].cnt = 0;

	cin >> n >> k;

	for (int i = 0; i < n; i++)
	{
		string s;
		cin >> s;

		add(s);
	}

	for (int i = 0; i < trie.size(); i++)
		if (trie[i].cnt <= k)
			rm.insert({ trie[i].cnt, i });

	int ans = 0;

	while (rm.size())
	{
		pair <int, int> z = *(rm.rbegin());
		rm.erase(z);
		kill(z.second);
		ans++;
	}

	cout << ans << endl;
}