#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <queue>
#include <tuple>
#include <exception>
#include <sstream>
#include <iomanip>
#include <memory>
#include <set>
#include <ctime>

int n, m;

char map[400][400];
bool used[400][400];

const char *FMASK[] = {
        "###",
        "#.A",
        "##A",
        "#AA",
        "#AA"
};

const char *QMASK[] = {
        "###",
        "#.#",
        "###",
        "AA#",
        "AA#"
};

bool check_if_mask_at(int i, int j, const char *mask[]) {
    if (i + 5 > n || j + 3 > m) {
        return false;
    }

    for (int di = 0; di < 5; ++di) {
        for (int dj = 0; dj < 3; ++dj) {
            if (used[i + di][j + dj]) {
                return false;
            }

            if (mask[di][dj] == 'A') {
                continue;
            }

            if (mask[di][dj] != map[i + di][j + dj]) {
                return false;
            }
        }
    }

    for (int di = 0; di < 5; ++di) {
        for (int dj = 0; dj < 3; ++dj) {
            if (mask[di][dj] != 'A') {
                used[i + di][j + dj] = true;
            }
        }
    }

    return true;
}

bool is_f_at(int i, int j) {
    return check_if_mask_at(i, j, FMASK);
}

bool is_q_at(int i, int j) {
    return check_if_mask_at(i, j, QMASK);
}

int main() {
    std::ios_base::sync_with_stdio(false);

    std::cin >> n >> m;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            std::cin >> c;
            map[i][j] = c;
        }
    }

    int fcount = 0, qcount = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (used[i][j]) {
                continue;
            }

            if (is_f_at(i, j)) {
                ++fcount;
            } else if (is_q_at(i, j)) {
                ++qcount;
            }
        }
    }

    std::cout << qcount << " " << fcount << std::endl;

    return 0;
}
