#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <queue>
#include <tuple>
#include <exception>
#include <sstream>
#include <iomanip>
#include <memory>
#include <set>
#include <ctime>

int n, m;

char map[400][400];
bool used[400][400] = {false};

const char *FMASK[] = {
        "###",
        "#.A",
        "##A",
        "#AA",
        "#AA"
};

const char *QMASK[] = {
        "###",
        "#.#",
        "###",
        "AA#",
        "AA#"
};

bool check_if_mask_at(int i, int j, const char *mask[]) {
    if (i - 4 < 0 || j - 2 < 0) {
        return false;
    }

    for (int di = 0; di < 5; ++di) {
        for (int dj = 0; dj < 3; ++dj) {
            char cm = mask[4 - di][2 - dj];
            char mm = map[i - di][j - dj];

            if (cm == 'A') {
                continue;
            }

            if (used[i - di][j - dj]) {
                return false;
            }

            if (cm != mm) {
                return false;
            }
        }
    }

    /*
..###
..#.#
..###
###.#
#.#.#
###..
..#..
..#..*/

    /*
###..
#.###
###..
#.##.
#.#..
..#..
     */

    for (int di = 0; di < 5; ++di) {
        for (int dj = 0; dj < 3; ++dj) {
            if (mask[4 - di][2 - dj] != 'A') {
                used[i - di][j - dj] = true;
            }
        }
    }

    return true;
}

bool is_f_at(int i, int j) {
    return check_if_mask_at(i, j, FMASK);
}

bool is_q_at(int i, int j) {
    return check_if_mask_at(i, j, QMASK);
}

int main() {
    std::ios_base::sync_with_stdio(false);

    std::cin >> n >> m;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            char c;
            std::cin >> c;
            map[i][j] = c;
        }
    }

    int fcount = 0, qcount = 0;

    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (is_q_at(i, j)) {
                ++qcount;
            } else if (is_f_at(i, j)) {
                ++fcount;
            }
        }
    }

    std::cout << qcount << " " << fcount << std::endl;

    return 0;
}
