#define _CRT_SECURE_NO_WARNINGS

#pragma comment(linker, "/stack:200000000")
//#pragma GCC optimize("O3","omit-frame-pointer")
//#pragma GCC target("sse","sse2","abm","tune=native")
/*"Ofast","O3",*/
/*"sse3","ssse3","sse4","popcnt",*//*"mmx","avx",*//*,"arch=native"*/
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>
#include <iostream>
#include <time.h>
#include <algorithm>
#include <math.h>
#include <numeric>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <bitset>
#include <string>
#include <cstring>
#include <cassert>
#include <fstream>
#include <map>
#include <unordered_map>
#include <deque>
#include <unordered_set>
#include <iomanip>
#include <chrono>
#include <random>
#include <deque>

using namespace std;

#define sqr(x) ((x)*(x))

typedef long long ll;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int inf = 1'000'000'007;
const ll llinf = 1'000'000'000'000'000'007LL;
const ld eps = 1e-7;
const ld pi = acos(-1.);

const int N_MAX = 1 << 17;

struct edge {
    int from;
    int to;
    int c;
};

vector<edge> g[N_MAX];
vector<edge> sp[N_MAX];
vector<edge> rsp[N_MAX];
ll dst_from[N_MAX];

int min_from_start[N_MAX];
int max_from_start[N_MAX];
int min_to_finish[N_MAX];
int max_to_finish[N_MAX];

int pv_min_from_start[N_MAX];
int pv_max_from_start[N_MAX];
int pv_min_to_finish[N_MAX];
int pv_max_to_finish[N_MAX];

void build_graph(int n, int m) {

    for (int i = 0; i < N_MAX; ++i) {
        dst_from[i] = inf;
    }

    queue<int> q;
    q.push(0);
    dst_from[0] = 0;
    while (q.size()) {
        int current = q.front();
        q.pop();

        for (auto& edg : g[current]) {
            int other = (edg.from == current ? edg.to : edg.from);
            if (dst_from[other] == inf) {
                q.push(other);
                dst_from[other] = dst_from[current] + 1;
            }
        }
    }
    
    vector<int> dst_to(N_MAX, inf);

    q.push(n - 1);
    dst_to[n - 1] = 0;
    while (q.size()) {
        int cur = q.front();
        q.pop();

        for (auto& edg : g[cur]) {
            int other = (edg.from == cur ? edg.to : edg.from);

            if (dst_to[other] == inf) {
                q.push(other);
                dst_to[other] = dst_to[cur] + 1;
            }

            if (dst_to[other] == dst_to[cur] + 1) {
                if (dst_to[other] + dst_from[other] == dst_from[n - 1]) {
                    edge new_e;
                    new_e.from = cur;
                    new_e.to = other;
                    new_e.c = edg.c;

                    rsp[new_e.from].push_back(new_e);
                    swap(new_e.from, new_e.to);
                    sp[new_e.from].push_back(new_e);
                }
            }
        }
    }
}

vector<int> calc_dp(int n) {
    for (int i = 0; i < N_MAX; ++i) {
        min_from_start[i] = min_to_finish[i] = inf;
        max_to_finish[i] = max_from_start[i] = -1;
    }
    
    vector<bool> in_q(N_MAX, false);
    queue<int> q;
    q.push(0);
    while (q.size()) {
        int cur = q.front();
        q.pop();

        for (auto& edg : sp[cur]) {
            if (edg.c < min_from_start[edg.to]) {
                min_from_start[edg.to] = edg.c;
                pv_min_from_start[edg.to] = cur;
            }
            
            if (max_from_start[edg.to] < edg.c) {
                max_from_start[edg.to] = edg.c;
                pv_max_from_start[edg.to] = cur;
            }

            if (!in_q[edg.to]) {
                q.push(edg.to);
                in_q[edg.to] = true;
            }
        }
    }

    for (int i = 0; i < N_MAX; ++i) {
        in_q[i] = false;
    }

    q.push(n - 1);
    while (q.size()) {
        int cur = q.front();
        q.pop();

        for (auto& edg : rsp[cur]) {
            if (edg.c < min_to_finish[edg.to]) {
                min_to_finish[edg.to] = edg.c;
                pv_min_to_finish[edg.to] = cur;
            }

            if (max_to_finish[edg.to] < edg.c) {
                max_to_finish[edg.to] = edg.c;
                pv_max_to_finish[edg.to] = cur;
            }
             
            if (!in_q[edg.to]) {
                q.push(edg.to);
                in_q[edg.to] = true;
            }
        }
    }

    int max_d = -inf;
    int best_node = -1;
    int tp = -1;
    for (int i = 0; i < n; ++i) {
        if (min_from_start[i] != inf && max_to_finish[i] != -1) {
            int d = max_to_finish[i] - min_from_start[i];
            if (max_d < d) {
                max_d = d;
                best_node = i;
                tp = 0;
            }
        }

        if (max_from_start[i] != -1 && min_to_finish[i] != inf) {
            int d = max_from_start[i] - min_to_finish[i];
            if (max_d < d) {
                max_d = d;
                best_node = i;
                tp = 1;
            }
        }
    }

    vector<int> path;
    if (tp == 0) {
        int cur = best_node;
        while (cur != 0) {
            path.push_back(cur);
            cur = pv_min_from_start[cur];
        }
        path.push_back(0);
        reverse(path.begin(), path.end());

        cur = pv_max_to_finish[best_node];
        while (cur != n - 1) {
            path.push_back(cur);
            cur = pv_max_to_finish[cur];
        }

        path.push_back(n - 1);
    } else {

        int cur = best_node;
        while (cur != 0) {
            path.push_back(cur);
            cur = pv_max_from_start[cur];
        }
        path.push_back(0);
        reverse(path.begin(), path.end());

        cur = pv_min_to_finish[best_node];
        while (cur != n - 1) {
            path.push_back(cur);
            cur = pv_min_to_finish[cur];
        }

        path.push_back(n - 1);

    }

    return path;
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        edge e;
        cin >> e.from >> e.to >> e.c;
        e.from--, e.to--;
        g[e.from].push_back(e);
        g[e.to].push_back(e);
    }

    for (auto& edg : g[0]) {
        int other = (edg.from == 0 ? edg.to : edg.from);
        if (other == n - 1) {
            cout << 1 << '\n';
            cout << 1 << ' ' << n;
            return;
        }
    }

    build_graph(n, m);
    auto ans = calc_dp(n);
    cout << ans.size() - 1 << '\n';
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i] + 1 << ' ';
    }
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    srand(time(0));
    cout.precision(10);

    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}