import java.io.*;
import java.util.*;


public class Main {

    static class MyReader {
        BufferedInputStream in;

        final int bufSize = 1 << 16;
        final byte b[] = new byte[bufSize];

        MyReader( InputStream in ) {
            this.in = new BufferedInputStream(in, bufSize);
        }

        int nextInt() throws IOException {
            int c;
            while ((c = nextChar()) <= 32)
                ;
            int x = 0, sign = 1;
            if (c == '-') {
                sign = -1;
                c = nextChar();
            }
            while (c >= '0') {
                x = x * 10 + (c - '0');
                c = nextChar();
            }
            return x * sign;
        }

        StringBuilder _buf = new StringBuilder();
        String nextWord() throws IOException {
            int c;
            _buf.setLength(0);
            while ((c = nextChar()) <= 32 && c != -1)
                ;
            if (c == -1)
                return null;
            while (c > 32) {
                _buf.append((char)c);
                c = nextChar();
            }
            return _buf.toString();
        }

        int bn = bufSize, k = bufSize;

        int nextChar() throws IOException {
            if (bn == k) {
                k = in.read(b, 0, bufSize);
                bn = 0;
            }
            return bn >= k ? -1 : b[bn++];
        }

        int nextNotSpace() throws IOException {
            int ch;
            while ((ch = nextChar()) <= 32 && ch != -1)
                ;
            return ch;
        }
    }

    static class MyWriter {
        BufferedOutputStream out;

        final int bufSize = 1 << 16;
        int n;
        byte b[] = new byte[bufSize];

        MyWriter( OutputStream out ) {
            this.out = new BufferedOutputStream(out, bufSize);
            this.n = 0;
        }

        byte c[] = new byte[20];
        void print( int x ) throws IOException {
            int cn = 0;
            if (n + 20 >= bufSize)
                flush();
            if (x < 0) {
                b[n++] = (byte)('-');
                x = -x;
            }
            while (cn == 0 || x != 0) {
                c[cn++] = (byte)(x % 10 + '0');
                x /= 10;
            }
            while (cn-- > 0)
                b[n++] = c[cn];
        }

        void print( char x ) throws IOException {
            if (n == bufSize)
                flush();
            b[n++] = (byte)x;
        }

        void print( String s ) throws IOException {
            for (int i = 0; i < s.length(); i++)
                print(s.charAt(i));
        }
        void println( String s ) throws IOException {
            print(s);
            println();
        }

        static final String newLine = System.getProperty("line.separator");
        void println() throws IOException {
            print(newLine);
        }

        void flush() throws IOException {
            out.write(b, 0, n);
            n = 0;
        }
        void close() throws IOException {
            flush();
            out.close();
        }
    }

    public static void main(String[] args) throws IOException {
        //Scanner scan = new Scanner(System.in);
        //BufferedReader br = new BufferedReader(new InputStreamReader(System.in));//
        //FastReader Scan = new FastReader();
        MyReader Scan = new MyReader(System.in);
        int N = 8;
        String s1 = Scan.nextWord();
        String s2 = Scan.nextWord();
        String s3 = Scan.nextWord();
        String s4 = Scan.nextWord();

        String[] in1 = {s1, s2};
        String[] in2 = {s3, s4};
        Arrays.sort(in1);
        Arrays.sort(in2);

        int y1 = Integer.parseInt(in1[0]);
        int y2 = Integer.parseInt(in2[0]);
        if (in1[1].equals("BC")){
            y1--;
            y1 *= -1;
        }
        if (in2[1].equals("BC")){
            y2--;
            y2 *= -1;
        }
        int min = Math.min(y1,y2);
        int max = Math.max(y1,y2);
        int res = Math.abs(max - min);
        System.out.println(res);

        MyWriter writer = new MyWriter(System.out);

        writer.close();
    }
}