import java.io.*;
import java.util.*;


public class Main {

    static class MyReader {
        BufferedInputStream in;

        final int bufSize = 1 << 16;
        final byte b[] = new byte[bufSize];

        MyReader( InputStream in ) {
            this.in = new BufferedInputStream(in, bufSize);
        }

        int nextInt() throws IOException {
            int c;
            while ((c = nextChar()) <= 32)
                ;
            int x = 0, sign = 1;
            if (c == '-') {
                sign = -1;
                c = nextChar();
            }
            while (c >= '0') {
                x = x * 10 + (c - '0');
                c = nextChar();
            }
            return x * sign;
        }

        StringBuilder _buf = new StringBuilder();
        String nextWord() throws IOException {
            int c;
            _buf.setLength(0);
            while ((c = nextChar()) <= 32 && c != -1)
                ;
            if (c == -1)
                return null;
            while (c > 32) {
                _buf.append((char)c);
                c = nextChar();
            }
            return _buf.toString();
        }

        int bn = bufSize, k = bufSize;

        int nextChar() throws IOException {
            if (bn == k) {
                k = in.read(b, 0, bufSize);
                bn = 0;
            }
            return bn >= k ? -1 : b[bn++];
        }

        int nextNotSpace() throws IOException {
            int ch;
            while ((ch = nextChar()) <= 32 && ch != -1)
                ;
            return ch;
        }
    }

    static class MyWriter {
        BufferedOutputStream out;

        final int bufSize = 1 << 16;
        int n;
        byte b[] = new byte[bufSize];

        MyWriter( OutputStream out ) {
            this.out = new BufferedOutputStream(out, bufSize);
            this.n = 0;
        }

        byte c[] = new byte[20];
        void print( int x ) throws IOException {
            int cn = 0;
            if (n + 20 >= bufSize)
                flush();
            if (x < 0) {
                b[n++] = (byte)('-');
                x = -x;
            }
            while (cn == 0 || x != 0) {
                c[cn++] = (byte)(x % 10 + '0');
                x /= 10;
            }
            while (cn-- > 0)
                b[n++] = c[cn];
        }

        void print( char x ) throws IOException {
            if (n == bufSize)
                flush();
            b[n++] = (byte)x;
        }

        void print( String s ) throws IOException {
            for (int i = 0; i < s.length(); i++)
                print(s.charAt(i));
        }
        void println( String s ) throws IOException {
            print(s);
            println();
        }

        static final String newLine = System.getProperty("line.separator");
        void println() throws IOException {
            print(newLine);
        }

        void flush() throws IOException {
            out.write(b, 0, n);
            n = 0;
        }
        void close() throws IOException {
            flush();
            out.close();
        }
    }

    public static long gcd(long a, long b) {
        if (b == 0)
            return a;
        else
            return gcd(b, a % b);
    }

    public static void main(String[] args) throws IOException {
        //Scanner scan = new Scanner(System.in);
        //BufferedReader br = new BufferedReader(new InputStreamReader(System.in));//
        //FastReader Scan = new FastReader();
        MyReader Scan = new MyReader(System.in);
        MyWriter writer = new MyWriter(System.out);
        int m = Scan.nextInt();
        while (m-- != 0){
            long n = Scan.nextInt();
            long s = n / 2;
            while(true){
                if(gcd(n, s) == 1){
                    System.out.println(s);
                    break;
                }
                s--;
            }
        }

        writer.close();
    }
}