#include <iostream>
#include <vector>
#include <utility>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <fstream>
#include <stack>

using namespace std;

typedef long long ll;

vector<vector<pair<int, int>>> g;
vector<pair<int, int>> ans;
int n;
int maxlen = INT16_MAX;
ll gmin = 0, gmax = 0;

void dfs(int v, int len, vector<pair<int, int>> &q, set<int> &st, int min, int max) {
    if (v == n - 1) {
        if (maxlen > len) {
            maxlen = len;
            gmin = 0;
            gmax = 0;
        }

        if (maxlen == len) {
            if (max - min >= gmax - gmin) {
                gmax = max;
                gmin = min;
                ans = q;
            }
        }
        return;
    }
    if (len + 1 > maxlen) {
        return;
    }
    for (auto &i: g[v]) {
        if (st.count(i.first) == 0) {
            q.emplace_back(i.first, i.second);
            st.insert(i.first);
            int lmax = max;
            int lmin = min;
            if (i.second > max) {
                lmax = i.second;
            }
            if (i.second < min) {
                lmin = i.second;
            }
            dfs(i.first, len + 1, q, st, lmin, lmax);
            st.erase(i.first);
            q.pop_back();
        }
    }
}

int main() {
    int m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        g.resize(n);
        g[a - 1].emplace_back(b - 1, c);
        g[b - 1].emplace_back(a - 1, c);
    }
    vector<pair<int, int>> q;
    set<int> st;
    st.insert(0);
    dfs(0, 0, q, st, INT16_MAX, INT16_MIN);
    cout << ans.size() << "\n" << 1;
    for (auto &a: ans) {
        cout << " " << a.first + 1;
    }
}