#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <queue>
#include <set>
#include <stack>
#include <deque>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int, int> pii;

#define fr first
#define sc second
#define mpr make_pair
#define pbk push_back

const int N = 2e5 + 4;
const int MOD = 1e9 + 7;
const ll INF = 1e18 + 7;
const double PI = acos(-1);

struct Path
{
	vector <int> path;
	int mn, mx;
	Path(vector <int> v, int a, int b) {
		path = v;
		mn = a;
		mx = b;
	}
};

int n;
vector <pii> g[N];

vector <int> bfs(int s)
{
	queue <Path> q;
	q.push(Path({ s }, MOD, -1));
	vector <int> dist(n, MOD);
	dist[s] = 0;
	Path ans({ s }, 0, -1);
	while (!q.empty()) {
		Path p = q.front();
		q.pop();
		int v = p.path.back();
		if (v == n - 1) break;
		for (int i = 0; i < g[v].size(); ++i) {
			int to = g[v][i].fr;
			if (p.path.size() <= dist[to]) {
				dist[to] = p.path.size();
				Path newpath = p;
				newpath.path.pbk(to);
				newpath.mn = min(p.mn, g[v][i].sc);
				newpath.mx = max(p.mx, g[v][i].sc);
				if (to == n - 1 && newpath.mx - newpath.mn > ans.mx - ans.mn)
					ans = newpath;
				q.push(newpath);
			}
		}
	}
	return ans.path;
}

void solve()
{
	int m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int v, u, c;
		cin >> v >> u >> c;
		--v; --u;
		g[v].pbk(mpr(u, c));
		g[u].pbk(mpr(v, c));
	}
	vector <int> ans = bfs(0);
	cout << ans.size() - 1 << endl;
	for (int i = 0; i < ans.size(); ++i)
		cout << ans[i] + 1 << ' ';
	cout << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	//	cout.setf(ios::fixed);
	//	cout.setf(ios::showpoint);
	//	cout.precision(6);

	int t = 1;
	//	cin >> t;

	while (t--)
		solve();

	return 0;
}