#pragma comment(linker, "/STACK:534217728")
//#pragma GCC optimize("fast-maths")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("no-stack-protector")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,fma,tune=native")
#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <bitset>
#include <stack>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <climits>
#include <ctime>
#include <random>
using namespace std;

#define forx(name, from, to, value) for (int name = from; name < to; name += value)
#define rforx(name, from, to, value) for (int name = from; name > to; name -= value)
#define all(_STL_NAME) _STL_NAME.begin(), _STL_NAME.end()
#define rall(_STL_NAME) _STL_NAME.rbegin(), _STL_NAME.rend()
#define mp(_FIRST,_SECOND) make_pair(_FIRST,_SECOND)

typedef long long ll;
typedef unsigned long long llu;
typedef long double ld;
const ld eps = 1e-6;
mt19937 rndm;

void start() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.precision(5); cout.setf(ios::fixed);
	string FILENAME = "n3v3r_g0|\|na_g1v3_u_up";
	rndm.seed(time(0));
#ifdef _DEBUG
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	//freopen((FILENAME + ".in").c_str(), "rt", stdin);
	//freopen((FILENAME + ".out").c_str(), "wt", stdout);
#endif
}

inline int FastIn() {
	int val = 0;
	char c = ' ';
	bool mns = false;
	while (!isdigit(c)) {
		mns = c == '-';
		c = _getchar_nolock(); // getchar_unlocked() in Clang
	}
	while (isdigit(c)) {
		val *= 10;
		val += c - '0';
		c = _getchar_nolock();
	}
	return (mns ? -val : val);
}

inline void FastOut(int val) {
	if (val < 0) {
		_putchar_nolock('-');
		val = -val;
	}
	bool fst = true;
	const int degree = 1000000000;
	//const ll degree = 10000000000000000ll;
	for (int i = degree; i > 0; i /= 10) {
		int dl = val / i;
		if (dl || !fst) {
			_putchar_nolock('0' + dl); // putchar_unlocked() in Clang
			fst = false;
		}
		val %= i;
	}
	if (fst)
		_putchar_nolock('0');
}

int n, k;

struct trie {
	int su;
	trie* next[26];
	int clear;

	trie() {
		su = 0;
		for (int i = 0; i < 26; i++)
			next[i] = nullptr;
	}
} *root = new trie();

trie* add_str(string& s) {
	trie* cur = root;
	for (int i = 0; i < s.size(); ++i) {
		if (cur->next[s[i] - 'a'] == nullptr)
			cur->next[s[i] - 'a'] = new trie();
		cur = cur->next[s[i] - 'a'];
	}
	cur->su++;
	return cur;
}

void dfs(trie *r) {
	for (int i = 0; i < 26; ++i)
		if (r->next[i] != nullptr) {
			dfs(r->next[i]);
			r->su += r->next[i]->su;
		}
}

int ans = 0;

int calc(trie *r) {
	priority_queue<pair<int, trie*>> f;
	int ssu = r->su;
	for (int i = 0; i < 26; ++i) {
		if (r->next[i] != nullptr)
			f.push(mp(r->next[i]->su, r->next[i]));
	}
	while (!f.empty() && f.top().first >= k) {
		int bef = f.top().first;
		int aft = calc(f.top().second);
		f.push(mp(aft, f.top().second));
		f.pop();
		ssu -= (bef - aft);
	}
	while (ssu > k) {
		int bef = f.top().first;
		f.pop();
		ssu -= bef;
		ans++;
	}
	if (ssu == k) ans++, ssu = 0;
	return ssu;
}

int main() {
	start();
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		add_str(s);
	}
	dfs(root);
	if (calc(root))
		ans++;
	cout << ans;
#ifdef _DEBUG
	cout << "\nTime: " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}