import java.awt.image.AreaAveragingScaleFilter;
import java.io.*;
import java.sql.SQLOutput;
import java.util.*;

public class Main {
    static FastReader sc;
    static PrintWriter pw;

    //final static long M = 1000000007;

    public static void main(String[] args) throws Exception{
        sc = new FastReader();
        pw = new PrintWriter(System.out);

        //StringBuilder sb = new StringBuilder("");

        try{
            final int n = sc.nextInt() + 5, m = sc.nextInt() + 5;
            int qCount = 0, pCount = 0;
            final String[] inpField = new String[n];
            final char[][] board = new char[n][m];

            for (int i = 0; i < n-5; i++){
                inpField[i] = sc.nextLine();
            }

            for(int i = 0; i < n-5; i++){
                for (int j = 0; j < m-5; j++){
                    board[i][j] = inpField[i].charAt(j);
                }
            }

            for (int i = 0; i < n-5; i++){
                for(int j = 0; j < m-5; j++){
                    if((board[i][j] == '#') && (board[i][j+1] == '#') && (board[i][j+2] == '#') &&
                            (board[i+1][j] == '#' && (board[i+2][j] == '#') && (board[i+2][j+1] == '#') &&
                                    board[i+3][j] == '#') && (board[i+4][j] == '#'))
                        pCount++;
                    else if((board[i][j] == '#') && (board[i][j+1] == '#') && (board[i][j+2] == '#') &&
                            (board[i+1][j] == '#') && (board[i+1][j+2] == '#') && (board[i+2][j] == '#') &&
                            (board[i+2][j+1] == '#') && (board[i+2][j+2] == '#') && (board[i+3][j+2] == '#') &&
                            (board[i+4][j+2] == '#'))
                        qCount++;
                }
            }

            pw.println(qCount + " " + pCount);

            //long endTime = System.nanoTime();
            //pw.println((endTime - startTime) / 1000000);

            }catch(Exception e){
                e.printStackTrace();
        }

        pw.close();
    }

    static class FastReader {
        BufferedReader br;
        StringTokenizer st;

        public FastReader(){
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        String next(){
            while (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(br.readLine());
                }
                catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        double nextDouble(){
            return Double.parseDouble(next());
        }

        long nextLong() { return Long.parseLong(next()); }

        int[] getArray(int n) {
            int[] arr = new int[n + 1];
            for (int i = 1; i <= n; i++)
                arr[i] = nextInt();
            return arr;
        }

        long[] getLongArray(int n) {
            long[] arr = new long[n];
            for (int i = 0; i < n; i++)
                arr[i] = nextLong();
            return arr;
        }

        String nextLine() {
            String str = "";
            try {
                str = br.readLine();
            }
            catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }

    }

}