/*
 _    _    _______   _    _
| |  / /  |  _____| | |  / /
| | / /   | |       | | / /
| |/ /    | |_____  | |/ /
| |\ \    |  _____| | |\ \
| | \ \   | |       | | \ \
| |  \ \  | |_____  | |  \ \
|_|   \_\ |_______| |_|   \_\

*/
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <vector>
#include <cstring>
#include <string>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <assert.h>

using namespace std;

typedef unsigned long long ull;
typedef long long ll;
typedef double ld;
typedef pair <int, int> PII;
typedef pair <ll, ll> PLL;

#define right first
#define left second
#define pb push_back
#define eb emplace_back
#define forn(x, a, b) for (int x = a; x <= b; ++x)
#define for1(x, a, b) for (int x = a; x >= b; --x)
#define mkp make_pair
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define y1 kekekek

const ll ool = 1e18 + 9;
const int oo = 1e9 + 9, base = 1e9 + 7;
const ld eps = 1e-7;
const int N = 5e5 + 6;


int n, m;
vector < int > ins[N], del[N];

bool is_valid(PII seg) {
    return (seg.right >= seg.left);
}

void solve() {
    cin >> n >> m;

    vector < int > vec;
    set < int > all;
    map < int, int > suff, pref;

    forn(i, 1, n) {
        int x;
        cin >> x;
        
        int day = x / m;
        all.insert(day);
        all.insert(day + 1);

        if (!pref.count(day)) pref[day] = (day + 1) * m - x;
        suff[day + 1] = (day + 1) * m - x;

        vec.eb((day + 1) * m - x);
    }

    vec.eb(0);
    vec.eb(m - 1);
    sort(all(vec));
    vec.erase(unique(all(vec)), vec.end());

    for (int x : all) {
        if (pref.count(x) && suff.count(x) && pref[x] >= suff[x]) {
            ins[0].eb(x);
            continue;
        }
        if (pref.count(x)) {
            int pos = lower_bound(all(vec), pref[x]) - vec.begin();
            ins[0].eb(x);
            del[pos].eb(x);
        }
        if (suff.count(x)) {
            int pos = lower_bound(all(vec), suff[x]) - vec.begin();
            ins[pos].eb(x);
        }
    }

    set < PII > st;
    int ans = 0, ansi = 0;

    forn(i, 0, sz(vec) - 1) {
        for (int x : del[i]) {
            auto it = st.lower_bound(PII(x, -oo));
            PII seg1 = {x - 1, it -> left};
            PII seg2 = {it -> right, x + 1};

            st.erase(it);

            if (is_valid(seg1)) st.insert(seg1);
            if (is_valid(seg2)) st.insert(seg2);
        }

        for (int x : ins[i]) {
            PII seg = {x, x};
            
            auto it = st.lower_bound(PII(x, -oo));
            if (it != st.end() && seg.right == it -> left - 1) {
                seg.right = it -> right;
                st.erase(it);
            }

            it = st.lower_bound(PII(x, -oo));
            if (sz(st)) --it;
            if (it != st.end() && seg.left == it -> right + 1) {
                seg.left = it -> left;
                st.erase(it);
            }

            if (seg.right - seg.left + 1 > ans) {
                ans = seg.right - seg.left + 1;
                ansi = vec[i];
            }
            st.insert(seg);
        }

        del[i].clear();
        ins[i].clear();
    }

    cout << ans << " " << ansi << endl;
}


int main() {
	ios_base :: sync_with_stdio(0), cin.tie(0), cout.tie(0);

    // freopen("input.txt", "r", stdin);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }    
    
	return 0;
}
