#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <map>
#include <set>

using namespace std;

const int N = int(1e5) + 7;

vector < pair < int, int > > g[N];
set < pair < int, pair < int, pair < int, int > > > > q; // {val, {dist, {min, max}}}
map < int, bool > used;
map < int, pair < int, pair < int, int > > > ans;
map < int, int > pr;

int main() {
    int n, m;
    cin >> n >> m;
    for (int i = 1, x, y, c; i <= m; i++) {
        cin >> x >> y >> c;
        g[x].emplace_back(y, c);
        g[y].emplace_back(x, c);
    }
//    for(int i = 1; i <= n; i++){
//        for(auto j : g[i]){
//            cout << j.first << ' ' << j.second << '\n';
//        }
//        cout << '\n';
//    }

    for (int i = 1; i <= n; i++) {
        ans[i] = {INT_MAX, {INT_MAX, INT_MIN}}; // {dist, {min, max}}
    }

    q.insert({1, {0, {INT_MAX, INT_MIN}}});
    ans[1] = {0, {INT_MAX, INT_MIN}};
    used[1] = true;
    pr[1] = -1;

    while (!q.empty()) {
        int v = q.begin()->first;
        q.erase(q.begin());
        for (auto i: g[v]) {
            int to = i.first;
            int color = i.second;
            if (ans[to].first > ans[v].first + 1) {
                q.erase({to, ans[to]});
                ans[to] = {ans[v].first + 1, {min(color, ans[v].second.first), max(color, ans[v].second.second)}};
                q.insert({to, ans[to]});
                pr[to] = v;
            } else if (ans[to].first == ans[v].first + 1) {
                int mn = min(ans[v].second.first, color);
                int mx = max(ans[v].second.second, color);
                if (mx - mn > ans[to].second.second - ans[to].second.first) {
                    q.erase({to, ans[to]});
                    ans[to] = {ans[v].first + 1, {mn, mx}};
                    q.insert({to, ans[to]});
                    pr[to] = v;
                }
            }
        }
    }

    vector < int > res;
    res.clear();
    int v = n;
    while(true){
        if(v == -1){
            break;
        }
//        cout << v << ' ';
        res.push_back(v);
        v = pr[v];
    }
    reverse(res.begin(), res.end());
    cout << int(res.size()) - 1 << '\n';
    for(auto i : res){
        cout << i << ' ';
    }

//    for (int i = 1; i <= n; i++) {
//        cout << i << " : " << ans[i].first << ' ' << ans[i].second.first << ' ' << ans[i].second.second << '\n';
//    }

//    while(!q.empty()){
//        int v = q.front();
//        q.pop();
//        for(auto i : g[v]){
//            int to = i.first;
//            int color = i.second;
//            if(used[to]){
//                continue;
//            }
//            int mn = min(ans[v].second.first, color);
//            int mx = max(ans[v].second.second, color);
//            ans[to] = {ans[v].first + 1, {mn, mx}};
//            q.push(to);
//            used[to] = true;
//        }
//    }
}