#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 5;
const int M = 1e5 + 5;
const long long INF = 1e9 + 5;
const int base = 317;

typedef long long ll;

const ll mod = 1e9 + 7;

double pi = acos(-1);
const int tx[] = {0, 1, 0, -1}, ty[] = {1, 0, -1, 0};

int n, k, ans;
string s;

struct node {
    int to[26];
    int cnt;
    node() {
        memset(to, 0, sizeof(to));
        cnt = 0;
    }
};

vector<int> dp;
vector<node> trie;

void add(string s) {
    if (trie.size() == 0)
        trie.push_back(node());
    int cur = 0;
    for (int i = 0; i < s.size(); i++) {
        int ch = s[i] - 'a';
        if (trie[cur].to[ch] == 0) {
            trie[cur].to[ch] = trie.size();
            trie.push_back(node());
        }
        trie[cur].cnt++;
        cur = trie[cur].to[ch];
    }
    trie[cur].cnt++;
}

pair<int, int> dfs(int v) {
    if (trie[v].cnt <= k) {
        return {trie[v].cnt, 0};
    }
    int res1 = 0, res2 = 0;
    int cnt1 = 0, cnt2 = 0;
    pair<int, int> ans1, ans2;
    vector<pair<int, int>> vec1, vec2;
    for (int i = 0; i < 26; i++) {
        if (trie[v].to[i]) {
            if (trie[v].cnt - trie[trie[v].to[i]].cnt - k >= 0) {
                vec1.push_back({trie[trie[v].to[i]].cnt, trie[v].to[i]});
            }
            else
                vec2.push_back({trie[trie[v].to[i]].cnt, trie[v].to[i]});
        }
    }
    sort(vec1.begin(), vec1.end());
    reverse(vec1.begin(), vec1.end());
    sort(vec2.begin(), vec2.end());
    for (auto it : vec1) {
        auto go = dfs(it.second);
//        cout << it.second << " " << dp[it.second] << "\n";
        res1 += go.second;
        cnt1 += dp[it.second];
        if (trie[v].cnt - res1 <= k) {
            ans1 = {trie[v].cnt, res1};
            break;
        } else if (go.first != go.second) {
            cnt1++;
            res1 += go.first - go.second;
        }
        if (trie[v].cnt - res1 <= k) {
            ans1 = {trie[v].cnt, res1};
            break;
        }
    }
    for (auto it : vec2) {
        auto go = dfs(it.second);
//        cout << it.second << " " << dp[it.second] << "\n";
        res2 += go.second;
        cnt2 += dp[it.second];
        if (trie[v].cnt - res2 <= k) {
            ans2 = {trie[v].cnt, res2};
            break;
        } else if (go.first != go.second) {
            cnt2++;
            res2 += go.first - go.second;
        }
        if (trie[v].cnt - res2 <= k) {
            ans2 = {trie[v].cnt, res2};
            break;
        }
    }
    if (cnt1 == 0) {
        dp[v] = cnt2;
        return ans2;
    }
    if (cnt2 == 0) {
        dp[v] = cnt1;
        return ans1;
    }
    if (cnt1 < cnt2 && ans1.first == trie[v].cnt) {
        dp[v] = cnt1;
        return ans1;
    }
//    cout << v << " ";
    dp[v] = cnt2;
    return ans2;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 1; i <= n; i++) {
        cin >> s;
        add(s);
    }
    dp.resize(trie.size());
    if (dfs(0).second != n)
        dp[0]++;
    cout << dp[0];
}
