#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template <typename T>
int sz(T &x) {
  return (int)(x.size());
}

int power(int x, int y, int mod) {
  if (y == 0) {
    return 1;
  }
  int z = power(x, y >> 1, mod);
  z = z * 1ll * z % mod;
  if (y & 1) {
    z = z * 1ll * x % mod;
  }
  return z;
}

const int mod = 998244353;
const int inf = 1000000007;



void solve() {
  int n, m;
  cin >> n >> m;

  vector<int> a(n);
  map<int, int> mn, mx;
  set<int> check;

  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    int block = a[i] / m;
    check.insert(block);
    check.insert(block + 1);
    if (!mn.count(block)) {
      mn[block] = a[i] % m;
      mx[block] = a[i] % m;
    } else {
      mn[block] = min(mn[block], a[i] % m);
      mx[block] = max(mx[block], a[i] % m);
    }
  }

  vector<pair<int, pair<pii, pii> > > blocks;
  for (int i : check) {
    pii A = make_pair(-2, -2);
    if (mn.count(i)) {
      A = make_pair(0, m - mn[i] - 1);
    }

    pii B = make_pair(-1, -1);
    if (mx.count(i - 1)) {
      B = make_pair(m - mx[i - 1], m - 1);
    }
    blocks.push_back(make_pair(i, make_pair(A, B)));
  }



  auto intersections2 = [](pii a, pii b) {
    return make_pair(max(a.first, b.first), min(a.second, b.second));
  };

  auto bintersections2 = [](pii a, pii b) {
    return max(a.first, b.first) <= min(a.second, b.second);
  };

  auto intersections4 = [&](pair<pii, pii> a, pair<pii, pii> b) {
    vector<pii> f;
    if (bintersections2(a.first, b.first)) {
      f.push_back(intersections2(a.first, b.first));
    }
    if (bintersections2(a.first, b.second)) {
      f.push_back(intersections2(a.first, b.second));
    }
    if (bintersections2(a.second, b.first)) {
      f.push_back(intersections2(a.second, b.first));
    }
    if (bintersections2(a.second, b.second)) {
      f.push_back(intersections2(a.second, b.second));
    }
    if (sz(f) == 0) {
      f.push_back(make_pair(-1, -1));
      f.push_back(make_pair(-2, -2));
    } else if (sz(f) == 1) {
      if (f[0] == make_pair(-1, -1)) {
        f.push_back(make_pair(-2, -2));
      } else {
        f.push_back(make_pair(-1, -1));
      }
    }
    assert(sz(f) <= 2);
    return make_pair(f[0], f[1]);
  };

  auto solve = [&](vector<pair<pii, pii> > vals) {

    int k = sz(vals);
    vector<vector<pair<pii, pii> > > in(k);
    vector<int> lg2(k + 2);
    for (int i = 2; i <= k; ++i) {
      lg2[i] = lg2[i / 2] + 1;
    }

    for (int i = 0; i < k; ++i) {
      in[i].resize(20);
      in[i][0] = vals[i];
    }
    for (int j = 1; j < 20; ++j) {
      for (int i = 0; i + (1 << j) - 1 < k; ++i) {
        in[i][j] = intersections4(in[i][j - 1], in[i + (1 << (j - 1))][j - 1]);
      }
    }

    auto get_range = [&](int l, int r) {
      int z = lg2[r - l + 1];
      return intersections4(in[l][z], in[r - (1 << z) + 1][z]);
    };

    pair<int, int> ans = make_pair(-1, -1);
    for (int i = 0; i < k; ++i) {
      pair<pii, pii> z;
      for (int j = i; j < k; ++j) {
        z = (j == i ? vals[j] : intersections4(vals[j], z));
        if ((max(z.first.second, z.second.second) >= 0) && j - i + 1 > ans.first) {
          ans = make_pair(j - i + 1, max(z.first.second, z.second.second));
        }
      }
      continue;
      int lf = i, rg = k - 1;
      int R = i;
      while (lf <= rg) {
        int mid = (lf + rg) >> 1;
        pair<pii, pii> F = get_range(i, mid);
        if (F.first.second >= 0 || F.second.second >= 0) {
          R = max(R, mid);
          lf = mid + 1;
        } else {
          rg = mid - 1;
        }
      }
      if (R - i + 1 > ans.first) {
        ans.first = R - i + 1;
        pair<pii, pii> F = get_range(i, R);
        if (F.first.second >= 0) {
          ans.second = F.first.second;
        } else {
          ans.second = F.second.second;
        }
      }
    }
    return ans;

  };

  pii ans = make_pair(-1, -1);

  for (int i = 0; i < sz(blocks); ) {
    int j = i;
    while (j + 1 < sz(blocks) && blocks[j].first == blocks[j + 1].first - 1) {
      ++j;
    }
    vector<pair<pii, pii> > ff;
    for (int k = i; k <= j; ++k) {
      ff.push_back(blocks[k].second);
    }
    pii z = solve(ff);
    if (ans.first < z.first) {
      ans = z;
    }
    i = j + 1;
  }
  cout << ans.first << " " << ans.second << "\n";
}

int main() {
  #ifndef LOCAL58
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
  #endif

  int t = 1;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
