#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

template <typename T>
int sz(T &x) {
  return (int)(x.size());
}

int power(int x, int y, int mod) {
  if (y == 0) {
    return 1;
  }
  int z = power(x, y >> 1, mod);
  z = z * 1ll * z % mod;
  if (y & 1) {
    z = z * 1ll * x % mod;
  }
  return z;
}

const int mod = 998244353;
const int inf = 1000000007;

int n, m;
vector<vector<pii> > g;
vector<int> cur;

vector<int> get_path(int x, int y) {
  queue<int> q;
  vector<int> d(n + 1, -1), p(n + 1, -1);
  d[x] = 0;
  q.push(x);
  while (!q.empty()) {
    int v = q.front();
    q.pop();
    for (pii i : g[v]) {
      if (d[i.first] == -1) {
        d[i.first] = d[v] + 1;
        p[i.first] = v;
        q.push(i.first);
      }
    }
  }
  vector<int> ans;
  while (true) {
    ans.push_back(y);
    if (y == x) {
      break;
    }
    y = p[y];
  }
  reverse(ans.begin(), ans.end());
  return ans;
}

void solve() {
  cin >> n >> m;

  g.resize(n + 1);
  for (int i = 1; i <= m; ++i) {
    int x, y, c;
    cin >> x >> y >> c;
    g[x].push_back(make_pair(y, c));
    g[y].push_back(make_pair(x, c));
  }

  queue<int> q;
  q.push(1);
  vector<int> d(n + 1, -1);
  d[1] = 0;
  while (!q.empty()) {
    int v = q.front();
    q.pop();
    for (pii i : g[v]) {
      if (d[i.first] == -1) {
        d[i.first] = d[v] + 1;
        q.push(i.first);
      }
    }
  }

  vector<int> d2(n + 1, -1);
  d2[n] = 0;
  q.push(n);
  while (!q.empty()) {
    int v = q.front();
    q.pop();
    for (pii i : g[v]) {
      if (d2[i.first] == -1) {
        d2[i.first] = d2[v] + 1;
        q.push(i.first);
      }
    }
  }

  vector<int> id;
  for (int i = 1; i <= n; ++i) {
    id.push_back(i);
  }
  sort(id.begin(), id.end(), [&](int x, int y) {
    return d[x] < d[y];
  });

  vector<pair<int, pii> > mn(n + 1, make_pair(inf, make_pair(inf, inf))), mx(n + 1, make_pair(-inf, make_pair(inf, inf)));
  for (int i : id) {
    if (d[i] + d2[i] != d[n]) {
      continue;
    }
    for (pii j : g[i]) {
      if (d[i] + 1 != d[j.first] || d[j.first] + d2[j.first] != d[n]) {
        continue;
      }
      if (mn[j.first].first > mn[i].first) {
        mn[j.first] = mn[i];
      }
      if (mn[j.first].first > j.second) {
        mn[j.first] = make_pair(j.second, make_pair(i, j.first));
      }
      if (mx[j.first].first < mx[i].first) {
        mx[j.first] = mx[i];
      }
      if (mx[j.first].first < j.second) {
        mx[j.first] = make_pair(j.second, make_pair(i, j.first));
      }
    }
  }
  int ans = -1;
  pair<pii, pii> ansp;
  for (int i = 1; i <= n; ++i) {
    if (d[i] + d2[i] != d[n]) {
      continue;
    }
    for (pii j : g[i]) {
      if (d[i] + 1 != d[j.first] || d[j.first] + d2[j.first] != d[n]) {
        continue;
      }
      if (j.second - mn[i].first > ans) {
        ans = j.second - mn[i].first;
        ansp = make_pair(mn[i].second, make_pair(i, j.first));
      }
      if (mx[i].first - j.second > ans) {
        ans = mx[i].first - j.second;
        ansp = make_pair(mx[i].second, make_pair(i, j.first));
      }
    }
  }

  vector<int> res;
  vector<int> temp = get_path(1, ansp.first.first);
  temp.push_back(ansp.first.second);
  for (int i : temp) {
    if (res.empty() || res.back() != i) {
      res.push_back(i);
    }
  }
  temp = get_path(ansp.first.second, ansp.second.first);
  temp.push_back(ansp.second.second);
  for (int i : temp) {
    if (res.empty() || res.back() != i) {
      res.push_back(i);
    }
  }
  temp = get_path(ansp.second.second, n);
  for (int i : temp) {
    if (res.empty() || res.back() != i) {
      res.push_back(i);
    }
  }
  cout << sz(res) - 1 << "\n";
  for (int i : res) {
    cout << i << " ";
  }
  cout << "\n";



}

int main() {
  #ifndef LOCAL58
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
  #endif

  int t = 1;
  //cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}
