#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

#define ll long long
#define EEE (ll)1e16
#define pll pair<ll,ll>
#define f first
#define s second
#define For(i, n) for (ll i = 0; i < n; i++)

using namespace std;

string ar[3*(ll)1e5 + 10];

struct Node{
  ll n;
  vector<Node*> p;
  Node* prev;
};

Node* up(Node* n, ll num){
  For(i, num) {n = n->prev;}
  return n;
}

void inc(Node* n, ll num){
  For(i, num) {
    n->n++;
    n = n->prev;
  }
}

void dec(Node* n, ll x){
  if (n->p.size() > x){
    n->p.resize(n->p.size() - x);
  }
  else while(n->prev != nullptr){
    n->n -= x;
    n = n->prev;
  }
}

Node* push(Node* n, ll num){
  Node* tmp;
  For(i, num){
    tmp = new Node;
    *tmp = {1, {}, n};
    n->p.push_back(tmp);
    n = tmp;
  }
  return n;
}

bool comp(const string& l, const string& r){
  for (ll i = 0; i < min(l.size(), r.size()); i++){
    if (l[i] < r[i]) return true;
    if (l[i] > r[i]) return false;
  }
  return l.size() > r.size();
}

ll same(const string& l, const string& r){
  ll res = 0;
  for (ll i = 0; i < min(l.size(), r.size()); i++){
    if (l[i] == r[i]) {
      res++;
      break;
    }
  }
  return res;
}

pair<Node*, ll> choose(Node* n, ll k){
  if (n->p.size() == 0) return {n, n->n};
  pair<Node*, ll> res = {n, EEE}, tmp;
  for (Node* i : n->p){
    tmp = choose(i, k);
    if (res.s == EEE || (tmp.s <= k && res.s < tmp.s)) 
      res = tmp;
  }
  return res;
}

int main(){
  ll n, m;
  cin >> n >> m;
  for (ll i = 0; i < n; i++) cin >> ar[i];
  sort(ar, ar+n, comp);
  Node tree{1, {}, nullptr};
  Node* cur = push(&tree, ar[0].size());
  for(ll i = 1, tmp; i < n; i++){
    tmp = same(ar[i-1], ar[i]);
    inc(cur, ar[i-1].size() - tmp);
    cur = up(cur, ar[i-1].size() - tmp);
    cur = push(cur, ar[i].size() - tmp);
  }
  ll res = 0;
  pair<Node*, ll> tmp;
  while(n > 0){
    res++;
    tmp = choose(&tree, m);
    dec(&tree, tmp.s);
    n -= tmp.s;
  }
  cout << res;
  return 0;
}