#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <cassert>
#include <queue>
#include <bitset>
#include <numeric>
#include <cstdlib>
#include <iostream>     // std::cout
#include <algorithm>    // std::random_shuffle
#include <vector>       // std::vector
#include <ctime>        // std::time
#include <cstdlib>
#include <iomanip>
#include <sstream>

#define mp make_pair

using namespace std;

const int N = (int) 1e6 + 123;
const int MOD = (int) 1e9 + 7;

struct Node {
    int parent;
    int cnt;
    int next[26];
    bool is_end;
    Node () {
        parent = 0;
        cnt = 0;
        for (int i = 0; i < 26; i++) {
            next[i] = 0;
        }
        is_end = 0;
    }
};

Node t[N];
int root = 1;
int sz = 1;
int n, k;

void add(string s) {
    int v = root;
    t[v].cnt++;
    for (auto ch : s) {
        int edge = ch - 'a';
        if (!t[v].next[edge]) {
            t[v].next[edge] = ++sz;
            t[sz] = Node();
            t[sz].parent = v;
        }
        v = t[v].next[edge];
        t[v].cnt++;
    }
    t[v].is_end = 1;
}

int dp[N];
int cntLeft[N];

void dfs(int v) {
    vector<pair<int, int>> sub;

    if (t[v].cnt <= k) {
        dp[v] = 1;
        cntLeft[v] = t[v].cnt;
        return;
    }

    if (t[v].is_end)
        sub.push_back(make_pair(1, 1));

    for (int edge = 0; edge < 26; edge++) {
        int to = t[v].next[edge];
        if (to) {
            dfs(to);
            sub.push_back(make_pair(cntLeft[to], dp[to]));
        }
    }
    sort(sub.begin(), sub.end());

    for (auto it : sub) {
        dp[v] += it.second;
    }

    int ps = 0;
    int mx = 0;
    for (int i = 0; i < sub.size(); i++) {
        ps += sub[i].first;
        if (ps <= k) {
            dp[v]--;
            cntLeft[v] = ps;
        }
    }
    dp[v]++;
    //cout << v << ' ' << dp[v] << ' ' << cntLeft[v] << endl;
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);

    cin >> n >> k;

    while (n--) {
        string s;
        cin >> s;
        add(s);
    }

    dfs(root);
    cout << dp[root];

    return 0;
}